#!/bin/bash
# Generate individual HTML error files for each SignStream validation error code possible.
# Source document is errors.csv, itself a scaled down version of errors.xlsx.
# Both should be found in the SignSream3 repo, currently under /scripts

INPUT_FILE="errors.csv"

mkdir -p codes

while read line; do

ERROR_CODE=`echo $line | awk -F "," '{print $1}'`
DESCRIPTION=`echo $line | awk -F "," '{print $2}'`
SOLUTION=`echo $line | awk -F "," '{print $3}'`

cat > codes/"$ERROR_CODE".html << EOF
<html>
  <head>
    <title>SignStream Error Code $ERROR_CODE</title>
  </head>
  <body>
    <h1><u>SignStream Error Code: $ERROR_CODE</u></h1><br>
    <h1><u>Description</u></h1>
    <h2>$DESCRIPTION</h2>
    <h1><u>Solution</u></h1>
    <h2>$SOLUTION</h2>
  </body>
</html>
EOF

done < $INPUT_FILE

