package edu.bu.signstream.common.tree;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;

public interface Transferable extends java.awt.datatransfer.Transferable {
    @Override
    default DataFlavor[] getTransferDataFlavors() {
        String mime = DataFlavor.javaJVMLocalObjectMimeType +
            String.format(";class=\"%s\"", clazz().getName());

        var flavors = new DataFlavor[1];
        try {
            flavors[0] = new DataFlavor(mime);
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }

        return flavors;
    }

    @Override
    default boolean isDataFlavorSupported(DataFlavor flavor) {
        return flavor.equals(getTransferDataFlavors()[0]);
    }

    @Override
    default Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException {
        if (!flavor.equals(getTransferDataFlavors()[0]))
            throw new UnsupportedFlavorException(flavor);

        return this;
    }

    Class<? extends Transferable> clazz();
}
