package edu.bu.signstream.common.util;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;

public final class SingletonTimeLog {

	HashMap<String, TimeLogValue>  map = new HashMap<String, TimeLogValue>();
	private static SingletonTimeLog log = null;

	public static SingletonTimeLog getSingletonTimeLog() {
		if (log == null) {
			log = new SingletonTimeLog();
			return log;
		} else {
			return log;
		}
	}

	public void setMap(HashMap<String, TimeLogValue> map) {
		this.map = map;
	}

	public void resetTotal(String name) {
		var curr = map.get(name);
		if (curr == null) {
			return;
		} else {
			curr.setTotal(0);

			curr.setCount(0);
		}
	}

	public void setStart(String name) {
		var curr = map.get(name);
		if (curr == null) {
			map.put(name, new TimeLogValue(System.nanoTime()));
		} else {
			curr.setStart(System.nanoTime());
		}
	}

	public void setStop(String name) {
		var curr = map.get(name);
		if (curr == null) {
			return;
		} else {
			long start = curr.getStart();
			long total = curr.getTotal();

			long now = System.nanoTime();
			long diff = now - start;
			long newTotal = diff + total;

			curr.setTotal(newTotal);

			int count = curr.getCount();
			curr.setCount(++count);
		}
	}

	public long getTotal(String name) {
		var curr = map.get(name);
		if (curr == null) {
			return -1;
		}
		else {
			return curr.getTotal();
		}
	}

	public void dump() {
		ArrayList<String> keys =  new ArrayList<String>(map.keySet());
		Collections.sort(keys);

		for (String name: keys) {
			TimeLogValue tuple = map.get(name);

			var total = tuple.getTotal();
			var count = tuple.getCount();
			if (count == 0)
				System.out.println("gregtesting " + name + "-- total: " + total);
			else {
				var div = total / count;
				System.out.println("gregtesting " + name + "-- total: " + total+ ", count: " + count  + ", (total/count): " + div);
			}
		}

		map.clear();
	}

	class TimeLogValue {
		private long start, total;
		private int count;

		public TimeLogValue(long start) {
			this.start = start;
			this.total = 0;

			this.count = 0;
		}

		public long getStart() {
			return start;
		}

		public void setStart(long start) {
			this.start = start;
		}

		public long getTotal() {
			return total;
		}

		public void setTotal(long total) {
			this.total = total;
		}

		public int getCount() {
			return count;
		}

		public void setCount(int count) {
			this.count = count;
		}
	}

}
