package edu.bu.signstream.common.util.vo.ss3.codingScheme.templates;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;

public class CSHandShapeTemplate {
   private String id;
   private String name;
   private String label;
   private int order;

   private ArrayList<CSHandShapePalette> palettes;

   public CSHandShapeTemplate(String id, String name, String label, int order) {
      this.id = id;
      this.name = name;
      this.label = label;
      this.palettes = new ArrayList<>();
      this.order = order;
   }

    public String getId() {
        return this.id;
    }

    public String getName() {
        return this.name;
    }

    public String getLabel() {
        return this.label;
    }

    public int getOrder() {
       return order;
    }

    public void setId(String id) {
        this.id = id;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public void addPalette(CSHandShapePalette palette) {
        this.palettes.add(palette);
    }

    public HashMap<String, CSHandShapePalette> getPalettesAsHashMap() {
         HashMap<String, CSHandShapePalette> map = new HashMap<>();

         for(CSHandShapePalette palette : this.palettes) {
             map.put(palette.getId(), palette);
         }

         return map;
    }

    public ArrayList<CSHandShapePalette> getPalettes() {
        return this.palettes;
    }
}
