package edu.bu.signstream.common.util.vo.ss3.codingScheme.templates;

import edu.bu.signstream.common.util.vo.Palette;

import java.util.ArrayList;
import java.util.HashMap;

public class PaletteGroup {
    private String id;
    private String order;
    private String name;

    private ArrayList<PaletteReference> paletteReferences;

    public PaletteGroup(String id, String order, String name) {
        this.id = id;
        this.order = order;
        this.name = name;
        this.paletteReferences = new ArrayList<>();
    }

    public String getId() {
        return this.id;
    }

    public String getOrder() {
        return this.order;
    }

    public int getOrderAsInt() {
        return Integer.parseInt(this.order);
    }

    public String getName() {
        return this.name;
    }

    public void setId(String id) {
        this.id = id;
    }

    public void setOrder(String order) {
        this.order = order;
    }

    public void setName(String name) {
        this.name = name;
    }

    public ArrayList<PaletteReference> getPaletteReferences() {
        return this.paletteReferences;
    }

    public HashMap<String, PaletteReference> getPaletteReferencesAsHashMap() {
        HashMap<String, PaletteReference> map = new HashMap<>();

        for(PaletteReference paletteReference : paletteReferences) {
            map.put(paletteReference.getPaletteId(), paletteReference);
        }

        return map;
    }

    public void setPaletteReferences(ArrayList<PaletteReference> paletteReferences) {
        this.paletteReferences = paletteReferences;
    }
}
