package edu.bu.signstream.common.util.vo.ss3.db;

import java.util.ArrayList;

public class SS3TemporalPartition extends SS3GlossWindowSegment {
	
	private SS3GlossWindowSegment listOfSegmentItems = new SS3GlossWindowSegment();
	private ArrayList<SS3GlossWindowSegment> temporalPartitionSegments = new ArrayList<SS3GlossWindowSegment>();
	
	public SS3GlossWindowSegment getGlossWindowSegment() {
//		// if read from a file, populate from segment1
//		if(listOfSegmentItems.getSS3GlossWindowItems().isEmpty() && !temporalPartitionsSegments.isEmpty()) {
//			SS3GlossWindowSegment temporalPartitionSegment = temporalPartitionsSegments.get(0);	// can't do it this way anymore
//			ArrayList<SS3GlossWindowItem> glossWindowItems = temporalPartitionSegment.getSS3GlossWindowItems();
//			for(SS3GlossWindowItem item : glossWindowItems) {
//				SS3GlossWindowItem glsItem = item.clone();
//				listOfSegmentItems.addSS3GlossWindowItem(glsItem);
//			}
//		}
		return listOfSegmentItems;
	}
	
	public void setGlossWindowSegment(SS3GlossWindowSegment listOfSegmentItems) {
		this.listOfSegmentItems = listOfSegmentItems;
	}
	
	public SS3GlossWindowSegment getTemporalPartitionSegmentByLabel(String label) {
		for (SS3GlossWindowSegment s: temporalPartitionSegments) {
			if (s.getLabel().equals(label)) {
				return s;
			}
		}		
		return null;
	}
	
	public ArrayList<SS3GlossWindowSegment> getTemporalPartitionSegments() {
		return temporalPartitionSegments;
	}

	// as of 8/24/2015, this is never called
	public void setTemporalPartitionSegments(ArrayList<SS3GlossWindowSegment> temporalPartitionSegments) {
		this.temporalPartitionSegments = temporalPartitionSegments;
	}
	
	public void addTemporalPartitionSegment(SS3GlossWindowSegment tpSegment) {
		temporalPartitionSegments.add(tpSegment);
	}
	
	public void removeTemporalPartitionSegment(SS3GlossWindowSegment segmentToRemove) {
		// if the default segment tier is removed, then auto-switch to the 0th index on this temporal partition
		// if default is at the 0th index, then choose the 1st index
		// there will always be an object in this index because it is impossible to delete the last segment tier
		SS3GlossWindowSegment defaultSegment = getDefaultSegment();
		SS3GlossWindowSegment firstSegment =temporalPartitionSegments.get(0);
		
		if (segmentToRemove != null) {
			if (segmentToRemove.equals(defaultSegment)) {
				if (! segmentToRemove.equals(firstSegment)) {
					setDefaultSegment(firstSegment);
				} else {
					setDefaultSegment(temporalPartitionSegments.get(1));
				}
			}
			
			temporalPartitionSegments.remove(segmentToRemove);
		} else {
			System.out.println("There is no such segment in this temporal partition");
		}		
	}
	
	public SS3GlossWindowSegment getDefaultSegment() {
		for (SS3GlossWindowSegment currentSegment: temporalPartitionSegments) {
			if (currentSegment.isDefault()) {
				return currentSegment;
			}
		}
		
		return null;
	}
	
	public void setDefaultSegmentByLabel(String defaultSegmentLabel) {
		SS3GlossWindowSegment defaultSegment = getTemporalPartitionSegmentByLabel(defaultSegmentLabel);
		
		if (defaultSegment != null)
			setDefaultSegment(defaultSegment);
	}
	
	public void setDefaultSegment(SS3GlossWindowSegment defaultSegment) {
		if (temporalPartitionSegments.contains(defaultSegment)) {
			// set defaultSegment default param to true, and all others in this collection to false
			for (SS3GlossWindowSegment currentSegment: temporalPartitionSegments) {
				if (currentSegment.equals(defaultSegment)) {
					currentSegment.setDefault(true);
				}
				else {
					currentSegment.setDefault(false);
				}
			}
		}
	}
	
	@Override
	public String toString() {
		String ret = "SS3TemporalPartitiont: label = " + getLabel();
		return ret;
	}
}
