package edu.bu.signstream.common.util.vo.ss3.participants;

public class SS3Participant {
	
	private String id="";
	private String fullName="";
	private String label="";
	private String yearOfBirth="";
	private char gender = 'M';
	private String nativeLanguage = "ASL";
	
	private String comments="";
	private String parentsInfo="";
	private String background="";
	// dom hand can be "RIGHT" or "LEFT"
	private String domHand = "R";

	private String graphFileID;
	
	private boolean justCreated = false;
	
	public boolean isJustCreated() {
		return justCreated;
	}

	public void setJustCreated(boolean justCreated) {
		this.justCreated = justCreated;
	}

	private boolean isSelected = false;
	
	public boolean isSelected() {
		return isSelected;
	}

	public void setSelected(boolean isSelected) {
		this.isSelected = isSelected;
	}
	
	public void setDominantHand(String domHand) {
		this.domHand = domHand;
	}
	
	public String getDominantHand() {
		return domHand;
	}
	
	public boolean isDominantHandRight() {
		return domHand.equalsIgnoreCase("R")||domHand.equalsIgnoreCase("RIGHT");
	}
	
	public void setGender(String str) {
		if(str == null || str.length() == 0) return;
		
		str.trim();
		this.gender = str.charAt(0); 
	}
	
	public void setGenderMale() {
		gender = 'M';
	}
	
	public void setGenderFemale() {
		gender = 'F';
	}
	
	public char getGender() {
		return gender;
	}

	public String getFullName() {
		return fullName;
	}

	public void setFullName(String fullName) {
		this.fullName = fullName;
	}

	public String getYearOfBirth() {
		return yearOfBirth;
	}

	public void setYearOfBirth(String yearOfBirth) {
		this.yearOfBirth = yearOfBirth;
	}

	public String getNativeLanguage() {
		return nativeLanguage;
	}

	public void setNativeLanguage(String nativeLanguage) {
		this.nativeLanguage = nativeLanguage;
	}

	public String getComments() {
		return comments;
	}

	public void setComments(String comments) {
		this.comments = comments;
	}

	public String getParentsInfo() {
		return parentsInfo;
	}

	public void setParentsInfo(String parentsInfo) {
		this.parentsInfo = parentsInfo;
	}

	public String getBackground() {
		return background;
	}

	public void setBackground(String background) {
		this.background = background;
	}

	public String getDomHand() {
		return domHand;
	}

	public void setDomHand(String domHand) {
		this.domHand = domHand;
	}

	public String getId() {
		return id;
	}

	public String getLabel() {
		return label;
	}

	public void setGender(char c) {
		gender = c;
	}

	public void setId(String string) {
		id = string;
	}

	public void setLabel(String string) {
		label = string;
	}

	public String getGraphFileID() {
		return graphFileID;
	}

	public void setGraphFileID(String graphFileID) {
		this.graphFileID = graphFileID;
	}

	public String getInformation() {
		StringBuffer info = new StringBuffer("");
		info.append("Full Name: ");
		info.append(fullName);
		info.append("\n");
		info.append("Label: ");
		info.append(label);
		info.append("\n");
		
		if(yearOfBirth != null && yearOfBirth.length()>0) {
			info.append("Year of birth: ");
			info.append(yearOfBirth);
			info.append("\n");
		}
		
		if(gender != ' ') {
			info.append("Gender: ");
			info.append(gender);
			info.append("\n");
		}
		
		if(nativeLanguage != null && nativeLanguage.length()>0) {
			info.append("Native Language: ");
			info.append(nativeLanguage);
			info.append("\n");
		}

		return info.toString();
	}
	
	@Override
	public String toString() {
//		StringBuffer bfr = new StringBuffer();
//		bfr.append("gender = ");
//		bfr.append(gender);
//		bfr.append(", id = ");
//		bfr.append(id);
//		bfr.append(", firstName = ");
//		bfr.append(firstName);
//		bfr.append(", lastName = ");
//		bfr.append(lastName
//		bfr.append(", label = ");
//		bfr.append(label); 
//		bfr.append(", age = ");
//		bfr.append(age); 
//		bfr.append(", domHand = ");
//		bfr.append(domHand);
//		bfr.append(", languages.size = ");
//		bfr.append(languages.size());
//		return bfr.toString();
		return isSelected ? "_"+label : label;
		//return label;
	}

	@Override
	public boolean equals(Object obj) {
		if (this.label == null) {
			return false;
		}
		if (obj instanceof SS3Participant) {
			SS3Participant p = (SS3Participant) obj;
			if (p.getLabel() == null) {
				return false;
			}
			return p.getLabel().equals(this.label);
		}
		return false;
	}
}
