package edu.bu.signstream.grepresentation.fields;

import edu.bu.signstream.common.util.vo.ss3.db.SS3Entity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureField;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureText;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolbarCommons;
import edu.bu.signstream.time.Rounding;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.time.TimeUnit;

import java.awt.*;
import java.util.ArrayList;

// JACK: This is a hack that allows passing a Text as an Event/EventsEntity
// to the regular select() functions without a million special cases everywhere.
//
// Text should probably just be an EventsEntity.

public class GestureTextEventsEntity extends EventsEntity {

    private final GestureText text;

    public GestureTextEventsEntity(GestureText text, Field field) {
        super(SS3Singleton.getMediaToolBar().segmentPanel(), field);
        this.text = text;
    }

    @Override
    public void setStartTimeInfo(Time time) {
        var coord = (double)time.absolute().as(TimeUnit.COORDINATE, Rounding.NEAREST);
        var bar = SS3Singleton.getMediaToolBar();
        MediaToolbarCommons.setTextStartEndTime((GestureField) getField(), null, time, coord, bar);
    }
    @Override
    public void setEndTimeInfo(Time time) {
        var coord = (double)time.absolute().as(TimeUnit.COORDINATE, Rounding.NEAREST);
        var bar = SS3Singleton.getMediaToolBar();
        MediaToolbarCommons.setTextStartEndTime((GestureField) getField(), null, time, coord, bar);
    }

    @Override
    public Time getStartTimeInfo() { return null; }
    @Override
    public Time getEndTimeInfo() { return null; }

    @Override
    public boolean select() {
        text.setSelected(true);
        return true;
    }
    @Override
    public boolean unselect() {
        text.setSelected(false);
        return true;
    }

    @Override public Event getFirstEvent() { return this; }
    @Override public Event getLastEvent() { return this; }
    @Override public SS3Entity getSS3Entity() { return null; }
    @Override public boolean selectEntityIfEventSelected() { return false; }
    @Override public boolean selectEventIfEntitySelected() { return false; }
    @Override public boolean adjustEntity(int x1, int x2) { return false; }
    @Override public Event getSelectedEvent() { return null; }
    @Override public void reset() { }
    @Override public boolean delete() { return false; }
    @Override public Event getEventAt(double x) { return null; }
    @Override public ArrayList<String> getEventsToAdd() { return null; }
    @Override public ArrayList<Event> getEventsList() { return null; }
    @Override public String getToolTipText(int x) { return null; }
    @Override public boolean selectEvent(double x) { return false; }
    @Override public void paint(Graphics2D g2d, double Y, Font font) {}
}
