package edu.bu.signstream.grepresentation.fields.gestureField.dialog;

import java.awt.Component;

import javax.swing.JCheckBox;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeCellRenderer;

public class CheckBoxNodeRenderer implements TreeCellRenderer {
	
	private JCheckBox leafRenderer = new JCheckBox();
	
	private DefaultTreeCellRenderer nonLeafRenderer = new DefaultTreeCellRenderer();
	
	protected JCheckBox getLeafRenderer() {
		return leafRenderer;
	}
	
	public CheckBoxNodeRenderer() {
		
	}
	
	@Override
	public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded,
			boolean leaf, int row, boolean hasFocus) {
		Component returnValue;
		if (leaf) {
			//Object userObject = ((DefaultMutableTreeNode)value).getUserObject();
			leafRenderer.setText(value.toString());
			leafRenderer.setSelected(selected);

			returnValue = leafRenderer;
		} else {
			nonLeafRenderer.setLeafIcon(null);
			nonLeafRenderer.setClosedIcon(null);
			nonLeafRenderer.setOpenIcon(null);
			returnValue = nonLeafRenderer.getTreeCellRendererComponent(tree, value, selected,
					expanded, leaf, row, hasFocus);
		}
		
		return returnValue;
	}

}
