package edu.bu.signstream.grepresentation.fields.gestureField.dialog;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.common.util.Util;

import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.*;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.HandShapeFormBean;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualField;
import edu.bu.signstream.grepresentation.view.SegmentTemplate;
import edu.bu.signstream.time.Bound;
import edu.bu.signstream.time.Duration;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3Field;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.common.util.vo.ss3.db.*;

import edu.bu.signstream.grepresentation.fields.*;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.apexField.ApexChainedApexEventsEntity;
import edu.bu.signstream.grepresentation.fields.apexField.ApexFieldWrapper;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureFieldWrapper;
import edu.bu.signstream.grepresentation.fields.gestureField.handshapes.GestureHandShapeEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.handshapes.GestureHandShapeEvent;
import edu.bu.signstream.grepresentation.fields.gestureField.handshapes.GestureHandShapeFieldWrapper;
import edu.bu.signstream.grepresentation.fields.gestureField.domNdomField.GestureDomNdomHandField;
import edu.bu.signstream.grepresentation.fields.gestureField.domNdomField.GestureDomNdomHandFieldWrapper;

import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.handshapeTypes.DomNdomHandshapesType;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.handshapeTypes.StartEndHandshapesType;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.associatedFields.locations.GestureLocationInfo;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.associatedFields.locations.GestureLocationType;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEvent;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureClassifications;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureField;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationEvent;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationEventsCollection;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationFieldWrapper;

import edu.bu.signstream.grepresentation.fields.gestureField.orientationField.GestureOrientationEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.orientationField.GestureOrientationEvent;
import edu.bu.signstream.grepresentation.fields.gestureField.orientationField.GestureOrientationFieldWrapper;
import edu.bu.signstream.grepresentation.fields.handShapeField.HandShapeEntity;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEvent;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEventsCollection;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEntityProperties;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualField;
import edu.bu.signstream.grepresentation.fields.nonManualField.mouseDelegateListeners.AccessSignBankActionListener;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.fields.gestureField.gesturePropertyField.*;
import edu.bu.signstream.grepresentation.listener.WeakActionListener;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.GestureNRelatedView;
import edu.bu.signstream.grepresentation.view.LabelObject;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolbarCommons;
import edu.bu.signstream.grepresentation.view.signbank.SignBankOccurrence;
import edu.bu.signstream.grepresentation.view.signbank.SignBankVariant;
import edu.bu.signstream.ui.ButtonPanel;
import edu.bu.signstream.ui.panels.signbank.SignBankDialog;

public class GestureInfoPanel extends JPanel implements ItemListener, ActionListener {

	private static final long serialVersionUID = 1L;

	private final JDialog parent;

	private SignBankDialog signBankDialog = null;

	private JTabbedPane tabbedPane;

	private GestureFieldWrapper wrapper = null;
	private GestureHandShapePanel hshPanel = null;
	private LocationEncloserPanel locationPanel;
	private JScrollPane locationScrollPane;
	
	private GesturePropertyPanel gstPanel = null;

	private final JLabel primaryEntryLb = new JLabel("Primary Entry");
	private final JTextField primaryEntryField = new JTextField();

	private final JLabel gestureLb = new JLabel("Label (Optional)");
	private final JTextField gestureLbField = new JTextField();
	private final JButton searchSignBank = new JButton("Search Sign Bank");
	private final JCheckBox incompleteCheckbox = new JCheckBox("Incomplete");
//	private final JCheckBox showUniqueNumberCheckbox = new JCheckBox("Show Unique Number");
	private final JCheckBox showAllUniqueNumbersCheckbox = new JCheckBox("Show All Unique Numbers");
//	private final JCheckBox defaultShowUniqueNumbersCheckbox = new JCheckBox("Default Show Unique Numbers");
	
	private final JLabel uniqueNumberLb = new JLabel("Gesture Number");
	private final JTextField uniqueNumberField = new JTextField(5);

	private final JButton addNewSign = new JButton("Add To Sign Bank");

	private final JLabel domHandLbl = new JLabel("Dominant Hand");
	private final JRadioButton domHandR = new JRadioButton("Right");
	private final JRadioButton domHandL = new JRadioButton("Left");

	private final JButton enter = new JButton("Enter");
	private final JButton cancel = new JButton("Cancel");
	private final JButton bypass = new JButton("Bypass Sign Bank Check");

	private final int ENTER_BYPASS = -1;
	private final int ENTER = 0;
	private final int CANCEL = 1;

	private final int SIGN_BANK = 8;
	private final int ADD_NEW = 9;

	public static final int TAB_HANDSHAPES = 0;
	public static final int TAB_LOCATION = 1;

	private GestureNRelatedView view = null;

	private GestureHandShapePreprocessor processor = null;
	private HandShapeFormBean hshFormBean = null;

	private final LoadedProperties loadedProperties = new LoadedProperties();

	private AccessSignBankActionListener accessSignBankListener = null;

	private GestureEventsEntity currentGestureEntity;
	private boolean currentPartipantRightHanded;
	private SS3GlossWindowSegment currentGestureWindowSegment;

	private String dominantHand;

	public GestureInfoPanel(GestureFieldWrapper wrapper, GestureNRelatedView view, JDialog parent) {
		this.view = view;
		this.parent = parent;
		this.processor = new GestureHandShapePreprocessor(view.getFieldWrappersCollection());

		enter.setActionCommand("" + ENTER);
		cancel.setActionCommand("" + CANCEL);
		bypass.setActionCommand("" + ENTER_BYPASS);
		addGestureFieldDocumentListener();

		enter.addActionListener(new WeakActionListener(this, enter));
		cancel.addActionListener(new WeakActionListener(this, cancel));
		bypass.addActionListener(new WeakActionListener(this, bypass));

//		searchSignBank.addActionListener(this);
//		searchSignBank.setActionCommand("" + SIGN_BANK);

//		addNewSign.addActionListener(this);
//		addNewSign.setActionCommand("" + ADD_NEW);

		ButtonGroup domHandGrp = new ButtonGroup();
		domHandGrp.add(domHandR);
		domHandGrp.add(domHandL);

		domHandR.setEnabled(false);
		domHandL.setEnabled(false);

		update(wrapper, view);
		initUI();
	}

	private void addGestureFieldDocumentListener() {
		gestureLbField.getDocument().addDocumentListener(new DocumentListener() {
			@Override
			public void insertUpdate(DocumentEvent e) {
				changed();
			}
			@Override
			public void removeUpdate(DocumentEvent e) {
				changed();
			}
			@Override
			public void changedUpdate(DocumentEvent e) {
			}

			public void changed() {
//				if (variantField.getText().trim().isEmpty())
//					enter.setEnabled(false);
//				else
//					enter.setEnabled(true);
			}
		});
	}

	public void showTab(int tabNum) {
		if (tabbedPane != null) {
			tabbedPane.setSelectedIndex(tabNum);
		}
	}

	private void populateHandshapeFormBean(GestureEventsEntity entity) {
		// retrieve selected handshapes for right and left hands
		GestureHandShapeEntity hshEntity1 = entity.getDependentHandShapeEntity();
		GestureOrientationEntity ftEntity1 = entity.getDependentFingerTipOrientationEntity();
		GestureOrientationEntity poEntity1 = entity.getDependentPalmOrientationEntity();
		// 1000, 2000
		SS3CodingScheme dbScheme = entity.getSignStreamSegmentPanel().getSS3Database().getSS3CodingScheme();

		ArrayList<HandShapeImage> selectedHandImagesRight = new ArrayList<>();
		ArrayList<HandShapeImage> selectedHandImagesLeft = new ArrayList<>();
		ArrayList<FingerTipImage> selectedOrientationFingerTipImagesRight = new ArrayList<>();
		ArrayList<FingerTipImage> selectedOrientationFingerTipImagesLeft = new ArrayList<>();
		ArrayList<PalmImage> selectedPalmOrientationImagesLeft = new ArrayList<>();
		ArrayList<PalmImage> selectedPalmOrientationImagesRight = new ArrayList<>();

		if (hshEntity1 != null) {
			String fID = hshEntity1.getField().getFieldID();
			SS3Field field = dbScheme.getField(fID);
			ArrayList<GestureHandShapeEvent> hShapes = hshEntity1.getGestureHandShapeEvents();

			for (GestureHandShapeEvent event : hShapes) {
				SS3FieldValue value = field.getFieldValue(event.getID());
				HandShapeImage image = new HandShapeImage(value, dbScheme);
				if (currentPartipantRightHanded) {
					selectedHandImagesRight.add(image);
				} else {
					selectedHandImagesLeft.add(image);
				}
			}
		}
		
		if (ftEntity1 != null) {
			String fID = ftEntity1.getField().getFieldID();
			SS3Field field = dbScheme.getField(fID);
			ArrayList<GestureOrientationEvent> hShapes = ftEntity1.getGestureOrientationEvents();

			for (GestureOrientationEvent event : hShapes) {
				SS3FieldValue value = field.getFieldValue(event.getID());
				FingerTipImage image = new FingerTipImage(value, dbScheme);
				if (currentPartipantRightHanded) {
					selectedOrientationFingerTipImagesRight.add(image);
				} else {
					selectedOrientationFingerTipImagesLeft.add(image);
				}
			}
		}

		if (poEntity1 != null) {
			String fID = poEntity1.getField().getFieldID();
			SS3Field field = dbScheme.getField(fID);
			ArrayList<GestureOrientationEvent> hShapes = poEntity1.getGestureOrientationEvents();

			for (GestureOrientationEvent event : hShapes) {
				SS3FieldValue value = field.getFieldValue(event.getID());
				PalmImage image = new PalmImage(value, dbScheme);
				if (currentPartipantRightHanded) {
					selectedPalmOrientationImagesRight.add(image);
				} else {
					selectedPalmOrientationImagesLeft.add(image);
				}
			}
		}

		GestureEventsEntity ndEntity = entity.getDependentGestureEntity();

		if (ndEntity != null && ndEntity.getDependentHandShapeEntity() != null) {
			GestureHandShapeEntity hshEntity2 = ndEntity.getDependentHandShapeEntity();
			String ndfID = hshEntity2.getField().getFieldID();

			SS3Field ndfield = dbScheme.getField(ndfID);
			ArrayList<GestureHandShapeEvent> ndHShapes = hshEntity2.getGestureHandShapeEvents();

			for (GestureHandShapeEvent event : ndHShapes) {
				SS3FieldValue value = ndfield.getFieldValue(event.getID());
				HandShapeImage image = new HandShapeImage(value, dbScheme);
				if (currentPartipantRightHanded) {
					selectedHandImagesLeft.add(image);
				} else {
					selectedHandImagesRight.add(image);
				}
			}
			
			GestureOrientationEntity ftEntity2 = ndEntity.getDependentFingerTipOrientationEntity();
			GestureOrientationEntity poEntity2 = ndEntity.getDependentPalmOrientationEntity();

			if (ftEntity2 != null) {
				String ndofID = ftEntity2.getField().getFieldID();

				SS3Field ndofield = dbScheme.getField(ndofID);
				ArrayList<GestureOrientationEvent> ndoShapes = ftEntity2.getGestureOrientationEvents();

				for (GestureOrientationEvent event : ndoShapes) {
					SS3FieldValue value = ndofield.getFieldValue(event.getID());
					FingerTipImage image = new FingerTipImage(value, dbScheme);
					if (currentPartipantRightHanded) {
						selectedOrientationFingerTipImagesLeft.add(image);
					} else {
						selectedOrientationFingerTipImagesRight.add(image);
					}
				}
			}

			if (poEntity2 != null) {
				String ndpofID = poEntity2.getField().getFieldID();

				SS3Field ndpofield = dbScheme.getField(ndpofID);
				ArrayList<GestureOrientationEvent> ndpoShapes = poEntity2.getGestureOrientationEvents();

				for (GestureOrientationEvent event : ndpoShapes) {
					SS3FieldValue value = ndpofield.getFieldValue(event.getID());
					PalmImage image = new PalmImage(value, dbScheme);
					if (currentPartipantRightHanded) {
						selectedPalmOrientationImagesLeft.add(image);
					} else {
						selectedPalmOrientationImagesRight.add(image);
					}
				}
			}
		}

		if (wrapper.getGestureField().getFieldID().equals(Util.DOM_GESTURE_FIELD_ID)) {
			if (isDominantHandRight()) {
				hshFormBean.setSelectedDomHandShapeImages(selectedHandImagesRight);
				hshFormBean.setSelectedNdomHandShapeImages(selectedHandImagesLeft);
				hshFormBean.setSelectedDomOrientationFingerTipImages(selectedOrientationFingerTipImagesRight);
				hshFormBean.setSelectedNdomOrientationFingerTipImages(selectedOrientationFingerTipImagesLeft);
				hshFormBean.setSelectedDomPalmOrientationImages(selectedPalmOrientationImagesRight);
				hshFormBean.setSelectedNdomPalmOrientationImages(selectedPalmOrientationImagesLeft);

			} else {
				hshFormBean.setSelectedDomHandShapeImages(selectedHandImagesLeft);
				hshFormBean.setSelectedNdomHandShapeImages(selectedHandImagesRight);
				hshFormBean.setSelectedDomOrientationFingerTipImages(selectedOrientationFingerTipImagesLeft);
				hshFormBean.setSelectedNdomOrientationFingerTipImages(selectedOrientationFingerTipImagesRight);
				hshFormBean.setSelectedDomPalmOrientationImages(selectedPalmOrientationImagesLeft);
				hshFormBean.setSelectedNdomPalmOrientationImages(selectedPalmOrientationImagesRight);
			}
		} else {
			if (this.isDominantHandRight()) {
				hshFormBean.setSelectedDomHandShapeImages(selectedHandImagesLeft);
				hshFormBean.setSelectedNdomHandShapeImages(selectedHandImagesRight);
				hshFormBean.setSelectedDomOrientationFingerTipImages(selectedOrientationFingerTipImagesLeft);
				hshFormBean.setSelectedNdomOrientationFingerTipImages(selectedOrientationFingerTipImagesRight);
				hshFormBean.setSelectedDomPalmOrientationImages(selectedPalmOrientationImagesLeft);
				hshFormBean.setSelectedNdomPalmOrientationImages(selectedPalmOrientationImagesRight);
			} else {
				hshFormBean.setSelectedDomHandShapeImages(selectedHandImagesRight);
				hshFormBean.setSelectedNdomHandShapeImages(selectedHandImagesLeft);
				hshFormBean.setSelectedDomOrientationFingerTipImages(selectedOrientationFingerTipImagesRight);
				hshFormBean.setSelectedNdomOrientationFingerTipImages(selectedOrientationFingerTipImagesLeft);
				hshFormBean.setSelectedDomPalmOrientationImages(selectedPalmOrientationImagesRight);
				hshFormBean.setSelectedNdomPalmOrientationImages(selectedPalmOrientationImagesLeft);
			}
		}
	}

	protected void update(GestureFieldWrapper wrapper, GestureNRelatedView gestView) {
		this.wrapper = wrapper;
		this.view = gestView;

		loadedProperties.reset();

		EventsEntity ent = SS3Singleton.getMediaToolBar(null).selectedEntity();

		if (ent == null)
			return;

		currentGestureEntity = (GestureEventsEntity) ent;
		PresentationField parentField = currentGestureEntity.getField().getParentField();
		currentGestureWindowSegment = parentField.getSS3GlossWindowSegment();
		currentPartipantRightHanded = currentGestureWindowSegment.getParticipant() == null || currentGestureWindowSegment.getParticipant().isDominantHandRight();

		dominantHand = currentPartipantRightHanded ? "R" : "L";
		if (currentPartipantRightHanded) {
			domHandR.setSelected(true);
		} else {
			domHandL.setSelected(true);
		}

		hshFormBean = new HandShapeFormBean();
		processor.setRightHandDominant(currentPartipantRightHanded);
		processor.populateFormBean(hshFormBean);
		hshFormBean.setGestFieldWrapper(wrapper);

		populateHandshapeFormBean(currentGestureEntity);

		GestureChainedEvent event = currentGestureEntity.getGestureChainedEvent();

		gestureLbField.setText(event.getText().trim());
		incompleteCheckbox.setSelected(currentGestureEntity.getIncompleteGesture());
		showAllUniqueNumbersCheckbox.setSelected(currentGestureWindowSegment.getShowAllGestureCounters());
		uniqueNumberField.setText(currentGestureEntity.getUniqueNumber().trim());
		primaryEntryField.setText(null);

		String fieldID = currentGestureEntity.getField().getFieldID();

		GestureEntityProperties properties = currentGestureEntity.getGestureEntityProperties();

		ArrayList<HandShapeImage> rhList = new ArrayList<>(hshFormBean.getSelectedDomHandShapeImages());
		ArrayList<HandShapeImage> lhList = new ArrayList<>(hshFormBean.getSelectedNdomHandShapeImages());

		if((rhList.size() > 0 && lhList.size() == 0) || (rhList.size() == 0 && lhList.size() > 0)) {
			properties.setTwoHanded(false);
		}

		if (currentPartipantRightHanded) {
			properties.setDominantHand("R");
		} else {
			properties.setDominantHand("L");
		}

		if(hshPanel == null) {
			this.hshPanel = new GestureHandShapePanel(this);
		}

		if (gstPanel == null) {
			this.gstPanel = new GesturePropertyPanel(this);
		}
		
		if (fieldID.equalsIgnoreCase(Util.DOM_GESTURE_FIELD_ID)) {
			// if dominant hand right (right handed signer), check right hand;
			// otherwise check left
			if (currentPartipantRightHanded) {
				properties.setOnehandedSignHand("R");
			} else {
				properties.setOnehandedSignHand("L");
			}
		} else {
			if (currentPartipantRightHanded) {
				properties.setOnehandedSignHand("L");
			} else {
				properties.setOnehandedSignHand("R");
			}
		}

		if (currentGestureEntity.getStartTimeInfo().equals(currentGestureEntity.getEndTimeInfo())) {
			properties.setOneFrameGesture(true);
		} else {
			properties.setOneFrameGesture(false);
		}

		FieldWrappersCollection collection = view.getFieldWrappersCollection();
		GestureFieldWrapper ndWrp;

        if (properties.getSignType() == null) {
			boolean rhEmpty = rhList.isEmpty();
			boolean lhEmpty = lhList.isEmpty();

			if (rhEmpty && !lhEmpty) {
				properties.setTwoHanded(false);
				boolean rIdentical = isIdenticalStartEndHandshapes(lhList);

				if (rIdentical) {
					properties.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
				} else {
					properties
							.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
				}

			} else {
				if (!rhEmpty && lhEmpty) {
					properties.setTwoHanded(false);
					boolean lIdentical = isIdenticalStartEndHandshapes(rhList);

					if (lIdentical) {
						properties
								.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
					} else {
						properties
								.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
					}
				} else if (!rhEmpty && !lhEmpty) {
					properties.setTwoHanded(true);

					boolean isIdenticalDomNdom = isIdenticalHandshapes(rhList, lhList);

					if (isIdenticalDomNdom) {
						properties.setTwoHandedHandshapesClassification(GestureEntityProperties.SAME_HANDSHAPES_DOM_NDOM);
						boolean lIdentical = isIdenticalStartEndHandshapes(rhList);

						if (lIdentical) {
							properties.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
						} else {
							properties.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
						}
					} else {
						properties.setTwoHandedHandshapesClassification(GestureEntityProperties.DIFFERENT_HANDSHAPES_DOM_NDOM);

						if (isIdenticalStartEndHandshapes(lhList)) {
							properties
									.setStartEndHandshapeNdomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
						} else {
							properties
									.setStartEndHandshapeNdomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
						}

						if (isIdenticalStartEndHandshapes(rhList)) {
							properties
									.setStartEndHandshapeDomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
						} else {
							properties
									.setStartEndHandshapeDomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
						}
					}

					properties.setTwoHandedEnabled(true);

					String gest = currentGestureEntity.getText();

					String handednessPattern = "(!)?(neu:|([a-z_1-3][p:]))?((.)([12][h])(.))(alt.)?(.*)?";
					Pattern.compile(handednessPattern);
					Pattern handednessR = Pattern.compile(handednessPattern);
					Matcher handednessMatcher = handednessR.matcher(gest);

					// handedness
					if (handednessMatcher.find()) {

						String oneHandedPattern = "(!)?(neu:)?((1h)){1}(.*)?";
						Pattern oneHandedR = Pattern.compile(oneHandedPattern);
						Matcher oneHandedMatcher = oneHandedR.matcher(gest);

						if (oneHandedMatcher.find()) {
							properties.setTwoHanded(false);

						} else {
							properties.setTwoHanded(true);

							String twoHandedAltPattern = "(!)?(neu:)?((2h).alt)(.*)?";
							Pattern twoHandedAltR = Pattern
									.compile(twoHandedAltPattern);
							Matcher twoHandedAltMatcher = twoHandedAltR
									.matcher(gest);

							if (twoHandedAltMatcher.find()) {
								properties
										.setTwoHandedHandshapesClassification(GestureEntityProperties.ALTERNATING_SAME_HANDSHAPES_DOM_NDOM);
							}
						}
					}
				}
			}

			String gest = currentGestureEntity.getText();
			// name sign
			String nameSignPattern = "(!)?(neu:|([a-z_1-3][p:]))?([(1h)][(2h)][(2h)alt.])?(ns-){1}(.*)?";
			Pattern nameSignR = Pattern.compile(nameSignPattern);
			Matcher nameSignMatcher = nameSignR.matcher(gest);

			if (nameSignMatcher.find()) {
				hshPanel.setNameSign(true);
			} else {
				hshPanel.setNameSign(false);
			}

			String fingerspelledPattern = "(!)?(neu:|([a-z_1-3][p:]))?([(1h)][(2h)][(2h)alt.])?(fs-){1}(.*)?";
			Pattern fingerspelledR = Pattern.compile(fingerspelledPattern);
			Matcher fingerspelledMatcher = fingerspelledR.matcher(gest);

			if (fingerspelledMatcher.find()) {
				hshPanel.setFingerspelled(true);
			} else {
				// loan sign
				String loanSignPattern = "(!)?(neu:|([a-z_1-3][p:]))?([(1h)][(2h)][(2h)alt.])?(#){1}(.*)?";
				Pattern loanSignR = Pattern.compile(loanSignPattern);
				Matcher loanSignMatcher = loanSignR.matcher(gest);

				if (loanSignMatcher.find()) {
					hshPanel.setLoan(true);
				} else {
					String classifierPattern = "(!)?(neu:|([a-z_1-3][p:]))?([(1h)][(2h)][(2h)alt.])?(ns-)?((CL)|(DCL)|(LCL)|(SCL)|(BCL)|(BPCL)|(PCL)|(ICL)){1}([-_:].*)?$";
					Pattern classifierR = Pattern.compile(classifierPattern);
					Matcher classifierMatcher = classifierR.matcher(gest);

					if (classifierMatcher.find()) {
						hshPanel.setClassifier(true);
					} else {

						String gesturePattern = "(!)?(neu:|([a-z_1-3][p:]))?([(1h)][(2h)][(2h)alt.])?(ns-)?((\"){1}(.){1,}(\"){1})(.*)?";
						Pattern gestureR = Pattern.compile(gesturePattern);
						Matcher gestureMatcher = gestureR.matcher(gest);

						if (gestureMatcher.find()) {
							hshPanel.setGesture(true);
						} else {
							hshPanel.setLexical(true);

							if (fieldID.equalsIgnoreCase(Util.DOM_GESTURE_FIELD_ID)) {
								ndWrp = (GestureFieldWrapper) collection
										.getFieldWrapperWithFieldID(Util.NDOM_GESTURE_FIELD_ID);
							} else {
								ndWrp = (GestureFieldWrapper) collection
										.getFieldWrapperWithFieldID(Util.DOM_GESTURE_FIELD_ID);
							}
						}
					}
				}
			}

		} else {
			hshPanel.setFingerspelled(properties.isFingerspelled());
			hshPanel.setLoan(properties.isLoan());
			hshPanel.setNumber(properties.isNumber());
			hshPanel.setLexical(properties.isLexical());
			hshPanel.setClassifier(properties.isClassifier());
			hshPanel.setGesture(properties.isGesture());
			hshPanel.setNameSign(properties.isNameSign());

			if (fieldID.equalsIgnoreCase(Util.DOM_GESTURE_FIELD_ID)) {
				ndWrp = (GestureFieldWrapper) collection
						.getFieldWrapperWithFieldID(Util.NDOM_GESTURE_FIELD_ID);
			} else {
				ndWrp = (GestureFieldWrapper) collection
						.getFieldWrapperWithFieldID(Util.DOM_GESTURE_FIELD_ID);
			}

			NonManualField ndField = (NonManualField) ndWrp.getField();
			boolean isPossibleToAddEvent = ndField.isIntervalEmpty(currentGestureEntity.interval());

			if (!isPossibleToAddEvent) {
				String correspondingID = currentGestureEntity.getCorrespondingGestureEntityID();
				EventsEntity correspondingEntity = ndField
						.getEntity(correspondingID);
				if (correspondingEntity != null) {
					isPossibleToAddEvent = true;
				}
			}
			properties.setTwoHandedEnabled(isPossibleToAddEvent);
		}

		hshFormBean.setGestureEntityProperties(properties);

		if (this.hshPanel != null) {
			this.hshPanel.update();
		}

		if (this.locationPanel != null) {
			this.locationPanel.resetHands();
		}

		if (this.gstPanel != null) {
			this.getGesturePropertyPanel().clearSelectedPaths();
			this.gstPanel.update();
		}

		checkSignTypeAndUpdateSignBankFunctionality();

		if (hshPanel != null) {
			loadedProperties.setSameDifStartEndHandshapes(hshPanel.getSelectedSameDifStartEndHandshapes());
			loadedProperties.setSameDIfferentDomNdomHandshapes(hshPanel.getSelectedSameDifDomNdomHandshapes());
			loadedProperties.setSameDifStartEndHandshapesL(hshPanel.getSelectedSameDifStartEndHandshapesNdom());
			loadedProperties.setSameDifStartEndHandshapesR(hshPanel.getSelectedSameDifStartEndHandshapesDom());
		}

		loadedProperties.setRightHandSelectedHandshapes(hshFormBean.getSelectedDomHandShapeImages());
		loadedProperties.setLeftHandSelectedHandshapes(hshFormBean.getSelectedNdomHandShapeImages());
		
		loadedProperties.setRightHandSelectedFingerTipOrientations(hshFormBean.getSelectedDomOrientationFingerTipImages());
		loadedProperties.setLeftHandSelectedFingerTipOrientations(hshFormBean.getSelectedNdomOrientationFingerTipImages());

		loadedProperties.setRightHandSelectedPalmOrientations(hshFormBean.getSelectedDomOrientationPalmImages());
		loadedProperties.setLeftHandSelectedPalmOrientations(hshFormBean.getSelectedNdomOrientationPalmImages());



		loadedProperties.setGesturePropertyEntity(currentGestureEntity.getDependentGesturePropertyEntity());

		loadedProperties.setGestText(this.gestureLbField.getText());

		// Determine if two handed gesture is selected

		loadedProperties.setTwoHanded(this.hshPanel.isTwoHanded());

		GestureEventsEntity depGestEntity = currentGestureEntity.getDependentGestureEntity();
		if (locationPanel == null) {
			locationPanel = new LocationEncloserPanel(this);
		}


		locationPanel.resetDialogs();
		if (depGestEntity != null) {   // Two-Handed
			GestureEntityProperties depProperties = depGestEntity.getGestureEntityProperties();
			if (isCurrentGestureDominant()) {
				locationPanel.setDomLocationInfo(properties.getLocationInfo().cloneInfo());
				locationPanel.setNDomLocationInfo(depProperties.getLocationInfo().cloneInfo());
			}
			else {
				locationPanel.setDomLocationInfo(depProperties.getLocationInfo().cloneInfo());
				locationPanel.setNDomLocationInfo(properties.getLocationInfo().cloneInfo());
			}
		}
		else { // Single-handed (Dominant and Non-Dominant)
//			locationPanel.resetHands();
			if (isCurrentGestureDominant())
				locationPanel.setDomLocationInfo(properties.getLocationInfo().cloneInfo());
			else
				locationPanel.setNDomLocationInfo(properties.getLocationInfo().cloneInfo());
		}

		if (tabbedPane != null) {
			showTab(TAB_HANDSHAPES);
		}

		revalidate();
		parent.pack();
	}

	public HandShapeFormBean getGestureHandShapeFormBean() {
		return hshFormBean;
	}

	private boolean isIdenticalHandshapes(ArrayList<HandShapeImage> rhList, ArrayList<HandShapeImage> lhList) {
		if (rhList.size() == lhList.size()) {
			for (int i = 0; i < rhList.size(); i++) {
				HandShapeImage rImg = rhList.get(i);
				HandShapeImage lImg = lhList.get(i);
				String rId = rImg.getSS3FieldValue().getId();
				String lId = lImg.getSS3FieldValue().getId();

				if (!rId.equalsIgnoreCase(lId)) {
					return false;
				}
			}
			return true;
		} else {
			return false;
		}
	}

	private boolean isIdenticalStartEndHandshapes(ArrayList<HandShapeImage> list) {
		if (list.isEmpty()) {
			return true;
		}

		HandShapeImage fImg = list.get(0);
		HandShapeImage lImg = list.get(list.size() - 1);

		String rId = fImg.getSS3FieldValue().getId();
		String lId = lImg.getSS3FieldValue().getId();

		return rId.equalsIgnoreCase(lId);

	}

	private JPanel createGesturePanel() {
		JPanel panel = new JPanel(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		Insets zeroInsets = new Insets(0,0,0,0);
		Insets insets = new Insets(0,80,0,0);

		c.gridx = 0;
		c.gridy = 0;
		c.anchor = GridBagConstraints.WEST;
		panel.add(gestureLb, c);

		c.gridx++;
		c.weightx = 1;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.insets = insets;
		c.gridwidth = 3;
		panel.add(gestureLbField, c);
		
		c.gridx = 0;
		c.gridy++;
		c.weightx = 0;
		c.fill = GridBagConstraints.NONE;
		c.insets = zeroInsets;
		c.gridwidth =1;
		panel.add(uniqueNumberLb, c);
		
		c.gridx++;
		c.weightx = 1;
		c.gridwidth = 1;
		c.insets = insets;
		panel.add(uniqueNumberField, c);
		
		c.gridx++;
		c.insets = zeroInsets;
		c.gridwidth = 2;
		panel.add(showAllUniqueNumbersCheckbox, c);
		
		c.gridx = 0;
		c.gridy++;

		c.gridx += 2;
		c.weightx = 0;
		c.fill = GridBagConstraints.NONE;
		c.gridwidth = 1;

		c.gridx = 0;
		c.gridy++;
		panel.add(domHandLbl, c);

		c.gridx++;
		c.insets = insets;
		panel.add(domHandR, c);

		c.gridx++;
		c.insets = new Insets(0, 0, 0, 15);
		c.anchor = GridBagConstraints.CENTER;
		panel.add(domHandL, c);

		c.gridx++;
		c.insets = zeroInsets;
		panel.add(incompleteCheckbox, c);

		panel.setBorder(new EmptyBorder(5, 5, 5, 5));
		return panel;
	}

	private JPanel createPosPanel() {
		JPanel panel = new JPanel();

		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();

		panel.setLayout(gbl);

		gbc.anchor = GridBagConstraints.NORTHWEST;
		gbc.gridwidth = GridBagConstraints.REMAINDER;

		gbc.anchor = GridBagConstraints.NORTH;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0, 0, 10, 0);

		ButtonPanel buttonPanel = new ButtonPanel();
		buttonPanel.add(cancel);
		buttonPanel.add(enter);
//		buttonPanel.add(bypass);

		gbc.anchor = GridBagConstraints.SOUTH;
		gbc.insets = new Insets(15, 0, 0, 0);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		panel.add(buttonPanel, gbc);

		return panel;
	}

	private JPanel createCenterPanel() {
		JPanel panel = new JPanel();

		locationScrollPane = new JScrollPane(locationPanel);
		locationScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		locationScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		locationScrollPane.getVerticalScrollBar().setUnitIncrement(16);
		locationScrollPane.setBounds(50, 30, 300, 50);

		tabbedPane = new JTabbedPane();
		tabbedPane.addTab("Hands", hshPanel);
		tabbedPane.addTab("Location", locationScrollPane);

		tabbedPane.addTab("Gesture Properties", gstPanel);

		tabbedPane.addChangeListener(new ChangeListener() {
			@Override
			public void stateChanged(ChangeEvent e) {
				locationPanel.resetDialogs();
				if (isTwoHandedSelected()) {
					locationPanel.enableDOMandNDOM();
				}
				else {
					if (isCurrentGestureDominant()) {
						locationPanel.enableOnlyDOM();
						locationPanel.clearNDOMRegion();
					}
					else {
						locationPanel.enableOnlyNDOM();
						locationPanel.clearDOMRegion();
					}
				}
			}
		});
		panel.setLayout(new BorderLayout());
		panel.add(tabbedPane, BorderLayout.CENTER);
		return panel;
	}

	private void initUI() {
		JPanel gestPanel = createGesturePanel();
		JPanel posPanel = createPosPanel();
		JPanel cPanel = createCenterPanel();

		setLayout(new BorderLayout(0, 10));
		add(gestPanel, BorderLayout.NORTH);

		Dimension size = new Dimension(650, 600);
		cPanel.setMinimumSize(size);
		cPanel.setPreferredSize(size);
		add(cPanel, BorderLayout.CENTER);
		add(posPanel, BorderLayout.SOUTH);
	}

	@Override
	public void itemStateChanged(ItemEvent event) {
		removeAll();
		initUI();
		revalidate();
		parent.pack();
	}

	public boolean isChanged() {
		String gestText = gestureLbField.getText().trim();
		if (!gestText.equalsIgnoreCase(loadedProperties.getGestText())) {
			return true;
		}

		if(hshPanel.isTwoHandedSelected() != loadedProperties.isTwoHanded()) {
			return true;
		}

		GestureDomNdomHandshapesType sameDifHandshapes = hshPanel.getSelectedSameDifDomNdomHandshapes();
		GestureStartEndHandshapesType sameDifStartEndHandshapes = hshPanel.getSelectedSameDifStartEndHandshapes();
		GestureStartEndHandshapesType sameDifStartEndHandshapesL = hshPanel.getSelectedSameDifStartEndHandshapesNdom();
		GestureStartEndHandshapesType sameDifStartEndHandshapesR = hshPanel.getSelectedSameDifStartEndHandshapesDom();

		GestureDomNdomHandshapesType loadedSameDifHandshapes = loadedProperties.getSameDIfferentDomNdomHandshapes();
		GestureStartEndHandshapesType loadedSameDifStartEndHandshapes = loadedProperties.getSameDifStartEndHandshapes();
		GestureStartEndHandshapesType loadedSameDifStartEndHandshapesR = loadedProperties.getSameDifStartEndHandshapesR();
		GestureStartEndHandshapesType loadedSameDifStartEndHandshapesL = loadedProperties.getSameDifStartEndHandshapesL();

		
		if(sameDifHandshapes != loadedSameDifHandshapes) {
			return true;
		}

		if(sameDifStartEndHandshapes != loadedSameDifStartEndHandshapes) {
			return true;
		}

		if(sameDifStartEndHandshapesL != loadedSameDifStartEndHandshapesL) {
			return true;
		}

		if(sameDifStartEndHandshapesR != loadedSameDifStartEndHandshapesR) {
			return true;
		}

		ArrayList<HandShapeImage> selLeftHandShapes = hshPanel.getSelectedNdomHandshapesPane().getHandshapes();
		ArrayList<HandShapeImage> selRightHandShapes = hshPanel.getSelectedDomHandshapesPane().getHandshapes();

		ArrayList<HandShapeImage> selLeftHandShapes1 = loadedProperties.getLeftHandSelectedHandshapes();
		ArrayList<HandShapeImage> selRightHandShapes1 = loadedProperties.getRightHandSelectedHandshapes();
		
		ArrayList<FingerTipImage> selLeftFingerTipOrientations = hshPanel.getSelectedNdomHandshapesPane().getFingerTipOrientationsImages();
		ArrayList<FingerTipImage> selRightFingerTipOrientations = hshPanel.getSelectedDomHandshapesPane().getFingerTipOrientationsImages();

		ArrayList<FingerTipImage> selLeftFingerTipOrientations1 = loadedProperties.getLeftHandSelectedFingerTipOrientations();
		ArrayList<FingerTipImage> selRightFingerTipOrientations1 = loadedProperties.getRightHandSelectedFingerTipOrientations();

		ArrayList<PalmImage> selLeftPalmOrientations = hshPanel.getSelectedNdomHandshapesPane().getPalmOrientationsImages();
		ArrayList<PalmImage> selRightPalmOrientations = hshPanel.getSelectedDomHandshapesPane().getPalmOrientationsImages();

		ArrayList<PalmImage> selLeftPalmOrientations1 = loadedProperties.getLeftHandSelectedPalmOrientations();
		ArrayList<PalmImage> selRightPalmOrientations1 = loadedProperties.getRightHandSelectedPalmOrientations();

		

		if(selLeftHandShapes.isEmpty() != selLeftHandShapes1.isEmpty()) {
			return true;
		}

		if(selRightHandShapes.isEmpty() != selRightHandShapes1.isEmpty()) {
			return true;
		}

		if(selLeftFingerTipOrientations.isEmpty() != selLeftFingerTipOrientations1.isEmpty()) {
			return true;
		}

		if(selRightFingerTipOrientations.isEmpty() != selRightFingerTipOrientations1.isEmpty()) {
			return true;
		}
		if (selLeftPalmOrientations.isEmpty() != selLeftPalmOrientations1.isEmpty()) {
			return true;
		}
		if (selRightPalmOrientations.isEmpty() != selRightPalmOrientations1.isEmpty()) {
			return true;
		}

		int rHsSize1 = selRightHandShapes1.size();
		int rHsSize = selRightHandShapes.size();

		if(rHsSize1 != rHsSize) {
			if(rHsSize1 == 2 && rHsSize == 1) {
				HandShapeImage rHandShape11 = selRightHandShapes1.get(0);
				HandShapeImage rHandShape12 = selRightHandShapes1.get(1);
				HandShapeImage rHandShape = selRightHandShapes.get(0);
				String rHandShape11ID = rHandShape11.getSS3FieldValue().getId();
				String rHandShape12ID = rHandShape12.getSS3FieldValue().getId();
				if(!rHandShape11ID.equalsIgnoreCase(rHandShape12ID)) {
					return true;
				}
				String rHandShapeID = rHandShape.getSS3FieldValue().getId();
				if(!rHandShape11ID.equalsIgnoreCase(rHandShapeID)) {
					return true;
				}
			} else {
				return true;
			}
		}

		int i = 0 ;
		for(HandShapeImage rHandShape : selRightHandShapes) {
			HandShapeImage rHandShape1 = selRightHandShapes1.get(i);
			String rhShapeID = rHandShape.getSS3FieldValue().getId();
			String rhShapeID1 = rHandShape1.getSS3FieldValue().getId();
			if(!rhShapeID.equalsIgnoreCase(rhShapeID1)) {
				return true;
			}
			i++;
		}

		int lHsSize1 = selLeftHandShapes1.size();
		int lHsSize = selLeftHandShapes.size();

		if(lHsSize1 != lHsSize) {
			if(lHsSize1 == 2 && lHsSize == 1) {
				HandShapeImage lHandShape11 = selLeftHandShapes1.get(0);
				HandShapeImage lHandShape12 = selLeftHandShapes1.get(1);
				HandShapeImage lHandShape = selLeftHandShapes.get(0);
				String lHandShape11ID = lHandShape11.getSS3FieldValue().getId();
				String lHandShape12ID = lHandShape12.getSS3FieldValue().getId();
				if(!lHandShape11ID.equalsIgnoreCase(lHandShape12ID)) {
					return true;
				}
				String lHandShapeID = lHandShape.getSS3FieldValue().getId();
				if(!lHandShape11ID.equalsIgnoreCase(lHandShapeID)) {
					return true;
				}
			} else {
				return true;
			}
		}

		int j = 0 ;
		for(HandShapeImage lHandShape : selLeftHandShapes) {
			HandShapeImage lHandShape1 = selLeftHandShapes1.get(j);
			String lhShapeID = lHandShape.getSS3FieldValue().getId();
			String lhShapeID1 = lHandShape1.getSS3FieldValue().getId();
			if(!lhShapeID.equalsIgnoreCase(lhShapeID1)) {
				return true;
			}
			j++;
		}
		
		int rOSize1 = selRightFingerTipOrientations1.size();
		int rOSize = selRightFingerTipOrientations.size();

		if(rOSize1 != rOSize) {
			if(rOSize1 == 2 && rOSize == 1) {
				OrientationImage rFingerTipOrientation11 = selRightFingerTipOrientations1.get(0);
				OrientationImage rFingerTipOrientation12 = selRightFingerTipOrientations1.get(1);
				OrientationImage rFingerTipOrientation = selRightFingerTipOrientations.get(0);
				String rFingerTipOrientation11ID = rFingerTipOrientation11.getSS3FieldValue().getId();
				String rFingerTipOrientation12ID = rFingerTipOrientation12.getSS3FieldValue().getId();
				if(!rFingerTipOrientation11ID.equalsIgnoreCase(rFingerTipOrientation12ID)) {
					return true;
				}
				String rFingerTipOrientationID = rFingerTipOrientation.getSS3FieldValue().getId();
				if(!rFingerTipOrientation11ID.equalsIgnoreCase(rFingerTipOrientationID)) {
					return true;
				}
			} else {
				return true;
			}
		}

		i = 0 ;
		for(OrientationImage rFingerTipOrientation : selRightFingerTipOrientations) {
			OrientationImage rFingerTipOrientation1 = selRightFingerTipOrientations1.get(i);
			String rhOrientationID = rFingerTipOrientation.getSS3FieldValue().getId();
			String rhOrientationID1 = rFingerTipOrientation1.getSS3FieldValue().getId();
			if(!rhOrientationID.equalsIgnoreCase(rhOrientationID1)) {
				return true;
			}
			i++;
		}

		int lOSize1 = selLeftFingerTipOrientations1.size();
		int lOSize = selLeftFingerTipOrientations.size();

		if(lOSize1 != lOSize) {
			if(lHsSize1 == 2 && lHsSize == 1) {
				OrientationImage lOrientationFingerTip11 = selLeftFingerTipOrientations1.get(0);
				OrientationImage lOrientationFingerTip12 = selLeftFingerTipOrientations1.get(1);
				OrientationImage lOrientationFingerTip = selLeftFingerTipOrientations.get(0);
				String lOrientationFingerTip11ID = lOrientationFingerTip11.getSS3FieldValue().getId();
				String lOrientationFingerTip12ID = lOrientationFingerTip12.getSS3FieldValue().getId();
				if(!lOrientationFingerTip11ID.equalsIgnoreCase(lOrientationFingerTip12ID)) {
					return true;
				}
				String lOrientationID = lOrientationFingerTip.getSS3FieldValue().getId();
				if(!lOrientationFingerTip11ID.equalsIgnoreCase(lOrientationID)) {
					return true;
				}
			} else {
				return true;
			}
		}

		j = 0 ;
		for(OrientationImage lOrientationFingerTip : selLeftFingerTipOrientations) {
			OrientationImage lOrientationFingerTip1 = selLeftFingerTipOrientations1.get(j);
			String lhOrienationFingerTipID = lOrientationFingerTip.getSS3FieldValue().getId();
			String lhOrientationFingerTipID1 = lOrientationFingerTip1.getSS3FieldValue().getId();
			if(!lhOrienationFingerTipID.equalsIgnoreCase(lhOrientationFingerTipID1)) {
				return true;
			}
			j++;
		}


		int rPSize1 = selRightPalmOrientations1.size();
		int rPSize = selRightPalmOrientations.size();

		if (rPSize1 != rPSize) {
			if(rPSize1 == 2 && rPSize == 1) {
				OrientationImage rPalmOrientation11 = selRightPalmOrientations1.get(0);
				OrientationImage rPalmOrientation12 = selRightPalmOrientations1.get(1);
				OrientationImage rPalmOrientation = selRightPalmOrientations.get(0);
				String rPalmOrientation11ID = rPalmOrientation11.getSS3FieldValue().getId();
				String rPalmOrientation12ID = rPalmOrientation12.getSS3FieldValue().getId();
				if(!rPalmOrientation11ID.equalsIgnoreCase(rPalmOrientation12ID)) {
					return true;
				}
				String rPalmOrientationID = rPalmOrientation.getSS3FieldValue().getId();
				if(!rPalmOrientation11ID.equalsIgnoreCase(rPalmOrientationID)) {
					return true;
				}
			} else {
				return true;
			}
		}

		int k = 0 ;

		for(OrientationImage rPalmOrientation : selRightPalmOrientations) {
			OrientationImage rPalmOrientation1 = selRightPalmOrientations1.get(k);
			String rPalmOrientationID = rPalmOrientation.getSS3FieldValue().getId();
			String rPalmOrientationID1 = rPalmOrientation1.getSS3FieldValue().getId();
			if(!rPalmOrientationID.equalsIgnoreCase(rPalmOrientationID1)) {
				return true;
			}
			k++;
		}

		int lPSize1 = selLeftPalmOrientations1.size();
		int lPSize = selLeftPalmOrientations.size();

		if (lPSize1 != lPSize) {
			if(lPSize1 == 2 && lPSize == 1) {
				OrientationImage lPalmOrientation11 = selLeftPalmOrientations1.get(0);
				OrientationImage lPalmOrientation12 = selLeftPalmOrientations1.get(1);
				OrientationImage lPalmOrientation = selLeftPalmOrientations.get(0);
				String lPalmOrientation11ID = lPalmOrientation11.getSS3FieldValue().getId();
				String lPalmOrientation12ID = lPalmOrientation12.getSS3FieldValue().getId();
				if(!lPalmOrientation11ID.equalsIgnoreCase(lPalmOrientation12ID)) {
					return true;
				}
				String lPalmOrientationID = lPalmOrientation.getSS3FieldValue().getId();
				if(!lPalmOrientation11ID.equalsIgnoreCase(lPalmOrientationID)) {
					return true;
				}
			} else {
				return true;
			}
		}

		int l = 0 ;

		for(OrientationImage lPalmOrientation : selLeftPalmOrientations) {
			OrientationImage lPalmOrientation1 = selLeftPalmOrientations1.get(l);
			String lPalmOrientationID = lPalmOrientation.getSS3FieldValue().getId();
			String lPalmOrientationID1 = lPalmOrientation1.getSS3FieldValue().getId();
			if(!lPalmOrientationID.equalsIgnoreCase(lPalmOrientationID1)) {
				return true;
			}
			l++;
		}
		
		// GREG TODO: the below won't work as is - need a way to compare pre/post gesture properties
		GesturePropertyEntity oldGesturePropertyEntity = loadedProperties.getGesturePropertyEntity();
		GesturePropertyEntity currentGesturePropertyEntity = currentGestureEntity.getDependentGesturePropertyEntity();
		
		if (oldGesturePropertyEntity != null) {
			if ( ! oldGesturePropertyEntity.equals(currentGesturePropertyEntity)) {
				return false;
			}
		}

		return false;
	}

	public boolean saveChanges(SignBankVariant variant) {
		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);
		GestureEventsEntity sEntity = (GestureEventsEntity) mediaToolBar.selectedEntity();

		if (sEntity == null) {
			sEntity = wrapper.getGestureField()
					.getGestureEventsEntityCollection()
					.getSelectedEntity();
		}

		GestureEntityProperties properties = sEntity.getGestureEntityProperties();

		properties.setVerifiedFromSignBank(true);

		// compare against the defaultOccurrence - from which we get the source resource
		SignBankOccurrence defaultOccurrence = variant.getDefaultOccurrence();
		String sourceResource = defaultOccurrence.getSignBankResourceFileName();
		properties.setSourceResource(sourceResource);

		String mainGestureID = ""; // variant.getParentMainGesture().getMainGestureID();
		String variantID = variant.getVariantID();
		String occurrenceID = defaultOccurrence.getOccurrenceID();
		properties.setMainGestureID(mainGestureID);
		properties.setVariantID(variantID);
		properties.setOccurrenceID(occurrenceID);

		ArrayList<HandShapeImage> domImages, nondomImages;
		int domImagesSize, nondomImagesSize;

		if (isDominantHandRight()) {
			domImages = hshPanel.getSelectedDomHandshapesPane().getHandshapes();
			nondomImages = hshPanel.getSelectedNdomHandshapesPane().getHandshapes();
		} else {
			domImages = hshPanel.getSelectedNdomHandshapesPane().getHandshapes();
			nondomImages = hshPanel.getSelectedDomHandshapesPane().getHandshapes();
		}
		domImagesSize = domImages.size();
		nondomImagesSize = nondomImages.size();

		String domStartHS = null;
		String nondomStartHS = null;
		String domEndHS = null;
		String nondomEndHS = null;

		if (domImagesSize > 0) {
			domStartHS = domImages.get(0).getSS3FieldValue().getLabel();
			domEndHS = domImages.get(domImagesSize - 1).getSS3FieldValue().getLabel();
		}

		if (nondomImagesSize > 0) {
			nondomStartHS = nondomImages.get(0).getSS3FieldValue().getLabel();
			nondomEndHS = nondomImages.get(nondomImagesSize - 1).getSS3FieldValue().getLabel();
		}

		String occDomStartHS = defaultOccurrence.getDomStartHS();
		String occNondomStartHS = defaultOccurrence.getNondomStartHS();
		String occDomEndHS = defaultOccurrence.getDomEndHS();
		String occNondomEndHS = defaultOccurrence.getNondomEndHS();

		String occLeftRightHS = defaultOccurrence.getLeftRightHS();
		String occStartEndHS = defaultOccurrence.getStartEndHS();
		String occStartEndLeftHS = defaultOccurrence.getStartEndLeftHS();
		String occStartEndRightHS = defaultOccurrence.getStartEndRightHS();

		boolean occTwoHanded = defaultOccurrence.isTwoHanded();
		boolean occMarkedHands = defaultOccurrence.isMarkedHands();
		boolean occPassiveBaseArm = defaultOccurrence.isPassiveBaseArm();

		String occSignType = defaultOccurrence.getSignType();

		boolean differingFromOccurrence = false;

		if (occDomStartHS != null && domStartHS != null && !occDomStartHS.equals(domStartHS))
			differingFromOccurrence = true;
		if (occNondomStartHS != null && nondomStartHS != null && !occNondomStartHS.equals(nondomStartHS))
			differingFromOccurrence = true;
		if (occDomEndHS != null && domEndHS != null && !occDomEndHS.equals(domEndHS))
			differingFromOccurrence = true;
		if (occNondomEndHS != null && nondomEndHS != null && !occNondomEndHS.equals(nondomEndHS))
			differingFromOccurrence = true;

		GestureDomNdomHandshapesType domNdomHS = hshPanel.getSelectedSameDifDomNdomHandshapes();
		GestureStartEndHandshapesType startEndHS = hshPanel.getSelectedSameDifStartEndHandshapes();
		GestureStartEndHandshapesType startEndLeftHS = hshPanel.getSelectedSameDifStartEndHandshapesNdom();
		GestureStartEndHandshapesType startEndRightHS = hshPanel.getSelectedSameDifStartEndHandshapesDom();
		
		boolean twoHanded = hshPanel.isTwoHandedSelected();
		boolean markedHands = hshPanel.isMarkedNumberOfHands();
		boolean passiveBaseArm = hshPanel.isPassiveBaseArm();

		String signType = null;
		if (hshPanel.isLexical())
			signType = "LEXICAL";
		if (hshPanel.isFingerspelled())
			signType = "FINGERSPELLED";
		if (hshPanel.isLoan())
			signType = "LOAN";
		if (hshPanel.isNumber())
			signType = "NUMBER";
		if (hshPanel.isClassifier())
			signType = "CLASSIFER";
		if (hshPanel.isGesture())
			signType = "GESTURE";

		if (occLeftRightHS != null) {
			if (occLeftRightHS.equals("SAME") && domNdomHS != GestureDomNdomHandshapesType.SAME) {
				differingFromOccurrence = true;

				if (occStartEndHS != null) {
					if (occStartEndHS.equals("SAME") && startEndHS != GestureStartEndHandshapesType.SAME)
						differingFromOccurrence = true;
					else if (occStartEndHS.equals("DIFFERENT") && startEndHS != GestureStartEndHandshapesType.DIFFERENT)
						differingFromOccurrence = true;
				}
			} else if (occLeftRightHS.equals("DIFFERENT") && domNdomHS != GestureDomNdomHandshapesType.DIFFERENT) {
				differingFromOccurrence = true;

				if (occStartEndLeftHS != null) {
					if (occStartEndLeftHS.equals("SAME") && startEndLeftHS != GestureStartEndHandshapesType.SAME)
						differingFromOccurrence = true;
					else if (occStartEndLeftHS.equals("DIFFERENT") && startEndLeftHS != GestureStartEndHandshapesType.DIFFERENT)
						differingFromOccurrence = true;
				}

				if (occStartEndRightHS != null) {
					if (occStartEndRightHS.equals("SAME") && startEndRightHS != GestureStartEndHandshapesType.SAME)
						differingFromOccurrence = true;
					else if (occStartEndRightHS.equals("DIFFERENT") && startEndRightHS != GestureStartEndHandshapesType.DIFFERENT)
						differingFromOccurrence = true;
				}
			}
		}

		if (occTwoHanded != twoHanded)
			differingFromOccurrence = true;

		if (occMarkedHands != markedHands)
			differingFromOccurrence = true;

		if (occPassiveBaseArm != passiveBaseArm)
			differingFromOccurrence = true;

		if ( !occSignType.equals(signType))
			differingFromOccurrence = true;

		properties.setDifferingFromOccurrence(differingFromOccurrence);

		// we need to set the same sign bank properties on the dependent (other hand) gloss entity
		// because on "file open" both hands (both SS3Track objects) will be need to be parsed separately
		// (there could be one handed signs on the nondominant hand - an unlikely but possible use case)
		GestureEventsEntity dependentEntity = sEntity.getDependentGestureEntity();
		if (dependentEntity != null) {
			GestureEntityProperties dependentProperties = dependentEntity.getGestureEntityProperties();
			dependentProperties.setVerifiedFromSignBank(true);
			dependentProperties.setSourceResource(sourceResource);
			dependentProperties.setDifferingFromOccurrence(differingFromOccurrence);
			dependentProperties.setMainGestureID(mainGestureID);
			dependentProperties.setVariantID(variantID);
			dependentProperties.setOccurrenceID(occurrenceID);
		}

		updateChanges();
		
		return true;
	}

	protected boolean updateChanges() {
		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);

		if (currentGestureEntity == null) {
			currentGestureEntity = wrapper.getGestureField()
					.getGestureEventsEntityCollection()
					.getSelectedEntity();
			boolean rightHanded = true;
			var parentEntities = currentGestureEntity.getParentEntities();
			for (PresentationEventsEntity parentEntity : parentEntities) {
				SS3GlossWindowItem windowItem = parentEntity.getSS3GlossWindowItem();
				SS3TemporalPartition partition = currentGestureEntity.getSignStreamSegmentPanel().getSS3Database()
						.getSS3GlossWindow().getTemporalPartitionByLabel(windowItem.getPartitionLabel());
				SS3GlossWindowSegment segment = partition.getTemporalPartitionSegmentByLabel(windowItem.getSegmentLabel());
				if (segment.getParticipant() != null && !segment.getParticipant().isDominantHandRight()) {
					rightHanded = false;
				}
			}
			currentPartipantRightHanded = rightHanded;
		}

		// (re-)setting unique number, if applicable
		String potentialUniqueNumberStr = uniqueNumberField.getText();
		if (potentialUniqueNumberStr == null || potentialUniqueNumberStr.isBlank() || !Pattern.matches("^[0-9]+$", potentialUniqueNumberStr)) {
			SS3Singleton.getErrorMessages().showErrorMessage(
					ErrorMessages.GESTURE_UNIQUE_NUMBER_NOT_NULL_OR_STRING);
			return false;
		}

		int potentialUniqueNumber = 0;
		try {
			potentialUniqueNumber = Integer.parseInt(potentialUniqueNumberStr);
		} catch (NumberFormatException ex) {
			SS3Singleton.getErrorMessages().showErrorMessage(
					ErrorMessages.GESTURE_UNIQUE_NUMBER_NOT_LARGER_THAN_INT);
			return false;
		}

		boolean success = currentGestureWindowSegment.setGestureUniqueNumber(currentGestureEntity, potentialUniqueNumber);
		if (!success) {
			SS3Singleton.getErrorMessages().showErrorMessage(
					ErrorMessages.GESTURE_UNIQUE_NUMBER_COLLISION);
			return false;
		}

		GestureEventsEntity depGestEntity = currentGestureEntity.getDependentGestureEntity();
		GestureEvent selectedTextEvent = (GestureEvent) currentGestureEntity.getTextValue();
		GestureClassifications gestClassification = selectedTextEvent.getGestureClassifications();

		GestureEntityProperties properties = currentGestureEntity.getGestureEntityProperties();

		if (hshPanel.isFingerspelled()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_FINGERSPELLED);
		} else if (hshPanel.isLoan()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_LOAN);
		} else if (hshPanel.isNumber()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_NUMBERS);
		} else if (hshPanel.isLexical()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_LEXICAL);
		} else if (hshPanel.isClassifier()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_CLASSIFIER);
		} else if (hshPanel.isGesture()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_GESTURE);
		}

		gestClassification.setNameSign(hshPanel.isNameSign());
		gestClassification.setOneFrameGesture(hshPanel.isOneFrameEntity());
		gestClassification.setPassiveBaseArm(hshPanel.isPassiveBaseArm());
		gestClassification.setMarkedNumberOfHands(hshPanel.isMarkedNumberOfHands());

		properties.setOneFrameGesture(hshPanel.isOneFrameEntity());

		currentGestureEntity.setIncompleteGesture(incompleteCheckbox.isSelected());
//		currentGestureEntity.setShowUniqueNumber(showUniqueNumberCheckbox.isSelected());

		currentGestureWindowSegment.setShowAllGestureCounters(showAllUniqueNumbersCheckbox.isSelected());
		currentGestureWindowSegment.showAllGestureCounters();
//		currentGlossWindowSegment.setDefaultShowGestureCounters(defaultShowUniqueNumbersCheckbox.isSelected());

		String fieldID = null;

		Field field = SS3Singleton.getMediaToolBar(null).selectedField();
		if (field != null) {
			fieldID = field.getFieldID();
		}

		if (fieldID == null) {
			EventsEntity ent = SS3Singleton.getMediaToolBar(null).selectedEntity();

			if (ent == null)
				return false;

			GestureEventsEntity entity = (GestureEventsEntity) ent;
			fieldID = entity.getField().getFieldID();
		}

		LabelObject gestLabelObj = view.getSegment().getRootLabelObject().getGestureLabelObject();

		String newID = fieldID.equalsIgnoreCase(Util.DOM_GESTURE_FIELD_ID) ? Util.NDOM_GESTURE_FIELD_ID : Util.DOM_GESTURE_FIELD_ID;

		GestureFieldWrapper depGestWrapper = (GestureFieldWrapper) gestLabelObj.getChildWithFieldID(newID).getWrapper();

		String domGesturePropertyFieldId = Util.DOM_GESTURE_PROPERTY_FIELD_ID;
		GesturePropertyFieldWrapper domGesturePropertyWrapper
				= (GesturePropertyFieldWrapper) gestLabelObj.getChildWithFieldID(domGesturePropertyFieldId).getWrapper();
		if (domGesturePropertyWrapper == null)
			domGesturePropertyWrapper = (GesturePropertyFieldWrapper) gestLabelObj.getChildWithFieldID(domGesturePropertyFieldId).getWrapper();

		String ndomGesturePropertyFieldId = Util.NDOM_GESTURE_PROPERTY_FIELD_ID;
		GesturePropertyFieldWrapper ndomGesturePropertyWrapper
				= (GesturePropertyFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGesturePropertyFieldId).getWrapper();
		if (ndomGesturePropertyWrapper == null)
			ndomGesturePropertyWrapper = (GesturePropertyFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGesturePropertyFieldId).getWrapper();

		boolean isTwoHanded = hshPanel.isTwoHandedSelected();
		if (isTwoHanded) {
			if (depGestEntity != null) {
				String text = currentGestureEntity.getText();
				depGestEntity.getTextValue().setText(text);
				depGestEntity.getGestureEntityProperties().setTwoHanded(true);
				depGestEntity.setIncompleteGesture(currentGestureEntity.getIncompleteGesture());
				depGestEntity.setShowUniqueNumber(currentGestureEntity.getShowUniqueNumber());
				depGestEntity.setUniqueNumber(currentGestureEntity.getUniqueNumber());
			} else {
				GestureField gestField = (GestureField) depGestWrapper.getField();

				ArrayList<GestureEventsEntity> entities = gestField.getEntitiesInInterval(currentGestureEntity.interval(), Bound.EXCLUSIVE);

				if (entities.isEmpty()) {
					GestureChainedEventsCollection chainedEventsCollection = new GestureChainedEventsCollection();

					GestureEvent ndTextEvent = new GestureEvent(
							currentGestureEntity.getSignStreamSegmentPanel());
					ndTextEvent.setStartTimeInfo(selectedTextEvent.getStartTimeInfo());
					ndTextEvent.setEndTimeInfo(selectedTextEvent.getEndTimeInfo());
					ndTextEvent.setText(selectedTextEvent.getText());


					chainedEventsCollection.setTextValueEvent(ndTextEvent);
					depGestEntity = new GestureEventsEntity(chainedEventsCollection, currentGestureEntity.getSignStreamSegmentPanel(), gestField);
					depGestEntity.updateParentEntity();
					depGestEntity.setCorrespondingGestureEntityID(currentGestureEntity.getID());
					currentGestureEntity.setCorrespondingGestureEntityID(depGestEntity.getID());
					currentGestureEntity.setDependentGestureEntity(depGestEntity);
					depGestEntity.setDependentGestureEntity(currentGestureEntity);
					depGestEntity.getGestureEntityProperties().setTwoHanded(true);
					depGestEntity.setIncompleteGesture(currentGestureEntity.getIncompleteGesture());
					depGestEntity.setShowUniqueNumber(currentGestureEntity.getShowUniqueNumber());
					depGestEntity.setUniqueNumber(currentGestureEntity.getUniqueNumber());

					currentGestureEntity.setLockedDomNdomAlignments(true);
					depGestEntity.setLockedDomNdomAlignments(true);
					depGestWrapper.getGestureField().addGestureEventsEntity(depGestEntity);

				} else {
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CHAINS_CANNOT_OVERLAP);
					return false;
				}
			}

		} else {
			currentGestureEntity.setLockedDomNdomAlignments(false);

			// delete second gloss and related
			if (depGestEntity != null) {
				depGestWrapper.getGestureField().deleteEntity(depGestEntity);

				GestureChainedEventsEntity depHandEntity = depGestEntity.getDependentHandEntity();
				GestureHandShapeEntity depHandShapeEntity = depGestEntity.getDependentHandShapeEntity();
				GestureOrientationEntity depFingerTipOrientationEntity = depGestEntity.getDependentFingerTipOrientationEntity();
				GestureOrientationEntity depPalmOrientationEntity = depGestEntity.getDependentPalmOrientationEntity();
				
				ApexChainedApexEventsEntity depApexEntity = depGestEntity.getDependentApexEntity();

				GestureDomNdomHandFieldWrapper depHandWrapper;
				GestureOrientationFieldWrapper depOrnFingerTipWrapper;
				
				ApexFieldWrapper depApexWrapper;

				if (depGestWrapper.getGestureField().getFieldID().equalsIgnoreCase(Util.DOM_GESTURE_FIELD_ID)) {
					depHandWrapper = (GestureDomNdomHandFieldWrapper) gestLabelObj.getChildWithFieldID(Util.DOM_GESTURE_HAND_FIELD_ID).getWrapper();
					depOrnFingerTipWrapper = (GestureOrientationFieldWrapper) gestLabelObj.getChildWithFieldID(Util.DOM_GESTURE_ORIENTATION_FINGER_TIP_FIELD_ID).getWrapper();
					depApexWrapper = (ApexFieldWrapper)  gestLabelObj.getChildWithFieldID(Util.DOM_GESTURE_APEX_FIELD_ID).getWrapper();
				} else {
					depHandWrapper = (GestureDomNdomHandFieldWrapper) gestLabelObj.getChildWithFieldID(Util.NDOM_GESTURE_HAND_FIELD_ID).getWrapper();
					depOrnFingerTipWrapper = (GestureOrientationFieldWrapper) gestLabelObj.getChildWithFieldID(Util.NDOM_GESTURE_ORIENTATION_FINGER_TIP_FIELD_ID).getWrapper();
					depApexWrapper = (ApexFieldWrapper)  gestLabelObj.getChildWithFieldID(Util.NDOM_GESTURE_APEX_FIELD_ID).getWrapper();
				}

				if (depHandEntity != null) {
					GestureDomNdomHandField rl = (GestureDomNdomHandField) depHandWrapper.getField();
					rl.deleteEntity(depHandEntity);
				}

				if (depHandShapeEntity != null) {
					depHandShapeEntity.getField().deleteEntity(depHandShapeEntity);
				}
				
				if (depFingerTipOrientationEntity != null) {
					depOrnFingerTipWrapper.getField().deleteEntity(depFingerTipOrientationEntity);
				}

				if (depPalmOrientationEntity != null) {
					depOrnFingerTipWrapper.getField().deleteEntity(depPalmOrientationEntity);
				}

				if (depApexEntity != null) {
					depApexWrapper.getField().deleteEntity(depApexEntity);
				}
				GestureLocationEntity depLocEntity = depGestEntity.getDependentLocationEntity();
				if (depLocEntity != null) {
					GestureLocationFieldWrapper domLocWrapper = (GestureLocationFieldWrapper) gestLabelObj.getChildWithFieldID(Util.DOM_GESTURE_LOCATION_FIELD_ID).getWrapper();
					GestureLocationFieldWrapper ndomLocWrapper = (GestureLocationFieldWrapper) gestLabelObj.getChildWithFieldID(Util.NDOM_GESTURE_LOCATION_FIELD_ID).getWrapper();
					if (wrapper.getGestureField().getFieldID().equals(Util.NDOM_GESTURE_FIELD_ID)) {

						// GD: copying the above sign type block, but for locations - in case it is ever necessary
						if (domLocWrapper == null || ndomLocWrapper == null) {
							ArrayList<LabelObject> arr = view.getLabelView().getLabels();
							LabelObject domLocObj = null, ndomLocObj = null;
							for (LabelObject obj : arr) {
								if (obj.getFieldID().equals(Util.DOM_GESTURE_LOCATION_FIELD_ID))
									domLocObj = obj;
								else if (obj.getFieldID().equals(Util.NDOM_GESTURE_LOCATION_FIELD_ID))
									ndomLocObj = obj;
							}

							if (domLocObj != null)
								domLocWrapper = (GestureLocationFieldWrapper) domLocObj.getWrapper();
							if (ndomLocObj != null)
								ndomLocWrapper = (GestureLocationFieldWrapper) ndomLocObj.getWrapper();
						}
					}
					GestureLocationFieldWrapper lfWrapper = !this.isCurrentGestureDominant() ? domLocWrapper : ndomLocWrapper;
					setLocEntityToNull(depGestEntity, depLocEntity, lfWrapper);
				}
				depGestEntity = null;
			}
		}

		getGesturePropertyPanel().setSelectedGestureProperties();

		// begin block: this block (up until below) was above, but the check for going to 2-handed should occur first
		if (hshPanel.isTwoHandedSelected()) {
			gestClassification.setNumberOfHands(2);
			properties.setTwoHanded(true);
		} else {
			gestClassification.setNumberOfHands(1);
			properties.setTwoHanded(false);
		}

		GestureDomNdomHandshapesType handshapeClassification = hshPanel.getSelectedSameDifDomNdomHandshapes();
		boolean sameHandshapes = handshapeClassification == GestureDomNdomHandshapesType.SAME;

		gestClassification.setSameHandshapes(sameHandshapes);

		if (sameHandshapes) {
			GestureStartEndHandshapesType sameDiffStartEndHandshapes = hshPanel.getSelectedSameDifStartEndHandshapes();
			gestClassification.setDomHandShapesSameDifferent(sameDiffStartEndHandshapes);
			gestClassification.setNondomHandShapesSameDifferent(sameDiffStartEndHandshapes);
		} else {
			GestureStartEndHandshapesType sameDifStartEndHandshapesL = hshPanel.getSelectedSameDifStartEndHandshapesNdom();
			GestureStartEndHandshapesType sameDifStartEndHandshapesR = hshPanel.getSelectedSameDifStartEndHandshapesDom();

			if (isDominantHandRight()) {
				gestClassification.setDomHandShapesSameDifferent(sameDifStartEndHandshapesR);
				gestClassification.setNondomHandShapesSameDifferent(sameDifStartEndHandshapesL);
			} else {
				gestClassification.setDomHandShapesSameDifferent(sameDifStartEndHandshapesL);
				gestClassification.setNondomHandShapesSameDifferent(sameDifStartEndHandshapesR);
			}
		}
		// end block

		GestureEntityProperties properties2 = null;

		if (depGestEntity != null)
			properties2 = depGestEntity.getGestureEntityProperties();

		if (hshPanel.isFingerspelled()) {
			properties.setFingerspelled();
			if (properties2 != null)
				properties2.setFingerspelled();
		} else if (hshPanel.isLoan()) {
			properties.setLoan();
			if (properties2 != null)
				properties2.setLoan();
		} else if (hshPanel.isNumber()) {
			properties.setNumber();
			if (properties2 != null)
				properties2.setNumber();
		} else if (hshPanel.isLexical()) {
			properties.setLexical();
			if (properties2 != null)
				properties2.setLexical();
		} else if (hshPanel.isClassifier()) {
			properties.setClassifier();
			if (properties2 != null)
				properties2.setClassifier();
		} else if (hshPanel.isGesture()) {
			properties.setGesture();
			if (properties2 != null)
				properties2.setGesture();
		}

		properties.setNameSign(hshPanel.isNameSign());
		properties.setDominantHand(dominantHand);
		properties.setMarkedNumberOfHands(hshPanel.isMarkedNumberOfHands());
		properties.setPassiveBaseArm(hshPanel.isPassiveBaseArm());

		if (properties2 != null) {
			properties2.setNameSign(hshPanel.isNameSign());
			properties2.setDominantHand(dominantHand);
			properties2.setMarkedNumberOfHands(hshPanel.isMarkedNumberOfHands());
			properties2.setPassiveBaseArm(hshPanel.isPassiveBaseArm());
		}

		String text = gestureLbField.getText().trim();

		currentGestureEntity.getGestureChainedEvent().setText(text);

		if (depGestEntity != null) {
			depGestEntity.getGestureChainedEvent().setText(text);
		}

		HandShapeFormBean hspBean = hshPanel.getHandShapeBean();
		addOrUpdateHandShapes(hspBean, currentGestureEntity, gestLabelObj);

		if (depGestEntity != null) {
			Event event = currentGestureEntity.getValueOrTextValueEvent();
			GestureChainedEvent preparation = currentGestureEntity.getPreparation();
			GestureChainedEvent prestrokeHold = currentGestureEntity.getPrestrokeHold();
			GestureChainedEvent retraction = currentGestureEntity.getRetraction();
			GestureChainedEvent poststrokeHold = currentGestureEntity.getPoststrokeHold();
			GestureChainedEvent relaxed = currentGestureEntity.getRelaxed();

			Event ndEvent = depGestEntity.getValueOrTextValueEvent();
			GestureChainedEvent ndPreparation = depGestEntity.getPreparation();
			GestureChainedEvent ndPrestrokeHold = depGestEntity.getPrestrokeHold();
			GestureChainedEvent ndRetraction = depGestEntity.getRetraction();
			GestureChainedEvent ndPoststrokeHold = depGestEntity.getPoststrokeHold();
			GestureChainedEvent ndRelaxed = depGestEntity.getRelaxed();

			if (currentGestureEntity.isLockedDomNdomAlignments() && depGestEntity.isLockedDomNdomAlignments()) {
				ndEvent.setStartTimeInfo(event.getStartTimeInfo());
				ndEvent.setEndTimeInfo(event.getEndTimeInfo());

				SignStreamSegmentPanel panel = wrapper.getField()
						.getSignStreamSegmentPanel();

				if (prestrokeHold != null) {
					if (ndPrestrokeHold != null) {
						ndPrestrokeHold.setStartTimeInfo(prestrokeHold.getStartTimeInfo());
						ndPrestrokeHold.setEndTimeInfo(prestrokeHold.getEndTimeInfo());
					} else {
						ndPrestrokeHold = new GestureChainedEvent(panel);
						ndPrestrokeHold.setStartTimeInfo(prestrokeHold.getStartTimeInfo());
						ndPrestrokeHold.setEndTimeInfo(prestrokeHold.getEndTimeInfo());
						depGestEntity.setPrestrokeHoldEvent(ndPrestrokeHold);
					}
				} else {
					depGestEntity.setPrestrokeHoldEvent(null);
				}

				if (preparation != null) {
					if (ndPreparation != null) {
						ndPreparation.setStartTimeInfo(preparation.getStartTimeInfo());
						ndPreparation.setEndTimeInfo(preparation.getEndTimeInfo());
					} else {
						ndPreparation = new GestureChainedEvent(panel);
						ndPreparation.setStartTimeInfo(preparation.getStartTimeInfo());
						ndPreparation.setEndTimeInfo(preparation.getEndTimeInfo());
						depGestEntity.setPreparationEvent(ndPreparation);
					}
				} else {
					depGestEntity.setPreparationEvent(null);
				}

				if (poststrokeHold != null) {
					if (ndPoststrokeHold != null) {
						ndPoststrokeHold.setStartTimeInfo(poststrokeHold.getStartTimeInfo());
						ndPoststrokeHold.setEndTimeInfo(poststrokeHold.getEndTimeInfo());
					} else {
						ndPoststrokeHold = new GestureChainedEvent(panel);
						ndPoststrokeHold.setStartTimeInfo(poststrokeHold.getStartTimeInfo());
						ndPoststrokeHold.setEndTimeInfo(poststrokeHold.getEndTimeInfo());
						depGestEntity.setPoststrokeHoldEvent(ndPoststrokeHold);
					}
				} else {
					depGestEntity.setPoststrokeHoldEvent(null);
				}

				if (retraction != null) {
					if (ndRetraction != null) {
						ndRetraction.setStartTimeInfo(retraction.getStartTimeInfo());
						ndRetraction.setEndTimeInfo(retraction.getEndTimeInfo());
					} else {
						ndRetraction = new GestureChainedEvent(panel);
						ndRetraction.setStartTimeInfo(retraction.getStartTimeInfo());
						ndRetraction.setEndTimeInfo(retraction.getEndTimeInfo());
						depGestEntity.setRetractionEvent(ndRetraction);
					}
				} else {
					depGestEntity.setRetractionEvent(null);
				}

				if (relaxed != null) {
					if (ndRelaxed != null) {
						ndRelaxed.setStartTimeInfo(relaxed.getStartTimeInfo());
						ndRelaxed.setEndTimeInfo(relaxed.getEndTimeInfo());
					} else {
						ndRelaxed = new GestureChainedEvent(panel);
						ndRelaxed.setStartTimeInfo(relaxed.getStartTimeInfo());
						ndRelaxed.setEndTimeInfo(relaxed.getEndTimeInfo());
						depGestEntity.setRelaxedEvent(ndRelaxed);
					}
				} else {
					depGestEntity.setRelaxedEvent(null);
				}
			}
		}

		properties.clearHandshapeInformation();

		if (hshPanel.isTwoHandedSelected()) {
			properties2.clearHandshapeInformation();
			if (handshapeClassification == GestureDomNdomHandshapesType.SAME) {
				properties.setTwoHandedHandshapesClassification(GestureEntityProperties.SAME_HANDSHAPES_DOM_NDOM);
				properties2.setTwoHandedHandshapesClassification(GestureEntityProperties.SAME_HANDSHAPES_DOM_NDOM);
				GestureStartEndHandshapesType sameDiffHandshapes = hshPanel.getSelectedSameDifStartEndHandshapes();
				if (sameDiffHandshapes == GestureStartEndHandshapesType.SAME) {
					properties.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
					properties2.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
				} else {
					properties.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
					properties2.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
				}
			} else if (handshapeClassification == GestureDomNdomHandshapesType.ALTERNATING) {
				properties.setTwoHandedHandshapesClassification(GestureEntityProperties.ALTERNATING_SAME_HANDSHAPES_DOM_NDOM);
				properties2.setTwoHandedHandshapesClassification(GestureEntityProperties.ALTERNATING_SAME_HANDSHAPES_DOM_NDOM);
				GestureStartEndHandshapesType sameDiffHandshapes = hshPanel.getSelectedSameDifStartEndHandshapes();
				if (sameDiffHandshapes == GestureStartEndHandshapesType.SAME) {
					properties.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
					properties2.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
				} else {
					properties.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
					properties2.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
				}
			} else {
				properties.setTwoHandedHandshapesClassification(GestureEntityProperties.DIFFERENT_HANDSHAPES_DOM_NDOM);
				properties2.setTwoHandedHandshapesClassification(GestureEntityProperties.DIFFERENT_HANDSHAPES_DOM_NDOM);

				GestureStartEndHandshapesType selectedStartEndHandshapeR = hshPanel.getSelectedSameDifStartEndHandshapesDom();
				GestureStartEndHandshapesType selectedStartEndHandshapeL = hshPanel.getSelectedSameDifStartEndHandshapesNdom();

				if (selectedStartEndHandshapeR == GestureStartEndHandshapesType.SAME) {
					properties.setStartEndHandshapeDomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
					properties2.setStartEndHandshapeDomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
				} else {
					properties.setStartEndHandshapeDomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
					properties2.setStartEndHandshapeDomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
				}

				if (selectedStartEndHandshapeL == GestureStartEndHandshapesType.SAME) {
					properties.setStartEndHandshapeNdomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
					properties2.setStartEndHandshapeNdomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
				} else {
					properties.setStartEndHandshapeNdomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
					properties2.setStartEndHandshapeNdomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
				}
			}
		} else {
			GestureStartEndHandshapesType sameDiffHandshapes = hshPanel.getSelectedSameDifStartEndHandshapes();
			if (sameDiffHandshapes == GestureStartEndHandshapesType.SAME) {
				properties.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
			} else {
				properties.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
			}
		}

		if (!properties.isTwoHanded()) {
			currentGestureEntity.setDependentGestureEntity(null);
			currentGestureEntity.setCorrespondingGestureEntityID(null);
		}

		if (depGestEntity != null && depGestEntity.isLockedGesturePhonAlignments()) { //check if locked to hand shape
			Event valueOrTextEvent = depGestEntity.getValueOrTextValueEvent();
			
			Time startTimeInfo = valueOrTextEvent.getStartTimeInfo();
			Time endTimeInfo = valueOrTextEvent.getEndTimeInfo();
			
			Event initialHoldEvent = depGestEntity.getPrestrokeHold();
			startTimeInfo = initialHoldEvent != null 
					? initialHoldEvent.getStartTimeInfo() 
							: valueOrTextEvent.getStartTimeInfo();
			
			Event finalHoldEvent = depGestEntity.getPoststrokeHold();
			endTimeInfo = finalHoldEvent != null 
					? finalHoldEvent.getEndTimeInfo() 
							: valueOrTextEvent.getEndTimeInfo();

			GestureChainedEventsEntity depHandEntity = depGestEntity.getDependentHandEntity();
			if (depHandEntity != null) {
				depHandEntity.setStartTimeInfo(startTimeInfo);
				depHandEntity.setEndTimeInfo(endTimeInfo);
			}
			
			GestureHandShapeEntity depHandShapeEntity = depGestEntity.getDependentHandShapeEntity();
			if (depHandShapeEntity != null) {
				MediaToolbarCommons.setGestureHandshapeStartTime(depHandShapeEntity, startTimeInfo);
				MediaToolbarCommons.setGestureHandshapeEndTime(depHandShapeEntity, endTimeInfo);
			}
			
			GestureOrientationEntity depFingertipOrientationEntity = depGestEntity.getDependentFingerTipOrientationEntity();
			if (depFingertipOrientationEntity != null) {
				MediaToolbarCommons.setGestureOrientationStartTime(depFingertipOrientationEntity, startTimeInfo);
				MediaToolbarCommons.setGestureOrientationEndTime(depFingertipOrientationEntity, endTimeInfo);
			}
			
			GestureOrientationEntity depPalmOrientationEntity = depGestEntity.getDependentPalmOrientationEntity();
			if (depPalmOrientationEntity != null) {
				MediaToolbarCommons.setGestureOrientationStartTime(depPalmOrientationEntity, startTimeInfo);
				MediaToolbarCommons.setGestureOrientationEndTime(depPalmOrientationEntity, endTimeInfo);
			}
		}

//		if (currentGestureEntity != null && currentGestureEntity.isLockedGesturePhonAlignments()) { //check if locked to hand shape
//			Event preStrokeHold = currentGestureEntity.getPrestrokeHold();
//			Event postStrokeHold = currentGestureEntity.getPoststrokeHold();
//
//			if(preStrokeHold != null) {
//				Time initialStartMovieTimeInfo = preStrokeHold.getStartTimeInfo();
//				currentGestureEntity.getDependentHandEntity().setStartTimeInfo(initialStartMovieTimeInfo);
//				currentGestureEntity.getDependentHandShapeEntity().getFirstGestureHandShapeEvent().setStartTimeInfo(initialStartMovieTimeInfo);
//				currentGestureEntity.getDependentHandShapeEntity().getFirstGestureHandShapeEvent().setEndTimeInfo(initialStartMovieTimeInfo);
//			}
//			if(postStrokeHold != null) {
//				Time finalEndMovieTimeInfo = postStrokeHold.getEndTimeInfo();
//				currentGestureEntity.getDependentHandEntity().setEndTimeInfo(finalEndMovieTimeInfo);
//				currentGestureEntity.getDependentHandShapeEntity().getLastGestureHandShapeEvent().setStartTimeInfo(finalEndMovieTimeInfo);
//				currentGestureEntity.getDependentHandShapeEntity().getLastGestureHandShapeEvent().setEndTimeInfo(finalEndMovieTimeInfo);
//			}
//		}

		hshPanel.getSelectedDomHandshapesPane().removeAll();
		hshPanel.getSelectedNdomHandshapesPane().removeAll();

		GestureEventsEntity gestureWithLocationAndSignType = null;
		if (depGestEntity != null) { 					// Two-Handed
			if (isCurrentGestureDominant()) {
				properties.setLocationInfo(locationPanel.getDomLocationInfo().cloneInfo());
				properties2.setLocationInfo(locationPanel.getNDomLocationInfo().cloneInfo());
			}
			else {
				properties2.setLocationInfo(locationPanel.getDomLocationInfo().cloneInfo());
				properties.setLocationInfo(locationPanel.getNDomLocationInfo().cloneInfo());
			}
		}
		else {			// Single-Handed Dom or Non-Dom
			if (isCurrentGestureDominant())
				properties.setLocationInfo(locationPanel.getDomLocationInfo().cloneInfo());
			else
				properties.setLocationInfo(locationPanel.getNDomLocationInfo().cloneInfo());
		}

		addOrUpdateLocations(currentGestureEntity, gestLabelObj);
		getGesturePropertyPanel().setSelectedGestureProperties();

		SegmentTemplate selectedTemplate = wrapper.getSignStreamSegmentPanel().getUtteranceView().getSegmentTemplate(wrapper.getGestureField().getSegmentID());
		wrapper.getSignStreamSegmentPanel().getUtteranceView().updateViews(selectedTemplate);

		wrapper.getSignStreamSegmentPanel().repaint();
		wrapper.getSignStreamSegmentPanel().getUtteranceView().updateUtteranceLists();
		wrapper.getSignStreamSegmentPanel().getUtteranceView().updateUtteranceIndex();

		// set start/end times to themselves to make sure handshapes won't get misaligned for badly saved glosses
		MediaToolbarCommons.setSelectedEventStartTime(mediaToolBar.selectedEvent().getStartTimeInfo());
		MediaToolbarCommons.setSelectedEventEndTime(mediaToolBar.selectedEvent().getEndTimeInfo());
		
		// this does a refresh of the entire screen
		view.getSignStreamSegmentPanel().getUtteranceView().getNonmanualFieldsView().getCSFieldDialog()
                .getCSFieldPanel().showAllFieldsCurrentUtterance();
		
		return true;
 	}

	private void addOrUpdateLocations(GestureEventsEntity gestureEntity, LabelObject gestLabelObj) {
		SignStreamSegmentPanel segmentPanel = gestureEntity.getSignStreamSegmentPanel();
		GestureLocationEntity currentLocEntity = gestureEntity.getDependentLocationEntity();
		GestureLocationInfo newCurrentInfo = gestureEntity.getGestureEntityProperties().getLocationInfo(); //locationPanel.getCurrentLocationInfo();

		GestureEventsEntity depGestEntity = gestureEntity.getDependentGestureEntity();

		GestureLocationFieldWrapper lfWrapper;
		String locFieldID;

		if (depGestEntity == null) {
			locFieldID =  isCurrentGestureDominant() ? Util.DOM_GESTURE_LOCATION_FIELD_ID: Util.NDOM_GESTURE_LOCATION_FIELD_ID;

			lfWrapper = (GestureLocationFieldWrapper) gestLabelObj.getChildWithFieldID(locFieldID).getWrapper();
			if (lfWrapper == null) {
				lfWrapper = (GestureLocationFieldWrapper) view.getSegment().getRootLabelObject().getGestureLabelObject().getChildWithFieldID(locFieldID).getWrapper();
			}

			if (newCurrentInfo.isEmpty()) {
				setLocEntityToNull(gestureEntity, currentLocEntity, lfWrapper);
			}
			else {
				setGestureLocationEntityOnSegmentPanel(gestureEntity, segmentPanel, currentLocEntity, newCurrentInfo, lfWrapper);
			}
		}
		else {
			String domLocFieldID, ndomLocFieldID;
			domLocFieldID = Util.DOM_GESTURE_LOCATION_FIELD_ID;
			ndomLocFieldID = Util.NDOM_GESTURE_LOCATION_FIELD_ID;

			GestureLocationFieldWrapper domlfWrapper, ndomlfWrapper;
			GestureLocationEntity depLocEntity = depGestEntity.getDependentLocationEntity();

			domlfWrapper = (GestureLocationFieldWrapper) gestLabelObj.getChildWithFieldID(domLocFieldID).getWrapper();
			if (domlfWrapper == null) {
				domlfWrapper = (GestureLocationFieldWrapper) view.getSegment().getRootLabelObject()
						.getGestureLabelObject().getChildWithFieldID(domLocFieldID).getWrapper();
			}
			ndomlfWrapper = (GestureLocationFieldWrapper) gestLabelObj.getChildWithFieldID(ndomLocFieldID).getWrapper();
			if (ndomlfWrapper == null) {
				ndomlfWrapper = (GestureLocationFieldWrapper) view.getSegment().getRootLabelObject()
						.getGestureLabelObject().getChildWithFieldID(ndomLocFieldID).getWrapper();
			}

			GestureLocationInfo newDepInfo = depGestEntity.getGestureEntityProperties().getLocationInfo();

			if (isCurrentGestureDominant()) {
				if (newCurrentInfo.isEmpty()) {
					setLocEntityToNull(gestureEntity, currentLocEntity, domlfWrapper);
				}
				else {
					setGestureLocationEntityOnSegmentPanel(gestureEntity, segmentPanel, currentLocEntity, newCurrentInfo, domlfWrapper);
				}
				if (newDepInfo.isEmpty()) {
					setLocEntityToNull(depGestEntity, depLocEntity, ndomlfWrapper);
				}
				else {
					setGestureLocationEntityOnSegmentPanel(depGestEntity, segmentPanel, depLocEntity, newDepInfo, ndomlfWrapper);
				}
			}
			else {
				if (newCurrentInfo.isEmpty()) {
					setLocEntityToNull(gestureEntity, currentLocEntity, ndomlfWrapper);
				}
				else {
					setGestureLocationEntityOnSegmentPanel(gestureEntity, segmentPanel, currentLocEntity, newCurrentInfo, ndomlfWrapper);
				}
				if (newDepInfo.isEmpty()) {
					setLocEntityToNull(depGestEntity, depLocEntity, domlfWrapper);
				}
				else {
					setGestureLocationEntityOnSegmentPanel(depGestEntity, segmentPanel, depLocEntity, newDepInfo, domlfWrapper);
				}
			}
		}
	}

	private static void setGestureLocationEntityOnSegmentPanel(GestureEventsEntity gestureEntity, SignStreamSegmentPanel segmentPanel, GestureLocationEntity currentLocEntity, GestureLocationInfo newCurrentInfo, GestureLocationFieldWrapper lfWrapper) {
		var startUnit = gestureEntity.getStartTimeInfo().unit();
		var endUnit = gestureEntity.getEndTimeInfo().unit();
		Time start = gestureEntity.getStartTimeInfo();
		Time end = gestureEntity.getEndTimeInfo();


		Time startTime = gestureEntity.getStartTimeInfo();
		Time endTime = gestureEntity.getEndTimeInfo();
		ArrayList<GestureLocationEvent> eventsList = new ArrayList<GestureLocationEvent>();

		// populates the list of LocationEvents that will get passed to the LocationEntity.
		// sets the start/end times of each LocationEvent relative to what order they appear in on-screen
		ArrayList<GestureLocationType> locationTypes = SS3Singleton.getGestureLocationConfig().getLocationTypes();
		int size = locationTypes.size();
		Duration dur = end.distance(start).divide(size - 1);
		for (int i = 0; i < size; i++) {
			GestureLocationType type = locationTypes.get(i);
			Time time;
			if (i == 0) {
				time = startTime;
			} else if (i == locationTypes.size() - 1) {
				time = endTime;
			} else {
				time = start.add(dur.multiply(i));
			}

			var s = time.convert(startUnit);
			var e = time.convert(endUnit);

			GestureLocationEvent event = new GestureLocationEvent(segmentPanel, type, newCurrentInfo.getLocationObj(type).getRegion(), newCurrentInfo.getLocationObj(type).isContralateral());
			event.setStartTimeInfo(s);
			event.setEndTimeInfo(e);

			eventsList.add(event);
		}

		if (currentLocEntity != null) {
			currentLocEntity.reset();
			currentLocEntity.setEvents(eventsList);
		} else {
			GestureLocationEventsCollection newLocEventsColl = new GestureLocationEventsCollection();
			for (GestureLocationEvent locationEvent : eventsList) {
				newLocEventsColl.addEvent(locationEvent);
			}
			currentLocEntity = new GestureLocationEntity(Util.getLongUniqueNumber(), newLocEventsColl, segmentPanel, lfWrapper.getField());
			currentLocEntity.setStartTimeInfo(newLocEventsColl.getFirstEvent().getStartTimeInfo());
			currentLocEntity.setEndTimeInfo(newLocEventsColl.getLastEvent().getEndTimeInfo());
			lfWrapper.addEventsEntity(currentLocEntity);

			currentLocEntity.setRefGestureEntity(gestureEntity);
			currentLocEntity.updateParentEntity();
		}
		gestureEntity.setDependentLocationEntity(currentLocEntity);

	}

	private static void setLocEntityToNull(GestureEventsEntity gestureEntity, GestureLocationEntity locEntity, GestureLocationFieldWrapper lfWrapper) {
		if (locEntity != null) {
			lfWrapper.getField().deleteEntity(locEntity);
			gestureEntity.setDependentLocationEntityID(null);
			gestureEntity.setDependentLocationEntity(null);
		}
	}

	private void addOrUpdateHandShapes(HandShapeFormBean bean, GestureEventsEntity entity, LabelObject gestLabelObj) {

		GestureEventsEntity depGestEntity = entity.getDependentGestureEntity();
		String fieldID = entity.getField().getFieldID();

		ArrayList<HandShapeImage> domHndShapeImgs = new ArrayList<>(bean.getSelectedDomHandShapeImages());
		ArrayList<HandShapeImage> ndomHndShapeImgs = new ArrayList<>(bean.getSelectedNdomHandShapeImages());
		ArrayList<OrientationImage> domFingerTipOrientationImgs = new ArrayList<>(bean.getSelectedDomOrientationFingerTipImages());
		ArrayList<OrientationImage> ndomFingerTipOrientationImgs = new ArrayList<>(bean.getSelectedNdomOrientationFingerTipImages());
		ArrayList<OrientationImage> domPalmOrientationImgs = new ArrayList<>(bean.getSelectedDomOrientationPalmImages());
		ArrayList<OrientationImage> ndomPalmOrientationImgs = new ArrayList<>(bean.getSelectedNdomOrientationPalmImages());

		GestureChainedEventsEntity dhEntity, ndhEntity;
		GestureHandShapeEntity dHshEntity, ndHshEntity;
		GestureOrientationEntity  dOFingerTipEntity, ndOFingerTipEntity;
		GestureOrientationEntity dPOEntity, ndPOEntity;

		SignStreamSegmentPanel segmentPanel = entity.getSignStreamSegmentPanel();

		GestureChainedEventsEntity handEntity = entity.getDependentHandEntity();
		GestureHandShapeEntity handShapeEntity = entity.getDependentHandShapeEntity();
		GestureOrientationEntity orientationFingerTipEntity = entity.getDependentFingerTipOrientationEntity();
		GestureOrientationEntity palmOrientationEntity = entity.getDependentPalmOrientationEntity();
		
		GestureChainedEventsEntity depHandEntity = null;
		GestureHandShapeEntity depHandShapeEntity = null;
		GestureOrientationEntity depOrientationFingerTipEntity = null;
		GestureOrientationEntity depPalmOrientationEntity = null;

		if (depGestEntity != null) {
			depHandEntity = depGestEntity.getDependentHandEntity();
			depHandShapeEntity = depGestEntity.getDependentHandShapeEntity();
			depOrientationFingerTipEntity = depGestEntity.getDependentFingerTipOrientationEntity();
			depPalmOrientationEntity = depGestEntity.getDependentPalmOrientationEntity();
		}

		LabelObject gestObj = view.getSegment().getRootLabelObject().getGestureLabelObject();
		
		String domGestureHandFieldID = Util.DOM_GESTURE_HAND_FIELD_ID;
		GestureDomNdomHandFieldWrapper domHandWrapper
			= (GestureDomNdomHandFieldWrapper) gestLabelObj.getChildWithFieldID(domGestureHandFieldID).getWrapper();
		if (domHandWrapper == null)
			domHandWrapper = (GestureDomNdomHandFieldWrapper) gestObj.getChildWithFieldID(domGestureHandFieldID).getWrapper();

		String domGestureHandshapeFieldID = Util.DOM_GESTURE_HANDSHAPE_FIELD_ID;
		GestureHandShapeFieldWrapper domHandShapeWrapper
			= (GestureHandShapeFieldWrapper) gestLabelObj.getChildWithFieldID(domGestureHandshapeFieldID).getWrapper();
		if (domHandShapeWrapper == null)
			domHandShapeWrapper = (GestureHandShapeFieldWrapper) gestObj.getChildWithFieldID(domGestureHandshapeFieldID).getWrapper();

		String domGestureOrientationFingerTipFieldID = Util.DOM_GESTURE_ORIENTATION_FINGER_TIP_FIELD_ID;
		GestureOrientationFieldWrapper domOrientationFingerTipWrapper
			= (GestureOrientationFieldWrapper) gestLabelObj.getChildWithFieldID(domGestureOrientationFingerTipFieldID).getWrapper();
		if (domOrientationFingerTipWrapper == null)
			domOrientationFingerTipWrapper = (GestureOrientationFieldWrapper) gestObj.getChildWithFieldID(domGestureOrientationFingerTipFieldID).getWrapper();

		String domGesturePalmOrientationFieldID = Util.DOM_GESTURE_PALM_FIELD_ID;
		GestureOrientationFieldWrapper domPalmOrientationWrapper
			= (GestureOrientationFieldWrapper) gestLabelObj.getChildWithFieldID(domGesturePalmOrientationFieldID).getWrapper();
		if (domPalmOrientationWrapper == null) {
			domPalmOrientationWrapper = (GestureOrientationFieldWrapper) gestObj.getChildWithFieldID(domGesturePalmOrientationFieldID).getWrapper();
		}


		String ndomGestureHandFieldID = Util.NDOM_GESTURE_HAND_FIELD_ID;
		GestureDomNdomHandFieldWrapper ndomHandWrapper
			= (GestureDomNdomHandFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGestureHandFieldID).getWrapper();
		if (ndomHandWrapper == null)
			ndomHandWrapper = (GestureDomNdomHandFieldWrapper) gestObj.getChildWithFieldID(ndomGestureHandFieldID).getWrapper();

		String ndomGestureHandshapeFieldID = Util.NDOM_GESTURE_HANDSHAPE_FIELD_ID;
		GestureHandShapeFieldWrapper ndomHandShapeWrapper
			= (GestureHandShapeFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGestureHandshapeFieldID).getWrapper();

		if (ndomHandShapeWrapper == null)
			ndomHandShapeWrapper = (GestureHandShapeFieldWrapper) gestObj.getChildWithFieldID(ndomGestureHandshapeFieldID).getWrapper();

		String ndomGestureOrientationFingerTipFieldID = Util.NDOM_GESTURE_ORIENTATION_FINGER_TIP_FIELD_ID;
		GestureOrientationFieldWrapper ndomOrientationFingerTipWrapper
			= (GestureOrientationFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGestureOrientationFingerTipFieldID).getWrapper();

		if (ndomOrientationFingerTipWrapper == null)
			ndomOrientationFingerTipWrapper = (GestureOrientationFieldWrapper) gestObj.getChildWithFieldID(ndomGestureOrientationFingerTipFieldID).getWrapper();

		String ndomGesturePalmOrientationFieldID = Util.NDOM_GESTURE_PALM_FIELD_ID;
		GestureOrientationFieldWrapper ndomPalmOrientationWrapper
			= (GestureOrientationFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGesturePalmOrientationFieldID).getWrapper();

		if(!domHndShapeImgs.isEmpty() || !domFingerTipOrientationImgs.isEmpty() || !domPalmOrientationImgs.isEmpty()) {
			// add/update handshapes on right hand

			if (fieldID.equals(Util.DOM_GESTURE_FIELD_ID)) {
				if(handEntity != null) {
					handEntity.getTextValue().setText(entity.getText());
					//					dhEntity = handEntity;
					//				} else {
					//					// add entity to Right Hand field
					//					dhEntity = addHandEntity(domHandWrapper, entity, segmentPanel);
					//					entity.setDependentHandEntity(dhEntity);
					//					dhEntity.setLockedGesturePhonAlignments(true);
				}

				if (!domHndShapeImgs.isEmpty()) {
					if(handShapeEntity != null) {
						Time startTimeInfo = handShapeEntity.getStartTimeInfo();
						Time endTimeInfo = handShapeEntity.getEndTimeInfo();
						
						if (entity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = entity.getTextValue();
							GestureChainedEvent prestroke = entity.getPrestrokeHold();
							GestureChainedEvent poststroke = entity.getPoststrokeHold();
							
							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureHandShapeEntity.createSS3Entity(domHndShapeImgs, startTimeInfo, endTimeInfo);
						handShapeEntity.resetEntity(ent);
					} else {
						// add entity to Right Hand field
						dhEntity = addHandEntity(domHandWrapper, entity, segmentPanel);

						dHshEntity = GestureHandShapeEntity.createGestureHandShapeEntity(bean, domHndShapeImgs, dhEntity,
								domHandShapeWrapper.getGestureHandShapeField());

						domHandShapeWrapper.getGestureHandShapeField().addGestureHandShapeEntity(dHshEntity);
						entity.setDependentHandEntity(dhEntity);
						entity.setDependentHandShapeEntity(dHshEntity);

						dHshEntity.setRefGestureEntity(entity);	
						entity.setLockedGesturePhonAlignments(true);
						dhEntity.setLockedGesturePhonAlignments(true);
						dHshEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!domFingerTipOrientationImgs.isEmpty()) {
					if (orientationFingerTipEntity != null) {
						Time startTimeInfo = orientationFingerTipEntity.getStartTimeInfo();
						Time endTimeInfo = orientationFingerTipEntity.getEndTimeInfo();
						
						if (entity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = entity.getTextValue();
							GestureChainedEvent prestroke = entity.getPrestrokeHold();
							GestureChainedEvent poststroke = entity.getPoststrokeHold();
							
							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(domFingerTipOrientationImgs, startTimeInfo, endTimeInfo);
						orientationFingerTipEntity.resetEntity(ent);
					} else {
						dhEntity = entity.getDependentHandEntity();
						/*
						 * if (dhEntity == null)
						 * ???? not sure how it would be, if handshapes and orientations must be selected together
						 */
						dOFingerTipEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, domFingerTipOrientationImgs, dhEntity,
								domOrientationFingerTipWrapper.getGestureOrientationField());

						domOrientationFingerTipWrapper.getGestureOrientationField().addGestureOrientationEntity(dOFingerTipEntity);
						entity.setDependentOrientationFingerTipEntity(dOFingerTipEntity);

						dOFingerTipEntity.setRefGestureEntity(entity);
						entity.setLockedGesturePhonAlignments(true);
						dOFingerTipEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!domPalmOrientationImgs.isEmpty()) {
					if (palmOrientationEntity != null) {
						Time startTimeInfo = palmOrientationEntity.getStartTimeInfo();
						Time endTimeInfo = palmOrientationEntity.getEndTimeInfo();

						if (entity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = entity.getTextValue();
							GestureChainedEvent prestroke = entity.getPrestrokeHold();
							GestureChainedEvent poststroke = entity.getPoststrokeHold();
							
							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(domPalmOrientationImgs, startTimeInfo, endTimeInfo);
						palmOrientationEntity.resetEntity(ent);
					} else {
						dhEntity = entity.getDependentHandEntity();

						dPOEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, domPalmOrientationImgs, dhEntity,
								domPalmOrientationWrapper.getGestureOrientationField());

						domPalmOrientationWrapper.getGestureOrientationField().addGestureOrientationEntity(dPOEntity);
						entity.setDependentOrientationPalmEntity(dPOEntity);

						dPOEntity.setRefGestureEntity(entity);
						entity.setLockedGesturePhonAlignments(true);
						dPOEntity.setLockedGesturePhonAlignments(true);
					}
				}

			} else if (fieldID.equals(Util.NDOM_GESTURE_FIELD_ID)) {
				if(depHandEntity != null) {
					depGestEntity.getTextValue().setText(entity.getText());
					//					dhEntity = ndHandEntity;
					//				} else {
					//					// add entity to Right Hand field
					//					dhEntity = addHandEntity(domHandWrapper, depGlsEntity, segmentPanel);
					//					depGlsEntity.setDependentHandEntity(dhEntity);
					//					dhEntity.setLockedGesturePhonAlignments(true);
				}

				if (!domHndShapeImgs.isEmpty()) {
					if(depHandShapeEntity != null) {
						Time startTimeInfo = depHandShapeEntity.getStartTimeInfo();
						Time endTimeInfo = depHandShapeEntity.getEndTimeInfo();

						if (depGestEntity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = depGestEntity.getTextValue();
							GestureChainedEvent prestroke = depGestEntity.getPrestrokeHold();
							GestureChainedEvent poststroke = depGestEntity.getPoststrokeHold();
							
							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureHandShapeEntity.createSS3Entity(domHndShapeImgs, startTimeInfo, endTimeInfo);
						depHandShapeEntity.resetEntity(ent);
					} else {
						// add entity to Right Hand field
						dhEntity = addHandEntity(domHandWrapper, depGestEntity, segmentPanel);

						dHshEntity = GestureHandShapeEntity.createGestureHandShapeEntity(bean, domHndShapeImgs, dhEntity,
								domHandShapeWrapper.getGestureHandShapeField());

						domHandShapeWrapper.getGestureHandShapeField().addGestureHandShapeEntity(dHshEntity);
						depGestEntity.setDependentHandEntity(dhEntity);
						depGestEntity.setDependentHandShapeEntity(dHshEntity);

						dHshEntity.setRefGestureEntity(depGestEntity);						
						depGestEntity.setLockedGesturePhonAlignments(true);
						dhEntity.setLockedGesturePhonAlignments(true);
						dHshEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!domFingerTipOrientationImgs.isEmpty()) {
					if(depOrientationFingerTipEntity != null) {
						Time startTimeInfo = depOrientationFingerTipEntity.getStartTimeInfo();
						Time endTimeInfo = depOrientationFingerTipEntity.getEndTimeInfo();

						if (depGestEntity.isLockedGesturePhonAlignments()) {

							GestureChainedEvent value = depGestEntity.getTextValue();
							GestureChainedEvent prestroke = depGestEntity.getPrestrokeHold();
							GestureChainedEvent poststroke = depGestEntity.getPoststrokeHold();
							
							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(domFingerTipOrientationImgs, startTimeInfo, endTimeInfo);
						depOrientationFingerTipEntity.resetEntity(ent);
					} else {
						dhEntity = depGestEntity.getDependentHandEntity();
						/*
						 * if (dhEntity == null)
						 * ???? not sure how it would be, if handshapes and orientations must be selected together
						 */

						dOFingerTipEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, domFingerTipOrientationImgs, dhEntity,
								domOrientationFingerTipWrapper.getGestureOrientationField());

						domOrientationFingerTipWrapper.getGestureOrientationField().addGestureOrientationEntity(dOFingerTipEntity);
						depGestEntity.setDependentOrientationFingerTipEntity(dOFingerTipEntity);

						dOFingerTipEntity.setRefGestureEntity(depGestEntity);
						depGestEntity.setLockedGesturePhonAlignments(true);
						dOFingerTipEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!domPalmOrientationImgs.isEmpty()) {
					if(depPalmOrientationEntity != null) {
						Time startTimeInfo = depPalmOrientationEntity.getStartTimeInfo();
						Time endTimeInfo = depPalmOrientationEntity.getEndTimeInfo();

						if (depGestEntity.isLockedGesturePhonAlignments()) {

							GestureChainedEvent value = depGestEntity.getTextValue();
							GestureChainedEvent prestroke = depGestEntity.getPrestrokeHold();
							GestureChainedEvent poststroke = depGestEntity.getPoststrokeHold();
							
							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(domPalmOrientationImgs, startTimeInfo, endTimeInfo);
						depPalmOrientationEntity.resetEntity(ent);
					} else {
						dhEntity = depGestEntity.getDependentHandEntity();
						/*
						 * if (dhEntity == null)
						 * ???? not sure how it would be, if handshapes and orientations must be selected together
						 */

						dPOEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, domPalmOrientationImgs, dhEntity,
								domPalmOrientationWrapper.getGestureOrientationField());

						domPalmOrientationWrapper.getGestureOrientationField().addGestureOrientationEntity(dPOEntity);
						depGestEntity.setDependentOrientationPalmEntity(dPOEntity);

						dPOEntity.setRefGestureEntity(depGestEntity);
						depGestEntity.setLockedGesturePhonAlignments(true);
						dPOEntity.setLockedGesturePhonAlignments(true);
					}
				}
			}
		} else {
			// delete handshapes and orientations
			if(fieldID.equals(Util.DOM_GESTURE_FIELD_ID)) {
				if(handEntity != null) {
					domHandWrapper.getField().deleteEntity(handEntity);
				}

				if(handShapeEntity != null) {
					domHandShapeWrapper.getGestureHandShapeField().deleteEntity(handShapeEntity);
				}

				if (orientationFingerTipEntity != null) {
					domOrientationFingerTipWrapper.getGestureOrientationField().deleteEntity(orientationFingerTipEntity);
				}

				if (palmOrientationEntity != null) {
					domPalmOrientationWrapper.getGestureOrientationField().deleteEntity(palmOrientationEntity);
				}

				entity.setDependentHandEntity(null);
				entity.setDependentHandShapeEntity(null);
				entity.setDependentOrientationFingerTipEntity(null);
				entity.setDependentOrientationPalmEntity(null);
			} else if(fieldID.equals(Util.NDOM_GESTURE_FIELD_ID)) {
				if(depHandEntity != null) {
					domHandWrapper.getField().deleteEntity(depHandEntity);
				}
				if(depHandShapeEntity != null) {
					domHandShapeWrapper.getGestureHandShapeField().deleteEntity(depHandShapeEntity);
				}
				if (depOrientationFingerTipEntity != null) {
					domOrientationFingerTipWrapper.getGestureOrientationField().deleteEntity(depOrientationFingerTipEntity);
				}

				if (depPalmOrientationEntity != null) {
					domPalmOrientationWrapper.getGestureOrientationField().deleteEntity(depPalmOrientationEntity);
				}

				if(depGestEntity != null) {
					depGestEntity.setDependentHandEntity(null);
					depGestEntity.setDependentHandShapeEntity(null);
					depGestEntity.setDependentOrientationFingerTipEntity(null);
					depGestEntity.setDependentOrientationPalmEntity(null);
				}
			}
		}

		if(!ndomHndShapeImgs.isEmpty() || !ndomFingerTipOrientationImgs.isEmpty() || !ndomPalmOrientationImgs.isEmpty()) {
			// add/update handshapes on right hand
			if (fieldID.equals(Util.NDOM_GESTURE_FIELD_ID)) {
				if (handEntity != null) {
					handEntity.getTextValue().setText(entity.getText());
					//					ndhEntity = handEntity;
					//				} else {
					//					// add entity to Right Hand field
					//					ndhEntity = addHandEntity(ndomHandWrapper, entity, segmentPanel);
					//					entity.setDependentHandEntity(ndhEntity);
					//					ndhEntity.setLockedGesturePhonAlignments(true);
				}

				if (!ndomHndShapeImgs.isEmpty()) {
					if (handShapeEntity != null) {
						Time startTimeInfo = handShapeEntity.getStartTimeInfo();
						Time endTimeInfo = handShapeEntity.getEndTimeInfo();

						if (entity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = entity.getTextValue();
							GestureChainedEvent prestroke = entity.getPrestrokeHold();
							GestureChainedEvent poststroke = entity.getPoststrokeHold();

							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureHandShapeEntity.createSS3Entity(ndomHndShapeImgs, startTimeInfo, endTimeInfo);
						handShapeEntity.resetEntity(ent);
					} else {
						// add entity to Right Hand field
						ndhEntity = addHandEntity(ndomHandWrapper, entity, segmentPanel);

						ndHshEntity = GestureHandShapeEntity.createGestureHandShapeEntity(bean, ndomHndShapeImgs, ndhEntity,
								ndomHandShapeWrapper.getGestureHandShapeField());

						ndomHandShapeWrapper.getGestureHandShapeField().addGestureHandShapeEntity(ndHshEntity);
						entity.setDependentHandEntity(ndhEntity);
						entity.setDependentHandShapeEntity(ndHshEntity);

						ndHshEntity.setRefGestureEntity(entity);
						entity.setLockedGesturePhonAlignments(true);
						ndhEntity.setLockedGesturePhonAlignments(true);
						ndHshEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!ndomFingerTipOrientationImgs.isEmpty()) {
					if (orientationFingerTipEntity != null) {
						Time startTimeInfo = orientationFingerTipEntity.getStartTimeInfo();
						Time endTimeInfo = orientationFingerTipEntity.getEndTimeInfo();

						if (entity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = entity.getTextValue();
							GestureChainedEvent prestroke = entity.getPrestrokeHold();
							GestureChainedEvent poststroke = entity.getPoststrokeHold();

							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(ndomFingerTipOrientationImgs, startTimeInfo, endTimeInfo);
						orientationFingerTipEntity.resetEntity(ent);
					} else {
						ndhEntity = entity.getDependentHandEntity();
						/*
						 * if null ....?
						 */
						ndOFingerTipEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, ndomFingerTipOrientationImgs, ndhEntity,
								ndomOrientationFingerTipWrapper.getGestureOrientationField());

						ndomOrientationFingerTipWrapper.getGestureOrientationField().addGestureOrientationEntity(ndOFingerTipEntity);
						entity.setDependentHandEntity(ndhEntity);
						entity.setDependentOrientationFingerTipEntity(ndOFingerTipEntity);

						ndOFingerTipEntity.setRefGestureEntity(entity);
						entity.setLockedGesturePhonAlignments(true);
						ndhEntity.setLockedGesturePhonAlignments(true);
						ndOFingerTipEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!ndomPalmOrientationImgs.isEmpty()) {
					if (palmOrientationEntity != null) {
						Time startTimeInfo = palmOrientationEntity.getStartTimeInfo();
						Time endTimeInfo = palmOrientationEntity.getEndTimeInfo();

						if (entity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = entity.getTextValue();
							GestureChainedEvent prestroke = entity.getPrestrokeHold();
							GestureChainedEvent poststroke = entity.getPoststrokeHold();

							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(ndomPalmOrientationImgs, startTimeInfo, endTimeInfo);
						palmOrientationEntity.resetEntity(ent);
					} else {
						ndhEntity = entity.getDependentHandEntity();
						/*
						 * if null ....?
						 */
						ndPOEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, ndomPalmOrientationImgs, ndhEntity,
								ndomPalmOrientationWrapper.getGestureOrientationField());

						ndomPalmOrientationWrapper.getGestureOrientationField().addGestureOrientationEntity(ndPOEntity);
						entity.setDependentHandEntity(ndhEntity);
						entity.setDependentOrientationPalmEntity(ndPOEntity);

						ndPOEntity.setRefGestureEntity(entity);
						entity.setLockedGesturePhonAlignments(true);
						ndhEntity.setLockedGesturePhonAlignments(true);
						ndPOEntity.setLockedGesturePhonAlignments(true);
					}
				}
			} else if (fieldID.equals(Util.DOM_GESTURE_FIELD_ID)) {
				// assert ndEntity != null;
				if (depHandEntity != null) {
					depHandEntity.getTextValue().setText(entity.getText());
					//					ndhEntity = ndHandEntity;
					//				} else {
					//					// add entity to Right Hand field
					//					ndhEntity = addHandEntity(ndomHandWrapper, depGlsEntity, segmentPanel);
					//					if (depGlsEntity != null) {
					//						depGlsEntity.setDependentHandEntity(ndhEntity);
					//					}
					//					ndhEntity.setLockedGesturePhonAlignments(true);
				}

				if (!ndomHndShapeImgs.isEmpty()) {
					if (depHandShapeEntity != null) {
						Time startTimeInfo = depHandShapeEntity.getStartTimeInfo();
						Time endTimeInfo = depHandShapeEntity.getEndTimeInfo();

						if (depGestEntity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = depGestEntity.getTextValue();
							GestureChainedEvent prestroke = depGestEntity.getPrestrokeHold();
							GestureChainedEvent poststroke = depGestEntity.getPoststrokeHold();
							
							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureHandShapeEntity.createSS3Entity(ndomHndShapeImgs, startTimeInfo, endTimeInfo);
						depHandShapeEntity.resetEntity(ent);
					} else if (depGestEntity != null) {
						// add entity to Right Hand field
						ndhEntity = addHandEntity(ndomHandWrapper, depGestEntity, segmentPanel);

						ndHshEntity = GestureHandShapeEntity.createGestureHandShapeEntity(bean, ndomHndShapeImgs, ndhEntity,
								ndomHandShapeWrapper.getGestureHandShapeField());

						ndomHandShapeWrapper.getGestureHandShapeField().addGestureHandShapeEntity(ndHshEntity);
						depGestEntity.setDependentHandShapeEntity(ndHshEntity);
						ndHshEntity.setRefGestureEntity(depGestEntity);
						depGestEntity.setDependentHandEntity(ndhEntity);
						depGestEntity.setLockedGesturePhonAlignments(true);
						ndhEntity.setLockedGesturePhonAlignments(true);
						ndHshEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!ndomFingerTipOrientationImgs.isEmpty()) {
					if (depOrientationFingerTipEntity != null) {
						Time startTimeInfo = depOrientationFingerTipEntity.getStartTimeInfo();
						Time endTimeInfo = depOrientationFingerTipEntity.getEndTimeInfo();

						if (depGestEntity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = depGestEntity.getTextValue();
							GestureChainedEvent prestroke = depGestEntity.getPrestrokeHold();
							GestureChainedEvent poststroke = depGestEntity.getPoststrokeHold();
							
							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(ndomFingerTipOrientationImgs, startTimeInfo, endTimeInfo);
						depOrientationFingerTipEntity.resetEntity(ent);
					} else if (depGestEntity != null) {
						// Checking if depGestEntity is not null because this entire block relies on depGestEntity not being null,
						// So we need to close this check around everything here... ndhEntity might produce a null pointer exception
						// if we do not check it, so we just need to ensure that depGestEntity is not null before we do anything else
						ndhEntity = depGestEntity.getDependentHandEntity();


						depOrientationFingerTipEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, ndomFingerTipOrientationImgs, ndhEntity,
								ndomOrientationFingerTipWrapper.getGestureOrientationField());

						ndomOrientationFingerTipWrapper.getGestureOrientationField().addGestureOrientationEntity(depOrientationFingerTipEntity);

						depGestEntity.setDependentHandEntity(ndhEntity);
						depGestEntity.setDependentOrientationFingerTipEntity(depOrientationFingerTipEntity);
						depOrientationFingerTipEntity.setRefGestureEntity(depGestEntity);
						depGestEntity.setLockedGesturePhonAlignments(true);
						ndhEntity.setLockedGesturePhonAlignments(true);
						depOrientationFingerTipEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!ndomPalmOrientationImgs.isEmpty()) {
					if (depPalmOrientationEntity != null) {
						Time startTimeInfo = depPalmOrientationEntity.getStartTimeInfo();
						Time endTimeInfo = depPalmOrientationEntity.getEndTimeInfo();

						if (depGestEntity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = depGestEntity.getTextValue();
							GestureChainedEvent prestroke = depGestEntity.getPrestrokeHold();
							GestureChainedEvent poststroke = depGestEntity.getPoststrokeHold();
							
							if (prestroke != null) {
								startTimeInfo = prestroke.getStartTimeInfo();
							} else {
								startTimeInfo = value.getStartTimeInfo();
							}
							if (poststroke != null) {
								endTimeInfo = poststroke.getEndTimeInfo();
							} else {
								endTimeInfo = value.getEndTimeInfo();
							}
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(ndomPalmOrientationImgs, startTimeInfo, endTimeInfo);
						depPalmOrientationEntity.resetEntity(ent);
					} else if (depGestEntity != null) {
						ndhEntity = depGestEntity.getDependentHandEntity();

						depPalmOrientationEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, ndomPalmOrientationImgs, ndhEntity,
								ndomOrientationFingerTipWrapper.getGestureOrientationField());

						ndomPalmOrientationWrapper.getGestureOrientationField().addGestureOrientationEntity(depPalmOrientationEntity);

						depGestEntity.setDependentHandEntity(ndhEntity);
						depGestEntity.setDependentOrientationPalmEntity(depPalmOrientationEntity);
						depPalmOrientationEntity.setRefGestureEntity(depGestEntity);
						depGestEntity.setLockedGesturePhonAlignments(true);
						ndhEntity.setLockedGesturePhonAlignments(true);
						depPalmOrientationEntity.setLockedGesturePhonAlignments(true);
					}
				}
			}
		} else {
			// delete handshapes and orientations
			if (fieldID.equals(Util.NDOM_GESTURE_FIELD_ID)) {
				if (handEntity != null) {
					ndomHandWrapper.getField().deleteEntity(handEntity);
				}

				if (handShapeEntity != null) {
					ndomHandShapeWrapper.getGestureHandShapeField().deleteEntity(handShapeEntity);
				}

				if (orientationFingerTipEntity != null) {
					ndomOrientationFingerTipWrapper.getGestureOrientationField().deleteEntity(orientationFingerTipEntity);
				}

				if (palmOrientationEntity != null) {
					ndomPalmOrientationWrapper.getGestureOrientationField().deleteEntity(palmOrientationEntity);
				}

				entity.setDependentHandEntity(null);
				entity.setDependentHandShapeEntity(null);
				entity.setDependentOrientationFingerTipEntity(null);
				entity.setDependentOrientationPalmEntity(null);
			} else if (fieldID.equals(Util.DOM_GESTURE_FIELD_ID)) {
				if (depHandEntity != null) {
					ndomHandWrapper.getField().deleteEntity(depHandEntity);
				}
				if (depHandShapeEntity != null) {
					ndomHandShapeWrapper.getGestureHandShapeField().deleteEntity(depHandShapeEntity);
				}
				if (depOrientationFingerTipEntity != null) {
					ndomOrientationFingerTipWrapper.getGestureOrientationField().deleteEntity(depOrientationFingerTipEntity);
				}

				if (depPalmOrientationEntity != null) {
					ndomPalmOrientationWrapper.getGestureOrientationField().deleteEntity(depPalmOrientationEntity);
				}

				if (depGestEntity != null) {
					depGestEntity.setDependentHandEntity(null);
					depGestEntity.setDependentHandShapeEntity(null);
					depGestEntity.setDependentOrientationFingerTipEntity(null);
					depGestEntity.setDependentOrientationPalmEntity(null);

				}
			}
		}

		if (entity != null) { // Entity at this point will probably never be null (I think), but just in case
			if (entity.getDependentHandEntity() != null) {
				entity.getDependentHandEntity().setIncompleteGesture(entity.getIncompleteGesture());
				entity.getDependentHandEntity().setShowUniqueNumber(entity.getShowUniqueNumber());
				entity.getDependentHandEntity().setUniqueNumber(entity.getUniqueNumber());
			}
		}

		if (depGestEntity != null) {
			if (depGestEntity.getDependentHandEntity() != null) {
				depGestEntity.getDependentHandEntity().setIncompleteGesture(depGestEntity.getIncompleteGesture());
				depGestEntity.getDependentHandEntity().setShowUniqueNumber(entity.getShowUniqueNumber());
				depGestEntity.getDependentHandEntity().setUniqueNumber(entity.getUniqueNumber());
			}
		}
	}

	private GestureChainedEventsEntity addHandEntity(GestureDomNdomHandFieldWrapper wrp,
											  GestureEventsEntity gestEntity, SignStreamSegmentPanel panel) {

		GestureChainedEvent value = gestEntity.getTextValue();
		GestureChainedEvent preStrokeHold = gestEntity.getPrestrokeHold();
		GestureChainedEvent postStrokeHold = gestEntity.getPoststrokeHold();

		Time startTimeInfo; // = null;
		Time endTimeInfo; // = null;

		gestEntity.setLockedGesturePhonAlignments(true);

		if (preStrokeHold != null) {
			startTimeInfo = preStrokeHold.getStartTimeInfo();
		} else {
			startTimeInfo = value.getStartTimeInfo();
		}

		if (postStrokeHold != null) {
			endTimeInfo = postStrokeHold.getEndTimeInfo();
		} else {
			endTimeInfo = value.getEndTimeInfo();
		}

		GestureChainedEventsCollection collection = new GestureChainedEventsCollection();

		GestureEvent gEvent = new GestureEvent(panel);
		gEvent.setStartTimeInfo(startTimeInfo);
		gEvent.setEndTimeInfo(endTimeInfo);
		gEvent.setText(value.getText());
		collection.setTextValueEvent(gEvent);

		GestureChainedEventsEntity handEntity = new GestureChainedEventsEntity(collection,
																 panel, wrp.getField());

		handEntity.setID(Util.getLongUniqueNumber());
		handEntity.setField(wrp.getField());
		handEntity.updateParentEntity();

		wrp.addEventsEntity(handEntity);
		handEntity.setRefEntityId(gestEntity.getID());

		handEntity.setLockedGesturePhonAlignments(true);
		return handEntity;
	}

	/**
	 * To be called by the sign bank panel exclusively.
	 * Set the main gloss text and variant text to the labels passed in.
	 * @param mainGestureLabel The main gloss label from the sign bank panel results list
	 * @param variantLabel The variant label from the sign bank panel results list
	 */
	public void populateMainGestureAndVariantLabels(String mainGestureLabel, String variantLabel) {
		if (mainGestureLabel == null || variantLabel == null)
			return;

		primaryEntryField.setText(mainGestureLabel.trim());
		gestureLbField.setText(variantLabel.trim());
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();

		switch (Integer.parseInt(str)) {
/*			case ENTER_BYPASS:
				boolean success = this.updateChanges();
				if (!success)
					return;
				
				view.update();
				view.getSignStreamSegmentPanel().getUtteranceView().getNonmanualFieldsView().getCSFieldDialog()
                        .getCSFieldPanel().showAllFieldsCurrentUtterance();
				SS3Singleton.getSignStreamApplication().repaint();
				parent.setVisible(false);
				System.gc();
				break;*/
			case ENTER:

//				SignBankCollection collection = null;
//				String mainGestureStr = "", trimmedVariantStr = "", originalVariantStr = "";
//
//				// first, before closing out, check that the user didn't edit the labels of main gloss & variant - to ensure that those labels are in the SB
//				if (hshPanel.isLexical() || hshPanel.isNumber()) {
//					collection = SS3Singleton.getSignStreamApplication().getSignBankCollection();
//
//					mainGestureStr = primaryEntryField.getText().trim();
//					originalVariantStr = variantField.getText().trim();
//					trimmedVariantStr = Util.trimAsterisksAndPlusSigns(originalVariantStr);
//					// check first if this sign DOES NOT exist in collection already - we will disallow if so
//					SignBankVariant matchingVariant = collection.contains(trimmedVariantStr);
//					SignBankVariant matchingOriginalVariant = collection.contains(originalVariantStr);
//					if (matchingVariant == null && matchingOriginalVariant == null) {
//						String warningDialogText =
//								"Sign was not found in the sign bank.\nPlease either search for an existing sign, or add a new one.";
//						String warningTitleText = "Sign Not Found";
//						int optionType = JOptionPane.YES_NO_OPTION;
//						int messageType = JOptionPane.ERROR_MESSAGE;
//						String options[] = {"OK"};
//
//						try {
//							JOptionPane.showOptionDialog(this,
//														 warningDialogText,
//														 warningTitleText,
//														 optionType,
//														 messageType,
//														 null,
//														 options,
//														 options[0]);
//						} catch (HeadlessException he) {
//							System.out.println("");
//						}
//
//						return;
//					} else if (matchingOriginalVariant == null) {
//						//addToSignBank(mainGestureStr, untrimmedVariantStr);
//
//						// reset this variant in the case we just added to sign bank
//						// (inside addToSignBank() the sign bank itself got re-parsed into `collection`)
//						//matchingUntrimmedVariant = collection.contains(mainGestureStr, untrimmedVariantStr);
//						saveChanges();
//					} else {
//						saveChanges(matchingOriginalVariant);
//					}
//
//
//				} else {
//					saveChanges();
//				}
				
				if (hshPanel.isTwoHanded()) {
					ArrayList<HandShapeImage> rhImages = this.hshPanel.getSelectedDomHandshapesPane().getHandshapes();
					ArrayList<HandShapeImage> lhImages = this.hshPanel.getSelectedNdomHandshapesPane().getHandshapes();
					ArrayList<FingerTipImage> rOImages = this.hshPanel.getSelectedDomHandshapesPane().getFingerTipOrientationsImages();
					ArrayList<FingerTipImage> lOImages = this.hshPanel.getSelectedNdomHandshapesPane().getFingerTipOrientationsImages();
					ArrayList<PalmImage>     rPOImages = this.hshPanel.getSelectedDomHandshapesPane().getPalmOrientationsImages();
					ArrayList<PalmImage>     lPOImages = this.hshPanel.getSelectedNdomHandshapesPane().getPalmOrientationsImages();
					
					boolean handSizeNotMatch = rhImages.size() != lhImages.size();
					boolean ornSizeNotMatch = rOImages.size() != lOImages.size();
					boolean palmOrnSizeNotMatch = rPOImages.size() != lPOImages.size();
					
					if ( (handSizeNotMatch && (rhImages.isEmpty() || lhImages.isEmpty()) )
							|| (ornSizeNotMatch && (rOImages.isEmpty() || lOImages.isEmpty()) ) ||
								(palmOrnSizeNotMatch && (rPOImages.isEmpty() || lPOImages.isEmpty()) )) {
						// user must select any number of handshape and orientation images for two-handed, unless empty
						SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.GESTURE_EMPTY_HANDSHAPES_ORIENTATIONS);
						break;
					}
				}

				boolean success = this.updateChanges();
				if (!success)
					return;
				
				view.update();
//				view.getSignStreamSegmentPanel().getUtteranceView().updateViews();
				view.getSignStreamSegmentPanel().getUtteranceView().getNonmanualFieldsView().getCSFieldDialog()
                        .getCSFieldPanel().showAllFieldsCurrentUtterance();
				SS3Singleton.getSignStreamApplication().repaint();
				parent.setVisible(false);
				System.gc();
				break;
			case CANCEL:
				parent.setVisible(false);
				break;
		}
		locationScrollPane.getVerticalScrollBar().setValue(0);
		checkSignTypeAndUpdateSignBankFunctionality();
	}

	public void checkSignTypeAndUpdateSignBankFunctionality() {
		if (hshPanel.isLexical() || hshPanel.isNumber() || hshPanel.isLoan())
			enableSignBankFunctionality(true);
		else if (hshPanel.isFingerspelled() || hshPanel.isGesture() || hshPanel.isClassifier())
			enableSignBankFunctionality(false);
	}

	public void enableSignBankFunctionality(boolean enabled) {
		primaryEntryField.setEnabled(enabled);
		addNewSign.setEnabled(enabled);
	}

	public boolean isOneHandedSelected() {
		return hshPanel.isOneHandedSelected();
	}

	public boolean isTwoHandedSelected() {
		return hshPanel.isTwoHandedSelected();
	}

	public boolean isDominantHandRight() {
		return Util.RIGHT_HAND.equals(dominantHand);
	}

	public boolean isCurrentGestureDominant() {
		return wrapper.getGestureField().getFieldID().equals(Util.DOM_GESTURE_FIELD_ID);
	}

	public String getDominantHand() {
		return dominantHand;
	}

	public JDialog getParentDialog() {
		return parent;
	}

	public JButton getEnterButton() {
		return enter;
	}

	public GestureEventsEntity getCurrentGestureEntity() {
		return currentGestureEntity;
	}
	
	public SS3GlossWindowSegment getCurrentSS3GestureWindowSegment() {
		return currentGestureWindowSegment;
	}

	public GesturePropertyPanel getGesturePropertyPanel() {
		return gstPanel;
	}
	
	public GestureNRelatedView getGestureNRelatedView() {
		return this.view;
	}
}

class LoadedProperties {

	private String gestText = "";

	private boolean fingerspelled = false;
	private boolean loan = false;
	private boolean number = false;
	private boolean lexical = false;
	private boolean classifier = false;
	private boolean gesture = false;
	private boolean nameSign = false;
	private boolean twoHanded = false;
	private boolean oneFrameGesture = false;
	private boolean markedNumberOfHands = false;
	private boolean passiveBaseArm = false;

//	private int sameDifHandshapes = 0;
	private GestureDomNdomHandshapesType sameDIfferentDomNdomHandshapes = GestureDomNdomHandshapesType.SAME;
	private GestureStartEndHandshapesType sameDifStartEndHandshapesL = GestureStartEndHandshapesType.SAME;
	private GestureStartEndHandshapesType sameDifStartEndHandshapesR = GestureStartEndHandshapesType.SAME;
	private GestureStartEndHandshapesType sameDifStartEndHandshapes = GestureStartEndHandshapesType.SAME;
	
	private ArrayList<HandShapeImage> rightHandSelectedHandshapes = new ArrayList<HandShapeImage>();
	private ArrayList<HandShapeImage> leftHandSelectedHandshapes = new ArrayList<HandShapeImage>();
	
	private ArrayList<FingerTipImage> rightHandSelectedFingerTipOrientations = new ArrayList<>();
	private ArrayList<FingerTipImage> leftHandSelectedFingerTipOrientations = new ArrayList<>();

	private ArrayList<PalmImage> rightHandSelectedPalmOrientations = new ArrayList<>();
	private ArrayList<PalmImage> leftHandSelectedPalmOrientations = new ArrayList<>();
	
	private GesturePropertyEntity gesturePropertyEntity = null;
	
//	public int getSameDifHandshapes() {
//		return sameDifHandshapes;
//	}
//	public void setSameDifHandshapes(int sameDifHandshapes) {
//		this.sameDifHandshapes = sameDifHandshapes;
//	}
	public GestureDomNdomHandshapesType getSameDIfferentDomNdomHandshapes() {
		return sameDIfferentDomNdomHandshapes;
	}
	public void setSameDIfferentDomNdomHandshapes(
			GestureDomNdomHandshapesType sameDIfferentDomNdomHandshapes) {
		this.sameDIfferentDomNdomHandshapes = sameDIfferentDomNdomHandshapes;
	}


	public void setSameDifStartEndHandshapes(
			GestureStartEndHandshapesType sameDifStartEndHandshapes) {
		this.sameDifStartEndHandshapes = sameDifStartEndHandshapes;
	}
	
	public GestureStartEndHandshapesType getSameDifStartEndHandshapes() {
		return sameDifStartEndHandshapes;
	}
	
	public GestureStartEndHandshapesType getSameDifStartEndHandshapesL() {
		return sameDifStartEndHandshapesL;
	}
	public void setSameDifStartEndHandshapesL(GestureStartEndHandshapesType sameDifStartEndHandshapesL) {
		this.sameDifStartEndHandshapesL = sameDifStartEndHandshapesL;
	}
	public GestureStartEndHandshapesType getSameDifStartEndHandshapesR() {
		return sameDifStartEndHandshapesR;
	}
	public void setSameDifStartEndHandshapesR(GestureStartEndHandshapesType sameDifStartEndHandshapesR) {
		this.sameDifStartEndHandshapesR = sameDifStartEndHandshapesR;
	}
	public boolean isFingerspelled() {
		return fingerspelled;
	}
	public void setFingerspelled(boolean fingerspelled) {
		this.fingerspelled = fingerspelled;
	}
	public boolean isLoan() {
		return loan;
	}
	public void setLoan(boolean loan) {
		this.loan = loan;
	}
	public boolean isNumber() {
		return number;
	}
	public void setNumber(boolean number) {
		this.number = number;
	}
	public boolean isLexical() {
		return lexical;
	}
	public void setLexical(boolean lexical) {
		this.lexical = lexical;
	}
	public boolean isClassifier() {
		return classifier;
	}
	public void setClassifier(boolean classifier) {
		this.classifier = classifier;
	}
	public boolean isGesture() {
		return gesture;
	}
//	public boolean getGesture() {
//		return gesture;
//	}
	public void setGesture(boolean gesture) {
		this.gesture = gesture;
	}
	public boolean isNameSign() {
		return nameSign;
	}
	public void setNameSign(boolean nameSign) {
		this.nameSign = nameSign;
	}
	public boolean isTwoHanded() {
		return twoHanded;
	}
	public void setTwoHanded(boolean twoHanded) {
		this.twoHanded = twoHanded;
	}
	public boolean isOneFrameGesture() {
		return oneFrameGesture;
	}
	public void setOneFrameGesture(boolean oneFrameGesture) {
		this.oneFrameGesture = oneFrameGesture;
	}
	public boolean isMarkedNumberOfHands() {
		return markedNumberOfHands;
	}
	public void setMarkedNumberOfHands(boolean markedNumberOfHands) {
		this.markedNumberOfHands = markedNumberOfHands;
	}
	public boolean isPassiveBaseArm() {
		return passiveBaseArm;
	}
	public void setPassiveBaseArm(boolean passiveBaseArm) {
		this.passiveBaseArm = passiveBaseArm;
	}
	public ArrayList<HandShapeImage> getRightHandSelectedHandshapes() {
		return rightHandSelectedHandshapes;
	}
	public void setRightHandSelectedHandshapes(
			ArrayList<HandShapeImage> rightHandSelectedHandshapes) {
		this.rightHandSelectedHandshapes.clear();
		this.rightHandSelectedHandshapes.addAll(rightHandSelectedHandshapes);
	}
	public ArrayList<HandShapeImage> getLeftHandSelectedHandshapes() {
		return leftHandSelectedHandshapes;
	}
	public void setLeftHandSelectedHandshapes(
			ArrayList<HandShapeImage> leftHandSelectedHandshapes) {
		this.leftHandSelectedHandshapes.clear();
		this.leftHandSelectedHandshapes.addAll(leftHandSelectedHandshapes);
	}
	public ArrayList<FingerTipImage> getRightHandSelectedFingerTipOrientations() {
		return rightHandSelectedFingerTipOrientations;
	}

	public ArrayList<PalmImage> getRightHandSelectedPalmOrientations() {
		return rightHandSelectedPalmOrientations;
	}

	public void setRightHandSelectedFingerTipOrientations(
			ArrayList<FingerTipImage> rightHandSelectedOrientations) {
		this.rightHandSelectedFingerTipOrientations.clear();
		this.rightHandSelectedFingerTipOrientations.addAll(rightHandSelectedOrientations);
	}
	public ArrayList<FingerTipImage> getLeftHandSelectedFingerTipOrientations() {
		return leftHandSelectedFingerTipOrientations;
	}

	public ArrayList<PalmImage> getLeftHandSelectedPalmOrientations() {
		return leftHandSelectedPalmOrientations;
	}

	public void setLeftHandSelectedFingerTipOrientations(
			ArrayList<FingerTipImage> leftHandSelectedOrientations) {
		this.leftHandSelectedFingerTipOrientations.clear();
		this.leftHandSelectedFingerTipOrientations.addAll(leftHandSelectedOrientations);
	}

	public void setLeftHandSelectedPalmOrientations(
			ArrayList<PalmImage> leftHandSelectedPalmOrientations) {
		this.leftHandSelectedPalmOrientations.clear();
		this.leftHandSelectedPalmOrientations.addAll(leftHandSelectedPalmOrientations);
	}

	public void setRightHandSelectedPalmOrientations(
			ArrayList<PalmImage> rightHandSelectedPalmOrientations) {
		this.rightHandSelectedPalmOrientations.clear();
		this.rightHandSelectedPalmOrientations.addAll(rightHandSelectedPalmOrientations);
	}

	public String getGestText() {
		return gestText;
	}
	public void setGestText(String gestText) {
		this.gestText = gestText;
	}
	public GesturePropertyEntity getGesturePropertyEntity() {
		return gesturePropertyEntity;
	}
	public void setGesturePropertyEntity(GesturePropertyEntity gesturePropertyEntity) {
		this.gesturePropertyEntity = gesturePropertyEntity;
	}
	public void reset() {
		this.gestText = "";
		this.fingerspelled = false;
		this.loan = false;
		this.number = false;
		this.lexical = false;
		this.classifier = false;
		this.gesture = false;
		this.nameSign = false;
		this.twoHanded = false;
		this.oneFrameGesture = false;
		this.markedNumberOfHands = false;
		this.passiveBaseArm = false;
//		this.sameDifHandshapes = 0;
		this.sameDIfferentDomNdomHandshapes = GestureDomNdomHandshapesType.SAME;
		this.sameDifStartEndHandshapesL = GestureStartEndHandshapesType.SAME;
		this.sameDifStartEndHandshapesR = GestureStartEndHandshapesType.SAME;

		rightHandSelectedHandshapes.clear();
		leftHandSelectedHandshapes.clear();
		
		rightHandSelectedFingerTipOrientations.clear();
		leftHandSelectedFingerTipOrientations.clear();

		this.rightHandSelectedPalmOrientations.clear();
		this.leftHandSelectedPalmOrientations.clear();
	}
}
