package edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.GestureHandShapePanel;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.HandShapeFormBean;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.handshapeTypes.StartEndHandshapesType;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.handShapes.HandShapesPaletteFormBean;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.ui.ButtonPanel;

public class GestureDblHandshapePalette extends JPanel implements ActionListener {
	private HandShapesPaletteFormBean rhFormBean = null;
	private HandShapesPaletteFormBean lhFormBean = null;
	private HandShapeFormBean bean = null;
	private GestureGeneralHandshapePalette rPalette = null;
	private GestureGeneralHandshapePalette lPalette = null;
	private JDialog dialog;
    private SS3CodingScheme scheme;
    private GestureHandShapePanel hsPanel;

//	//private JComboBox templatesCb = new JComboBox();
//   private JPanel languagePanel = null;

	private JButton enter = new JButton("Enter");
	private JButton cancel = new JButton("Cancel");

	private final int ENTER = 0;
	private final int CANCEL = 1;

	public GestureDblHandshapePalette(
		HandShapesPaletteFormBean rhFormBean,
		HandShapesPaletteFormBean lhFormBean,
		HandShapeFormBean bean, SS3CodingScheme scheme,
		JDialog dialog, GestureHandShapePanel hsPanel) {

		this.rhFormBean = rhFormBean;
		this.lhFormBean = lhFormBean;
		this.bean = bean;
		this.dialog = dialog;
		this.scheme = scheme;
		this.hsPanel = hsPanel;
		initUI(scheme);

		lPalette.setPalette(0);
		rPalette.setPalette(0);

		enter.setActionCommand("" + ENTER);
		cancel.setActionCommand("" + CANCEL);
		enter.addActionListener(this);
		cancel.addActionListener(this);

		enter.setSelected(true);
	}
   
   private JPanel createLanguageSelectionPanel() {
      
//      if(languagePanel != null)
//         return languagePanel;
      
//		String[] lstr = new String[1];
//		lstr[0] = "American Sign Language";
//		JComboBox l = new JComboBox(lstr);		

		String[] tstr1 = new String[5];
		tstr1[0] = "ASL - All";
		tstr1[1] = "ASL - Letters";
		tstr1[2] = "ASL - Numbers";
		tstr1[3] = "ASL - Unmarked";
	   	tstr1[4] = "Basic Gestures";
		final JComboBox t1 = new JComboBox(tstr1);
		
		t1.setSelectedIndex(rhFormBean.getPaletteID());
		//rPalette.setPalett(1);	
		
		t1.addItemListener(new ItemListener() {
			@Override
			public void itemStateChanged(ItemEvent itemEvent) {
//				invalidate();
				int selectedIndex = t1.getSelectedIndex();
				rPalette.setPalette(selectedIndex);
//				revalidate();
			}
		});

		String[] tstr2 = new String[5];
		tstr2[0] = "ASL - All";
		tstr2[1] = "ASL - Letters";
		tstr2[2] = "ASL - Numbers";
		tstr2[3] = "ASL - Unmarked";
	   	tstr2[4] = "Basic Gestures";
		final JComboBox t2 = new JComboBox(tstr2);
		
		t2.setSelectedIndex(lhFormBean.getPaletteID());
		
		t2.addItemListener(new ItemListener() {
		      @Override
		      public void itemStateChanged(ItemEvent itemEvent) {
//		    	  invalidate();
		    	  int selectedIndex = t2.getSelectedIndex();
		    	  lPalette.setPalette(selectedIndex);
//		    	  revalidate();
		      }
		});

		String[] ostr1 = new String[1];
		ostr1[0] = "Orientations";
		final JComboBox o1 = new JComboBox(ostr1);
		
		o1.setSelectedIndex(0);
		//rPalette.setPalett(1);	
		
		o1.addItemListener(new ItemListener() {
			@Override
			public void itemStateChanged(ItemEvent itemEvent) {
//				invalidate();
				int selectedIndex = o1.getSelectedIndex();
				rPalette.setOrientationFingerTipPalette(selectedIndex);
//				revalidate();
			}
		});

		String[] ostr2 = new String[1];
		ostr2[0] = "Orientations";
		final JComboBox o2 = new JComboBox(ostr2);
		
		o2.setSelectedIndex(0);
		
		o2.addItemListener(new ItemListener() {
		      @Override
		      public void itemStateChanged(ItemEvent itemEvent) {
//		    	  invalidate();
		    	  int selectedIndex = o2.getSelectedIndex();
		    	  lPalette.setOrientationFingerTipPalette(selectedIndex);
//		    	  revalidate();
		      }
		});

      ButtonPanel bp = new ButtonPanel();
//      bp.add(new JLabel("Palettes: "));
//      bp.add(l);
      bp.add(new JLabel(" Right Hand: "));
      bp.add(t1);
      bp.add(new JLabel(" Left Hand: "));
      bp.add(t2);
      
      ButtonPanel bp2 = new ButtonPanel();
      bp2.add(new JLabel(" Right Orientations: " ));
      bp2.add(o1);
      bp2.add(new JLabel(" Left Orientations: " ));
      bp2.add(o2);
      
      JPanel p = null;
      p = new JPanel(new BorderLayout());
      p.add(bp, BorderLayout.NORTH);
      p.add(bp2, BorderLayout.SOUTH);

      return p;
   }

	private void initUI(SS3CodingScheme scheme) {
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		setLayout(gbl);
      
      JPanel languagePanel = createLanguageSelectionPanel();
	  gbc.insets = new Insets(0, 0, 0, 0); // GD 2021-03-08: changed this from Insets(15, 0, 0, 0)
	  gbc.anchor = GridBagConstraints.CENTER;
	  gbc.gridheight = 1;
	  gbc.gridwidth = GridBagConstraints.REMAINDER;
	  gbc.weightx = 1.0;
	  gbc.weighty = 0.0; // Don't use any extra vertical space
	  gbc.fill = GridBagConstraints.HORIZONTAL;
	  add(languagePanel, gbc);
      
       boolean rhSelected = rhFormBean.isRightHandSelected();

	  int all = 0;
      if(!rhSelected)
		all = 3;
       
       rPalette =
			new GestureGeneralHandshapePalette(
				rhFormBean.getValues(),
				rhFormBean.getSelectedHshImages(),
				rhFormBean.getSelectedFingerTipOrientationImages(), rhFormBean.getSelectedPalmOrientationImages(), scheme, all, hsPanel);

		rPalette.setBorder(new TitledBorder(rhFormBean.getTitle()));
		rPalette.setPalette(rhFormBean.getPaletteID());
//		rPalette.setMinimumSize(rPalette.getPreferredSize());

		int unm = 3;
		if(!rhSelected)
			unm = 0;
		
		//
		//System.err.println("rhSelected = " + rhSelected + ", all = " + all + ", unm = " + unm);
		//
		
		lPalette =
			new GestureGeneralHandshapePalette(
				lhFormBean.getValues(),
				lhFormBean.getSelectedHshImages(),
				lhFormBean.getSelectedFingerTipOrientationImages(), lhFormBean.getSelectedPalmOrientationImages(), scheme, unm, hsPanel);

		lPalette.setBorder(new TitledBorder(lhFormBean.getTitle()));
		lPalette.setPalette(lhFormBean.getPaletteID());

		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridwidth = 1;
		gbc.weightx = 1.0; // Use all vertical and horizontal space
		gbc.weighty = 1.0;
		gbc.fill = GridBagConstraints.BOTH;
		add(rPalette, gbc);

		//gbc.anchor = GridBagConstraints.NORTHWEST;
		add(Box.createHorizontalStrut(10));
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		add(lPalette, gbc);

		ButtonPanel buttonPanel = new ButtonPanel();
		buttonPanel.add(cancel);
		buttonPanel.add(enter);

		gbc.anchor = GridBagConstraints.SOUTH;
		gbc.insets = new Insets(15, 0, 0, 0);
		gbc.gridwidth = 7;
		gbc.weightx = 1.0;
		gbc.weighty = 0.0; // Don't use extra vertical space
		gbc.fill = GridBagConstraints.HORIZONTAL;
		add(buttonPanel, gbc);
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();

		switch (Integer.parseInt(str)) {
			case ENTER :
				bean.setUpdated(true);

	            ArrayList<HandShapeImage> rhImages = new ArrayList<>(getRightHandSelectedHandshapes());
	            ArrayList<HandShapeImage> lhImages =  new ArrayList<>(getLeftHandSelectedHandshapes());
	            ArrayList<FingerTipImage> rOImages = new ArrayList<>(getRightHandSelectedFingerTipOrientations());
	            ArrayList<FingerTipImage> lOImages =  new ArrayList<>(getLeftHandSelectedFingerTipOrientations());
				ArrayList<PalmImage> rPOImages = new ArrayList<>(getRightHandSelectedPalmOrientations());
				ArrayList<PalmImage> lPOImages =  new ArrayList<>(getLeftHandSelectedPalmOrientations());
	            
				// first check if this is a one-frame gloss, and if it is then disallow anything more than one handshape in either hand
				if (hsPanel.isOneFrameEntity()) {
					if (rhImages.size() > 1 || lhImages.size() > 1) {
						SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.SELECT_GESTURE_HANDSHAPES_EXACTLY_ONE);
						break;
					}
				} else if ( (hsPanel.getSelectedSameDifStartEndHandshapesDom() == GestureStartEndHandshapesType.DIFFERENT && rhImages.size() == 1)
							|| (hsPanel.getSelectedSameDifStartEndHandshapesNdom() == GestureStartEndHandshapesType.DIFFERENT && lhImages.size() == 1) ) {
					// conversely, if this is not a one-frame gloss and you have dif start/end selected,
					// then disallow a selection of just one handshape in either hand
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.SELECT_GESTURE_HANDSHAPES_MULTIPLE);
					break;
				} else if ((rhImages.size() == 0 && (rOImages.size() > 0 || rPOImages.size() > 0)) || (lhImages.size() == 0 && (lOImages.size() > 0 || lPOImages.size() > 0))) {
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.GESTURE_HANDSHAPES_NOT_SELECTED);
					break;
				} else if ((rhImages.size() != rOImages.size() || rhImages.size() != rPOImages.size()) || (lhImages.size() != lOImages.size() || lhImages.size() != lPOImages.size())) {
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.GESTURE_SELECT_HANDSHAPES_ORIENTATIONS);
					break;
				}
				
//	            // if user only selected none-image for one of above lists - disallow
//	            boolean rightHandNoneImageOnly = this.isHandOrientationNoneOnly(rhImages, rOImages, rPOImages);
//				boolean leftHandNoneImageOnly = this.isHandOrientationNoneOnly(lhImages, lOImages, lPOImages);
//
//
//				if (rightHandNoneImageOnly || leftHandNoneImageOnly) {
//					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.GESTURE_CANNOT_SELECT_ONLY_NONE);
//	            	break;
//	            }

				if (hsPanel.getAssociatedFieldsPanel().isDominantHandRight()) {
					hsPanel.updateParentInfoSelectedEntities(rhImages, lhImages, rOImages, lOImages, rPOImages, lPOImages);
				} else {
					hsPanel.updateParentInfoSelectedEntities(lhImages, rhImages, lOImages, rOImages, rPOImages, lPOImages);
				}

				dialog.dispose();
				break;
			case CANCEL:
				dialog.dispose();
				break;
		}
	}

//	private boolean isHandOrientationNoneOnly(ArrayList<HandShapeImage> rhImages, ArrayList<FingerTipImage> rOImages, ArrayList<PalmImage> rPOImages) {
//		boolean rightHandNoneImageOnly;
//		rightHandNoneImageOnly = (rhImages.size() > 0 && rhImages.stream().allMatch(hs -> hs.getSS3FieldValue().getIid().equalsIgnoreCase(Util.DNI_HANDSHAPE_IMAGE_ID))) &&
//				(rOImages.size() > 0 && rOImages.stream().allMatch(oi -> oi.getSS3FieldValue().getIid().equalsIgnoreCase(Util.DNI_FINGERTIP_IMAGE_ID))) &&
//				(rPOImages.size() > 0 && rPOImages.stream().allMatch(oi -> oi.getSS3FieldValue().getIid().equalsIgnoreCase(Util.DNI_PALM_IMAGE_ID)));
//		return rightHandNoneImageOnly;
//	}

	public ArrayList<HandShapeImage> getRightHandSelectedHandshapes() {
		return rPalette.getSelectedHandshapes();
	}

	public ArrayList<HandShapeImage> getLeftHandSelectedHandshapes() {
		return lPalette.getSelectedHandshapes();
	}
	

	public ArrayList<FingerTipImage> getRightHandSelectedFingerTipOrientations() {
		return rPalette.getSelectedFingerTipOrientations();
	}

	public ArrayList<FingerTipImage> getLeftHandSelectedFingerTipOrientations() {
		return lPalette.getSelectedFingerTipOrientations();
	}

	public ArrayList<PalmImage> getRightHandSelectedPalmOrientations() {
		return rPalette.getSelectedPalmOrientations();
	}

	public ArrayList<PalmImage> getLeftHandSelectedPalmOrientations() {
		return lPalette.getSelectedPalmOrientations();
	}
}