package edu.bu.signstream.grepresentation.fields.glossField;

//import edu.bu.signstream.grepresentation.fields.*;
import java.util.ArrayList;

import edu.bu.signstream.grepresentation.fields.domNdomField.DomNdomHandFieldWrapper;
import edu.bu.signstream.grepresentation.fields.domNdomField.RLDependentFields;
import edu.bu.signstream.grepresentation.fields.handShapeField.HandShapeFieldWrapper;
import edu.bu.signstream.grepresentation.fields.handShapes.fingers.FingersFieldWrapper;
import edu.bu.signstream.grepresentation.fields.handShapes.joints.JointsFieldWrapper;
import edu.bu.signstream.grepresentation.fields.handShapes.spread.SpreadFieldWrapper;
import edu.bu.signstream.grepresentation.fields.lTranslationField.LiteralTranslationWrapper;
import edu.bu.signstream.grepresentation.fields.locationField.LocationFieldWrapper;
import edu.bu.signstream.grepresentation.fields.movementField.MovementFieldWrapper;
import edu.bu.signstream.grepresentation.fields.partOfSpeechField.PartOfSpeechFieldWrapper;

public class GlsDependentFields {

	private PartOfSpeechFieldWrapper pos = null;
	private LiteralTranslationWrapper ltw = null;

	private DomNdomHandFieldWrapper rightHand = null;
	private DomNdomHandFieldWrapper leftHand = null;

	private RLDependentFields rightDep = new RLDependentFields();
	private RLDependentFields leftDep = new RLDependentFields();
	
	public ArrayList getDependentFields() {
		ArrayList fields = new ArrayList();

		if (pos != null)
			fields.add(pos);

		if (ltw != null)
			fields.add(ltw);

		if (rightHand != null)
			fields.add(rightHand);

		if (leftHand != null)
			fields.add(leftHand);

		ArrayList rDepFields = rightDep.getDependentFields();
		fields.addAll(rDepFields);

		ArrayList lDepFields = leftDep.getDependentFields();
		fields.addAll(lDepFields);

		return fields;
	}

	public RLDependentFields getRightDep() {
		return rightDep;
	}

	public RLDependentFields getLeftDep() {
		return leftDep;
	}

	public void setLeftDep(RLDependentFields fields) {
		leftDep = fields;
	}

	public LiteralTranslationWrapper getLiteralTranslationWrapper() {
		//      if (ltw == null)
		//         ltw = new LiteralTranslationWrapper(new LiteraltranslationField());
		return ltw;
	}

	public PartOfSpeechFieldWrapper getPartOfSpeechWrapper() {
		//      if(pos == null)
		//         pos = new PartOfSpeechFieldWrapper(new PartOfSpeechField());
		return pos;
	}

	public DomNdomHandFieldWrapper getRightHandWrapper() {
		//      if (rightHand == null)
		//         rightHand = new DomNdomHandFieldWrapper(new GlossField());
		return rightHand;
	}

	public DomNdomHandFieldWrapper getLeftHandWrapper() {
		//      if (leftHand == null)
		//         leftHand = new DomNdomHandFieldWrapper(new GlossField());
		return leftHand;
	}

	public void setLeftHandWrapper(DomNdomHandFieldWrapper wrapper) {
		leftHand = wrapper;
	}

	public void setLiteralTranslationWrapper(LiteralTranslationWrapper wrapper) {
		ltw = wrapper;
	}

	public void setPartOfSpeechWrapper(PartOfSpeechFieldWrapper wrapper) {
		pos = wrapper;
	}

	public void setRightDep(RLDependentFields fields) {
		rightDep = fields;
	}

	public void setRightHandWrapper(DomNdomHandFieldWrapper wrapper) {
		rightHand = wrapper;
	}

	// right hand
	public HandShapeFieldWrapper getRightHandShapeWrapper() {
		return rightDep.getHandShapeWrapper();
	}

	public void setRighttHandShapeWrapper(HandShapeFieldWrapper wrapper) {
		rightDep.setHandShapeWrapper(wrapper);
	}

	public LocationFieldWrapper getRightLocationWrapper() {
		return rightDep.getLocationWrapper();
	}

	public MovementFieldWrapper getRightMovementWrapper() {
		return rightDep.getMovementWrapper();
	}

	public void setRightLocationWrapper(LocationFieldWrapper wrapper) {
		rightDep.setLocationWrapper(wrapper);
	}

	public void setRightMovementWrapper(MovementFieldWrapper wrapper) {
		rightDep.setMovementWrapper(wrapper);
	}
	// left hand
	public HandShapeFieldWrapper getLeftHandShapeWrapper() {
		return leftDep.getHandShapeWrapper();
	}

	public void setLeftHandShapeWrapper(HandShapeFieldWrapper wrapper) {
		leftDep.setHandShapeWrapper(wrapper);
	}

	public LocationFieldWrapper getLeftLocationWrapper() {
		return leftDep.getLocationWrapper();
	}

	public MovementFieldWrapper getLeftMovementWrapper() {
		return leftDep.getMovementWrapper();
	}

	public void setLeftLocationWrapper(LocationFieldWrapper wrapper) {
		leftDep.setLocationWrapper(wrapper);
	}

	public void setLeftMovementWrapper(MovementFieldWrapper wrapper) {
		leftDep.setMovementWrapper(wrapper);
	}
   
   public void setRightSelectedFingersFieldWrapper(FingersFieldWrapper selectedFingersWrp) {
      rightDep.getHSHDependentFields().setSelectedFingersWrp(selectedFingersWrp);
   }
   
   public void setLeftSelectedFingersFieldWrapper(FingersFieldWrapper selectedFingersWrp) {
      leftDep.getHSHDependentFields().setSelectedFingersWrp(selectedFingersWrp);
   }
   
   public void setRightNonSelectedFingersFieldWrapper(FingersFieldWrapper nonSelectedFingersWrp) {
      rightDep.getHSHDependentFields().setNonSelectedFingersWrp(nonSelectedFingersWrp);
   }
   
   public void setLeftNonSelectedFingersFieldWrapper(FingersFieldWrapper nonSelectedFingersWrp) {
      leftDep.getHSHDependentFields().setNonSelectedFingersWrp(nonSelectedFingersWrp);
   }
   
   public void setRightThumbContactFieldWrapper(SpreadFieldWrapper thumbContactWrp) {
      rightDep.getHSHDependentFields().setThumbContactWrp(thumbContactWrp); 
   }

   public void setLeftThumbContactFieldWrapper(SpreadFieldWrapper thumbContactWrp) {
      leftDep.getHSHDependentFields().setThumbContactWrp(thumbContactWrp); 
   }
   
   public void setRightBaseJointsFieldWrapper(JointsFieldWrapper baseJointsWrp) {
      rightDep.getHSHDependentFields().setBaseJointsWrapper(baseJointsWrp); 
   }
   
   public void setLeftBaseJointsFieldWrapper(JointsFieldWrapper baseJointsWrp) {
      leftDep.getHSHDependentFields().setBaseJointsWrapper(baseJointsWrp); 
   }
   
   public void setRightNonBaseJointsFieldWrapper(JointsFieldWrapper nonBaseJointsWrp) {
      rightDep.getHSHDependentFields().setNonBaseJointsWrapper(nonBaseJointsWrp); 
   }
   
   public void setLeftNonBaseJointsFieldWrapper(JointsFieldWrapper nonBaseJointsWrp) {
      leftDep.getHSHDependentFields().setNonBaseJointsWrapper(nonBaseJointsWrp); 
   }
   
   public void setRightSpreadFieldWrapper(SpreadFieldWrapper spreadWrp) {
      rightDep.getHSHDependentFields().setSpreadWrapper(spreadWrp); 
   }
   
   public void setLefSpreadFieldWrapper(SpreadFieldWrapper spreadWrp) {
      leftDep.getHSHDependentFields().setSpreadWrapper(spreadWrp);
   }

//
  public FingersFieldWrapper getRightSelectedFingersFieldWrapper() {
     return rightDep.getHSHDependentFields().getSelectedFingersWrp();
  }
   
  public FingersFieldWrapper getLeftSelectedFingersFieldWrapper() {
     return leftDep.getHSHDependentFields().getSelectedFingersWrp();
  }
   
  public FingersFieldWrapper getRightNonSelectedFingersFieldWrapper() {
     return rightDep.getHSHDependentFields().getNonSelectedFingersWrp();
  }
   
  public FingersFieldWrapper getLeftNonSelectedFingersFieldWrapper() {
     return leftDep.getHSHDependentFields().getNonSelectedFingersWrp();
  }
   
  public SpreadFieldWrapper getRightThumbContactFieldWrapper() {
     return rightDep.getHSHDependentFields().getThumbContactWrp(); 
  }

  public SpreadFieldWrapper getLeftThumbContactFieldWrapper() {
     return leftDep.getHSHDependentFields().getThumbContactWrp(); 
  }
   
  public JointsFieldWrapper getRightBaseJointsFieldWrapper() {
     return rightDep.getHSHDependentFields().getBaseJointsWrapper(); 
  }
   
  public JointsFieldWrapper getLeftBaseJointsFieldWrapper() {
     return leftDep.getHSHDependentFields().getBaseJointsWrapper(); 
  }
   
  public JointsFieldWrapper getRightNonBaseJointsFieldWrapper() {
     return rightDep.getHSHDependentFields().getNonBaseJointsWrapper(); 
  }
   
  public JointsFieldWrapper  getLeftNonBaseJointsFieldWrapper() {
     return leftDep.getHSHDependentFields().getNonBaseJointsWrapper(); 
  }
   
  public SpreadFieldWrapper getRightSpreadFieldWrapper() {
     return rightDep.getHSHDependentFields().getSpreadWrapper(); 
  }
   
  public SpreadFieldWrapper getLefSpreadFieldWrapper() {
     return leftDep.getHSHDependentFields().getSpreadWrapper();
  }
}
