package edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields;

import java.util.ArrayList;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEntityProperties;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureFieldWrapper;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.FingerTipImage;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.OrientationImage;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.PalmImage;
import edu.bu.signstream.grepresentation.fields.glossField.GlossFieldWrapper;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.nonManualField.GlossEntityProperties;

public class HandShapeFormBean {
	private SS3CodingScheme cs = null;
	private GlossFieldWrapper glsFieldWrapper = null;

	private boolean fingerspelledSelected = false;
	private boolean fingerspelledR = false;

	private boolean oneHandedSelected = false;
	private boolean oneHandedR = false;

	private char type;

	private boolean isRightHandSelected = true;
	private ArrayList<HandShapeImage> slctDomHandShapeImages = new ArrayList<HandShapeImage>();
	private ArrayList<HandShapeImage> slctNdomHandShapeImages = new ArrayList<HandShapeImage>();
	private ArrayList<FingerTipImage> slctDomOrientationFingerTipImages = new ArrayList<>();
	private ArrayList<FingerTipImage> slctNdomOrientationFingerTipImages = new ArrayList<>();
	private ArrayList<PalmImage> slctDomOrientationPalmImages = new ArrayList<>();
	private ArrayList<PalmImage> slctNdomOrientationPalmImages = new ArrayList<>();
	
	private GlossEntityProperties properties;
	private GestureEntityProperties gestureProperties;
	
	public void setGlossEntityProperties(GlossEntityProperties properties) {
		this.properties = properties;
	}
	
	public GlossEntityProperties getGlossEntityProperties() {
		return properties;
	}

	public SS3CodingScheme getSS3CodingScheme() {
		return cs;
	}

	public void setSS3CodingScheme(SS3CodingScheme cs) {
		this.cs = cs;
	}

	private GestureFieldWrapper gestFieldWrapper;

	private boolean updated = false;

	public boolean isRightHandSelected() {
		if (fingerspelledSelected && fingerspelledR) {
			return fingerspelledR;
		} else if (oneHandedSelected && oneHandedR) {
			return oneHandedR;
		}
		return false;
	}

	public void setSelectedDomHandShapeImages(
			ArrayList<HandShapeImage> handShapes) {
		this.slctDomHandShapeImages.clear();
		this.slctDomHandShapeImages.addAll(handShapes);
	}

	public void setSelectedNdomHandShapeImages(
			ArrayList<HandShapeImage> handShapes) {
		this.slctNdomHandShapeImages.clear();
		this.slctNdomHandShapeImages.addAll(handShapes);
	}

	public ArrayList<HandShapeImage> getSelectedDomHandShapeImages() {
		return slctDomHandShapeImages;
	}

	public ArrayList<HandShapeImage> getSelectedNdomHandShapeImages() {
		return slctNdomHandShapeImages;
	}

	public void setSelectedDomOrientationFingerTipImages(
			ArrayList<FingerTipImage> orientations) {
		this.slctDomOrientationFingerTipImages.clear();
		this.slctDomOrientationFingerTipImages.addAll(orientations);
	}

	public void setSelectedNdomOrientationFingerTipImages(
			ArrayList<FingerTipImage> orientations) {
		this.slctNdomOrientationFingerTipImages.clear();
		this.slctNdomOrientationFingerTipImages.addAll(orientations);
	}

	public void setSelectedDomPalmOrientationImages(
			ArrayList<PalmImage> orientations) {
		this.slctDomOrientationPalmImages.clear();
		this.slctDomOrientationPalmImages.addAll(orientations);
	}

	public void setSelectedNdomPalmOrientationImages(
			ArrayList<PalmImage> orientations) {
		this.slctNdomOrientationPalmImages.clear();
		this.slctNdomOrientationPalmImages.addAll(orientations);
	}

	public ArrayList<FingerTipImage> getSelectedDomOrientationFingerTipImages() {
		return slctDomOrientationFingerTipImages;
	}

	public ArrayList<FingerTipImage> getSelectedNdomOrientationFingerTipImages() {
		return slctNdomOrientationFingerTipImages;
	}

	public ArrayList<PalmImage> getSelectedDomOrientationPalmImages() {
		return slctDomOrientationPalmImages;
	}

	public ArrayList<PalmImage> getSelectedNdomOrientationPalmImages() {
		return slctNdomOrientationPalmImages;
	}

	public void setGestureEntityProperties(GestureEntityProperties properties) {
		this.gestureProperties = properties;
	}

	public GestureEntityProperties getGestureEntityProperties() {
		return gestureProperties;
	}

	public void setRightHandSelected(boolean isRightHandSelected) {
		this.isRightHandSelected = isRightHandSelected;
	}

	public void clearNdomHandShapeImages() {
		this.slctNdomHandShapeImages.clear();
	}

	public void clearDomHandShapeImages() {
		this.slctDomHandShapeImages.clear();
	}

	public void clearDomOrientationFingerTipImages() {
		this.slctDomOrientationFingerTipImages.clear();
	}

	public void clearNdomOrientationFingerTipImages() {
		this.slctNdomOrientationFingerTipImages.clear();
	}

	public void clearDomOrientationPalmImages() {
		this.slctDomOrientationPalmImages.clear();
	}

	public void clearNdomOrientationPalmImages() {
		this.slctNdomOrientationPalmImages.clear();
	}

	public void setUpdated(boolean updated) {
		this.updated = updated;
	}


	/**
	 * @param b
	 */
	public void setFingerspelledR(boolean b) {
		fingerspelledR = b;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledSelected(boolean b) {
		fingerspelledSelected = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedR(boolean b) {
		oneHandedR = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedSelected(boolean b) {
		oneHandedSelected = b;
	}

	/**
	 * @param c
	 */
	public void setType(char c) {
		type = c;
	}

	/**
	 * @return
	 */
	public char getType() {
		return type;
	}

	/**
	 * @return
	 */
	public GlossFieldWrapper getGlsFieldWrapper() {
		return glsFieldWrapper;
	}

	/**
	 * @param wrapper
	 */
	public void setGlsFieldWrapper(GlossFieldWrapper wrapper) {
		glsFieldWrapper = wrapper;
	}

	/**
	 * @return
	 */
	public GestureFieldWrapper getGestFieldWrapper() {
		return gestFieldWrapper;
	}

	/**
	 * @param wrapper
	 */
	public void setGestFieldWrapper(GestureFieldWrapper wrapper) {
		gestFieldWrapper = wrapper;
	}
}
