package edu.bu.signstream.grepresentation.fields.nonManualField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.handShapeField.HandShapeEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolbarCommons;

public class LockUnlockGlossPhonAlignmentsListener implements ActionListener {
	
	@Override
	public void actionPerformed(ActionEvent e) {
		GlossChainedEventsEntity selectedEntity  = (GlossChainedEventsEntity)SS3Singleton.getMediaToolBar(null).selectedEntity();
		
		boolean locked = !selectedEntity.isLockedGlossPhonAlignments();
		
		ChainedEventsEntity depHandEntity = selectedEntity.getDependentHandEntity();
		HandShapeEntity depHandShapeEntity = selectedEntity.getDependentHandShapeEntity();
		
		if(locked) {
			Event valueOrTextEvent = selectedEntity.getValueOrTextValueEvent();
			
			Time startTimeInfo = valueOrTextEvent.getStartTimeInfo();
			Time endTimeInfo = valueOrTextEvent.getEndTimeInfo();
			
			Event initialHoldEvent = selectedEntity.getInitialHold();
			startTimeInfo = initialHoldEvent != null 
					? initialHoldEvent.getStartTimeInfo() 
							: valueOrTextEvent.getStartTimeInfo();
			
			Event finalHoldEvent = selectedEntity.getFinalHold();
			endTimeInfo = finalHoldEvent != null 
					? finalHoldEvent.getEndTimeInfo() 
							: valueOrTextEvent.getEndTimeInfo();
					
			if(depHandEntity != null) {
				ChainedEventsEntity prevEntity = depHandEntity.getPreviousEntity();
				ChainedEventsEntity nextEntity = depHandEntity.getNextEntity();

				if( (prevEntity == null || prevEntity.getEndTimeInfo().lessThanOrEq(startTimeInfo) )
						&& (nextEntity == null || nextEntity.getStartTimeInfo().greaterThanOrEq(endTimeInfo) ) ) {
					
					depHandEntity.getValueOrTextValueEvent().setStartTimeInfo(startTimeInfo);
					depHandEntity.getValueOrTextValueEvent().setEndTimeInfo(endTimeInfo);
				
					if(depHandShapeEntity != null) {
						MediaToolbarCommons.setHandshapeStartTime(depHandShapeEntity, startTimeInfo);
						MediaToolbarCommons.setHandshapeEndTime(depHandShapeEntity, endTimeInfo);
					}
					
					depHandEntity.setLockedGlossPhonAlignments(locked);
					
					if(depHandShapeEntity != null) {
						depHandShapeEntity.setLockedGlossPhonAlignments(locked);
					}
					
					SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().repaint();
				} else {
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CANT_LOCK_GLOSSES);
					return;
				}
			}
			
			selectedEntity.setLockedGlossPhonAlignments(locked);
			
		} else {
			selectedEntity.setLockedGlossPhonAlignments(locked);
			if(depHandEntity != null) {
				depHandEntity.setLockedGlossPhonAlignments(locked);
			}
			if(depHandShapeEntity != null) {
				depHandShapeEntity.setLockedGlossPhonAlignments(locked);
			}
			SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().repaint();
		}
	}
}
