package edu.bu.signstream.grepresentation.fields.palettes.helpers.interfaces;

import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.FingerTipImage;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.GenericStartEndHandShapeTypes;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.PalmImage;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.handshapeTypes.StartEndHandshapesType;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;

import java.util.ArrayList;

/**
 * This interface is used to get information about the parent of the palette panel. In other words, this interface is used
 * to get information about Morph-phon or Gesture Info panel that the palette may need. This interface exists as a way to generify
 * the Morph-phon and Gesture Info panels so that a single type can be used for both palettes and potentially others in the future.
 */
public interface ParentPaletteInformationHelper<T extends Enum<?> & GenericStartEndHandShapeTypes> {
    public boolean isDominantHandRight();

    public boolean isDomHandSelected();
    public boolean isNondomHandSelected();

    public boolean isOneFrameEntity();

    public T getSelectedSameDifStartEndHandshapes();

    // TODO: Hasanin, does Gestures need this too?
    public T getSelectedSameDifStartEndHandshapesDom();
    public T getSelectedSameDifStartEndHandshapesNdom();
}
