package edu.bu.signstream.grepresentation.fields.presentation;

import javax.swing.*;
import java.awt.*;
import edu.bu.signstream.common.util.*;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.*;

public class CreateNewEntityPanel extends JPanel {
	private JTextField excerptTxt = new JTextField(25);

	private JComboBox participantCb = new JComboBox();
	private JComboBox coderCb = new JComboBox();
	private JList fields = new JList();

	public CreateNewEntityPanel(SS3CodingScheme cs) {
		initUI(cs);
	}

	private void initUI(SS3CodingScheme cs) {
		participantCb.addItem("Peter");
		participantCb.addItem("Alex");

		coderCb.addItem("Peter");
		coderCb.addItem("Peter");
		
		JLabel title = new JLabel(" Create New Statement ");
		title.setFont(UserInterfaceUtil.getDialogTitleFont());
		title.setForeground(UserInterfaceUtil.getDialogTitleColor());

		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();

		setLayout(gbl);

		gbc.anchor = GridBagConstraints.NORTHWEST;
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		add(title, gbc);

		gbc.anchor = GridBagConstraints.NORTH;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0, 0, 10, 0);
		add(new JSeparator(), gbc);

		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridwidth = 1;
		gbc.insets = new Insets(0, 0, 0, 0);
		add(new JLabel("Excerpt:"), gbc);

		add(Box.createHorizontalStrut(10));
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		add(excerptTxt, gbc);

		gbc.gridwidth = 1;
		add(new JLabel("Coder:"), gbc);

		add(Box.createHorizontalStrut(10));
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		add(coderCb, gbc);

		gbc.gridwidth = 1;
		add(new JLabel("Participant:"), gbc);

		add(Box.createHorizontalStrut(10));
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		add(participantCb, gbc);
	}

	public String getLabel() {
		return null;
	}
}
