package edu.bu.signstream.grepresentation.fields.signTypeField;

import edu.bu.signstream.grepresentation.fields.gestureField.GestureEntityProperties;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.GlossEntityProperties;

public enum SignType {
    FINGERSPELLED("fs"),
    LOAN("loan"),
    LEXICAL("lex"),
    CLASSIFIER("cl"),
    GESTURE("ges"),
    NUMBER("num"),
    NONE;

    private String label;

    SignType() {}

    SignType(String label) {
        this.label = label;
    }

    public String getLabel() {
        return label;
    }

    public static SignType getSignTypeFromGloss(GlossChainedEventsEntity entity) {
        GlossEntityProperties properties = entity.getGlossEntityProperties();
        if (properties.isFingerspelled()) {
            return FINGERSPELLED;
        } else if (properties.isLoan()) {
            return LOAN;
        } else if (properties.isLexical()) {
            return LEXICAL;
        } else if (properties.isClassifier()) {
            return CLASSIFIER;
        } else if (properties.isGesture()) {
            return GESTURE;
        } else if (properties.isNumber()) {
            return NUMBER;
        }
        return NONE;
    }

	public static SignType getSignTypeFromGesture(GestureEventsEntity gloss) {
		GestureEntityProperties properties = gloss.getGestureEntityProperties();
        if (properties.isFingerspelled()) {
            return FINGERSPELLED;
        } else if (properties.isLoan()) {
            return LOAN;
        } else if (properties.isLexical()) {
            return LEXICAL;
        } else if (properties.isClassifier()) {
            return CLASSIFIER;
        } else if (properties.isGesture()) {
            return GESTURE;
        } else if (properties.isNumber()) {
            return NUMBER;
        }
        return NONE;
	}

}
