package edu.bu.signstream.grepresentation.listener;

import edu.bu.signstream.ui.SS3SignStreamApplication;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.ref.WeakReference;
import java.lang.reflect.Method;
import java.util.logging.Level;

public class WeakActionListener implements ActionListener {  
	  
    private WeakReference<ActionListener> weakListenerReference;  
    private Object source;  
  
  
    public WeakActionListener(ActionListener listener, Object source) {  
        this.weakListenerReference = new WeakReference<>(listener);
        this.source = source;  
    }  
  
    public void actionPerformed(ActionEvent actionEvent) {  
        ActionListener actionListener = this.weakListenerReference.get();
        if(actionListener == null) {  
            this.removeListener();  
        } else {  
            actionListener.actionPerformed(actionEvent);  
        }  
    }  
  
    private void removeListener() {  
        try {  
            Method method = source.getClass().getMethod("removeActionListener", new Class[] {ActionListener.class});  
            method.invoke(source, new Object[] {this});  
        } catch(Exception ex) {  
            ex.printStackTrace();
            SS3SignStreamApplication.logger.log(Level.SEVERE, "Exception", ex);
        }  
    }  
}  