package edu.bu.signstream.grepresentation.view;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import edu.bu.signstream.common.util.vo.ss3.db.SS3GlossWindowItemNote;
import edu.bu.signstream.ui.ButtonPanel;

public class NotesPanel extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;
	private JButton cancelBtn = new JButton("Cancel");
	private JButton saveBtn = new JButton("Save");
	private JTextArea noteTxt = new JTextArea();
	
	private JScrollPane scrollPane = null;
	
	private SS3GlossWindowItemNote note = null;
	private JDialog dialog = null;
	
	private final int CANCEL = 0;
	private final int SAVE  = 1;
	
	public NotesPanel(SS3GlossWindowItemNote note, JDialog dialog) {
		this.note = note;
		this.dialog = dialog;
		if(this.note == null) {
			note = new SS3GlossWindowItemNote();
		}
		
		this.setPreferredSize(new Dimension(350, 300));
		
		Dimension preferredSize = cancelBtn.getPreferredSize();
		saveBtn.setPreferredSize(preferredSize);
		noteTxt.setText(note.getNote());

		ButtonPanel buttonPanel = new ButtonPanel();
		buttonPanel.add(cancelBtn);
		buttonPanel.add(saveBtn);
		
		scrollPane = new JScrollPane(noteTxt);
		scrollPane.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
		
		this.setLayout(new BorderLayout());
		this.add(scrollPane, BorderLayout.CENTER);
		this.add(buttonPanel, BorderLayout.SOUTH);
		
		cancelBtn.setActionCommand("" + CANCEL);
		cancelBtn.addActionListener(this);
		saveBtn.setActionCommand("" + SAVE);
		saveBtn.addActionListener(this);
	}	
	
	public void save() {
		note.setNote(noteTxt.getText());
		dialog.setVisible(false);
	}
	
	public void discard() {
		cancelBtn.removeActionListener(this);
		saveBtn.removeActionListener(this);
	}
	
	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();

		switch (Integer.parseInt(str)) {
			case SAVE:
				save();
			break;
			case CANCEL:
				noteTxt.setText(note.getNote());
				dialog.setVisible(false);
			break;
		}	
	}
}
