package edu.bu.signstream.media.fileNavigation;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.border.Border;
import javax.swing.table.TableCellRenderer;
import java.io.File;
import java.awt.Component;

public class FileRenderer extends JLabel implements TableCellRenderer {
	Border unselectedBorder = null;

	Border selectedBorder = null;

	boolean isBordered = true;

	public FileRenderer(boolean isBordered) {
		this.isBordered = isBordered;
	}

	@Override
	public Component getTableCellRendererComponent(JTable table, Object file,
			boolean isSelected, boolean hasFocus, int row, int column) {
		File newFile = (File) file;

		setText(newFile.getName()); 
		if (isBordered) {
			if (isSelected) {
				if (selectedBorder == null) {
					selectedBorder = BorderFactory.createMatteBorder(2, 5, 2,
							5, table.getSelectionBackground());
				}
				setBorder(selectedBorder);
			} else {
				if (unselectedBorder == null) {
					unselectedBorder = BorderFactory.createMatteBorder(2, 5, 2,
							5, table.getBackground());
				}
				setBorder(unselectedBorder);
			}
		}

		if (newFile.exists()) {
			setToolTipText(newFile.getPath());
		} else {
			String tooltipText = "Movie file " + newFile.getName()
					+ " not found. \n Ctrl + dbl click to relocate.";
			setToolTipText(tooltipText);
		}
		return this;
	}
}
