package edu.bu.signstream.media.fileNavigation;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.*;

import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class MediaDialog extends JDialog {

   public MediaDialog(
      JDialog parentDialog,
      SignStreamSegmentPanel segmentPanel) {
      super(parentDialog, "Media Dialog");
      init(segmentPanel);
   }

   public MediaDialog(
      JFrame parentFrame,
      SignStreamSegmentPanel segmentPanel) {
      super(parentFrame, "Media Dialog");      
      init(segmentPanel);
   }

   private void init(SignStreamSegmentPanel segmentPanel) {
      addWindowListener(new WindowAdapter() {
         @Override
		public void windowClosing(WindowEvent e) {
            dispose();
         }
      });

      MediaPropertiesPanel mPanel =
         new MediaPropertiesPanel(segmentPanel, this);
      Dimension d = mPanel.getPreferredSize();
      Dimension nD = new Dimension(d.width + 40, d.height + 10);
      mPanel.setPreferredSize(nD);

      Container contentPane = getContentPane();
      contentPane.setLayout(new BorderLayout(50, 50));
      contentPane.add(mPanel, BorderLayout.CENTER);

      this.pack();
   }
}
