package edu.bu.signstream.media.ui.icon;

import javax.swing.*;
import java.awt.*;
import java.util.function.Consumer;

public abstract class ToggleIconLight implements Icon {
    private final boolean enabled;

    protected ToggleIconLight(boolean enabled) {
        this.enabled = enabled;
    }

    protected void paint(Graphics g, Consumer<Graphics2D> fn) {
        var g2d = (Graphics2D)g;

        g2d.setPaint(enabled
            ? new GradientPaint(0, 0, Color.BLACK, 15, 15, Color.DARK_GRAY)
            : new GradientPaint(0, 0, Color.GRAY, 15, 15, Color.LIGHT_GRAY));

        fn.accept(g2d);
    }

    @Override
    public int getIconWidth() {
        return 22;
    }

    @Override
    public int getIconHeight() {
        return 21;
    }
}
