package edu.bu.signstream.ui.panels;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;

import edu.bu.signstream.ui.ButtonPanel;

public class EditParticipantPanel extends JPanel {	
  
  JSeparator sep = new JSeparator();
  JLabel title   = new JLabel("Edit Participant");
  
  JTextField prtFld    = new JTextField(25);
  JTextField labelFld = new JTextField(25);
  JTextField nameFld    = new JTextField(25);
  JTextArea parentArea = new JTextArea();
  JTextArea bckgrArea = new JTextArea();
  JTextArea cmmntArea = new JTextArea();
  JTextField ageFld   = new JTextField(2);
  
  Dimension areaSize = new Dimension(100, 80);

  JComboBox genderCb = new JComboBox();
  JComboBox langCb = new JComboBox();
  
  JButton saveBtn = new JButton("Save");
  JButton cncBtn   = new JButton("Cancel");
  JButton dltBtn   = new JButton("Delete");
	

  public EditParticipantPanel() { 	
	parentArea.setPreferredSize(areaSize);
	bckgrArea.setPreferredSize(areaSize);
	cmmntArea.setPreferredSize(areaSize);
	
	GridBagLayout      gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();

	setLayout(gbl);

	genderCb.addItem("Male");
	genderCb.addItem("Female");
	
	langCb.addItem("ASL");
	langCb.addItem("English");

	title.setFont(new Font("Times-Roman", Font.BOLD + Font.ITALIC, 16));

	gbc.anchor    = GridBagConstraints.NORTHWEST;
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	add(title, gbc);

	gbc.anchor    = GridBagConstraints.NORTH;
	gbc.fill      = GridBagConstraints.HORIZONTAL;
	gbc.insets    = new Insets(0,0,10,0);
	add(sep, gbc);

	gbc.anchor    = GridBagConstraints.WEST;
	gbc.gridwidth = 1;
	gbc.insets    = new Insets(0,0,0,0);
	add(new JLabel("Participant:"), gbc);

	add(Box.createHorizontalStrut(10));
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	add(prtFld, gbc);

	gbc.gridwidth = 1;
	add(new JLabel("Label:"), gbc);

	add(Box.createHorizontalStrut(10));
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	add(labelFld, gbc);
	
	gbc.gridwidth = 1;
	add(new JLabel("Full Name:"), gbc);

	add(Box.createHorizontalStrut(10));
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	add(nameFld, gbc);
	
	gbc.gridwidth = 1;
	add(new JLabel("Language:"), gbc);
    
    JPanel panel = new JPanel();
    panel.setLayout(new FlowLayout());
    panel.add(langCb);
    panel.add(new JLabel("Gender: "));
    panel.add(genderCb);
    panel.add(new JLabel("Age: "));
    panel.add(ageFld);
    
	add(Box.createHorizontalStrut(10));
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	add(panel, gbc);
	
	gbc.gridwidth = 1;
	add(new JLabel("Parent Info:"), gbc);

    JTextArea ta1 = new JTextArea("text will go here.");	  
	ta1.setPreferredSize(new Dimension(100, 80));
	JScrollPane sp = new JScrollPane(ta1, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	sp.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);

	add(Box.createHorizontalStrut(10));
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	add(sp, gbc);

    gbc.gridwidth = 1;
	add(new JLabel("Background:"), gbc);

	  JTextArea ta2 = new JTextArea("background will go here.");	  
	  ta2.setPreferredSize(new Dimension(100, 80));
	  JScrollPane sp1 = new JScrollPane(ta2, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	  sp1.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);

	  add(Box.createHorizontalStrut(10));
	  gbc.gridwidth = GridBagConstraints.REMAINDER;
	  add(sp1, gbc);

	  gbc.gridwidth = 1;
		add(new JLabel("Comments:"), gbc);

		JTextArea ta3 = new JTextArea("comments will go here.");	  
		ta3.setPreferredSize(new Dimension(100, 80));
		JScrollPane sp2 = new JScrollPane(ta3, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		sp2.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);

		add(Box.createHorizontalStrut(10));
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		add(sp2, gbc);

	gbc.gridwidth = 1;
	add(Box.createHorizontalStrut(5));	

	gbc.insets = new Insets(5,0,5,0);
	
	ButtonPanel buttonPanel = new ButtonPanel();
	buttonPanel.add(saveBtn);
	buttonPanel.add(cncBtn);
	buttonPanel.add(dltBtn);

	gbc.anchor    = GridBagConstraints.SOUTH;
	gbc.insets    = new Insets(15,0,0,0);
	gbc.fill      = GridBagConstraints.HORIZONTAL;
	gbc.gridwidth = 7;
	add(buttonPanel, gbc);
  }
}

