package edu.bu.signstream.ui.panels;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JDialog;

import edu.bu.signstream.common.util.vo.ss3.participants.SS3Participant;
import edu.bu.signstream.ui.panels.newDatabase.ParticipantView;

public class ParticipantDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private ParticipantPanel participantPanel = null;
	
	public ParticipantDialog(JDialog parent, SS3Participant participant, ParticipantView view, AnnotatorsPanel annotatorPanel) {		
		super(parent, "Create or Edit Participant", true);

		participantPanel = new ParticipantPanel(participant, view, annotatorPanel, this);
		
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				if (participantPanel.isEdited()) {
					participantPanel.showCancelEntryDialog();
				} else {
					setVisible(false);
				}
			}
		});

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout()); //30, 10));
		contentPane.add(participantPanel, BorderLayout.CENTER);
		this.pack();
	}

}
