package edu.bu.signstream.ui.panels.search;

import java.util.ArrayList;

import edu.bu.signstream.common.util.vo.ss3.db.SS3Database;
import edu.bu.signstream.grepresentation.fields.Segment;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.time.Time;

public class SearchSavedState {
	
	SS3Database database;
	ArrayList<String> segmentsList;
	Time visibleOnsetTime;
	double sliderPosition;
	double zoomerValue;
	int selectedSegmentTemplateIndex;
	String selectedUtteranceId;

	private final String selectedUtterance;
	private final String temporalPartitionLabel;
	private final String segmentLabel;

	public SearchSavedState(SS3Database database, ArrayList<String> segmentsList, Time visibleOnsetTime, double sliderPosition, double zoomerValue, int selectedSegmentTemplateIndex, String selectedUtteranceId, String selectedUtteranceString, String segmentLabel, String temporalPartitionLabel) {
		this.database = database;
		this.segmentsList = segmentsList;
		this.visibleOnsetTime = visibleOnsetTime;
		this.sliderPosition = sliderPosition;
		this.zoomerValue = zoomerValue;
		this.selectedSegmentTemplateIndex = selectedSegmentTemplateIndex;
		this.selectedUtteranceId = selectedUtteranceId;
		this.selectedUtterance = selectedUtteranceString;
		this.temporalPartitionLabel = temporalPartitionLabel;
		this.segmentLabel = segmentLabel;
	}
	
	public SS3Database getDatabase() {
		return this.database;
	}
	
	public ArrayList<String> getSegmentsList() {
		return this.segmentsList;
	}
	
	public Time getVisibleOnsetTime() {
		return this.visibleOnsetTime;
	}
	
	public double getSliderPosition() {
		return this.sliderPosition;
	}
	
	public double getZoomerValue() {
		return this.zoomerValue;
	}

	public String getSelectedUtteranceId() {
		return this.selectedUtteranceId;
	}
	
	public int getSelectedSegmentTemplateIndex() {
		return this.selectedSegmentTemplateIndex;
	}

	public String getSelectedUtterance() {
		return this.selectedUtterance;
	}
	
	public String getTemporalPartitionLabel() {
		return this.temporalPartitionLabel;
	}

	public String getSegmentLabel() {
		return this.segmentLabel;
	}
}
