package edu.bu.signstream.ui.video.controlPanelIcons;

import java.awt.Color;
import java.awt.GradientPaint;

import javax.swing.Icon;

public abstract class VideoControlPanelIcon implements Icon {
	
	private boolean enabled = true;
	private int width = 0;
	private int height = 0;
		
	public VideoControlPanelIcon(boolean enabled, int width, int height) {
		this.enabled = enabled;
		this.width = width; 
		this.height = height;
	}

	public GradientPaint getGradientPaint() {
		if(enabled) {			
			return new GradientPaint(0, 0, Color.white, 15, 15, Color.gray);
		} else {
			return new GradientPaint(0, 0, Color.gray, 15, 15, Color.DARK_GRAY);
		}
	}
	
	public Color getBackground() {
		return Color.black;
	}

	
	@Override
	public int getIconWidth() {
		return width;
	}

	@Override
	public int getIconHeight() {
		 return height;
	}
	
	public boolean isEnabled() {
		return enabled;
	}	
}
